;------Reindeer Rescue
;
;--Bob Montgomery 2005
;

;	Dennis mod:

;TIA_BASE_READ_ADDRESS	=	$30

    processor 6502
    include vcs.h
    include macro.h

;---Constants Below

NTSC            =       1
PAL             =       0
TV_MODE         =       NTSC
TESTVERSION		=	0

STARTINGLEVEL   =   0   ;switch this around for testing purposes
PLAYAREAHEIGHT  =   110

	;--end of level bonuses

EXTRALIFE_BONUS		=	$01	;in thousands



INITIALEXTRALIVES   =   2

P0HEIGHT    =   23  ;height of player0 in scanlines...constant.
SKYITEMHEIGHT   =   8
SKYITEMFRAMELENGTH  =   SKYITEMHEIGHT+1
SKYITEMINITYOFFSET  =   SKYITEMFRAMELENGTH*4
SKYITEMACTIONOFFSET =   SKYITEMINITYOFFSET+1
BAND0HEIGHT =   5   ;height of bands in scanlines
BAND1HEIGHT =   10
BAND2HEIGHT =   12
BAND3HEIGHT =   4
BAND4HEIGHT =   4
BAND5HEIGHT =   4
BAND6HEIGHT =   12
BAND7HEIGHT =   10
NONTRIVIALPRESETS   =   90  ;number of non-trivial presets.

INITJUMPINDEX   =   31
INITRAMPINDEX   =   47
INITFALLINDEX   =   7
FREEFALLSPEED   =   2

HITPFFORCEDACTION   =   $82

BETWEENLEVELSDELAY  =   20
BEGINFALLINDEX      =   5

ANIMATIONDELAY  =   $30
MAXANIMATIONFRAMES  =   9   ;for prot (0-4)
MAXSKYITEMANIMATIONFRAMES   =   %01100000   ;for skyitem
NUMBEROFBANDS   =   8   ;number of horizontal, scrolling bands
HSOHARDLEFT =   18  ;positioning constants for HighSkyObject
HSOMIDLEFT  =   58
HSOMIDRIGHT =   110
HSOHARDRIGHT    =   150
HSOCENTER   =   76
LEVELDATALENGTH =   17  ;number of bytes of level data per level.
MIDSKYOBJECTHEIGHT  =   22;
HIGHSKYOBJECTHEIGHT =   9;
LOWSKYOBJECTHEIGHT  =   9;
MSOY    =   18      ;relative vert position of MidSkyObject - constant
HSOY    =   22      ;relative vert position of HighSkyObject - constant
LSOY    =   9       ;relative vert position of LowSkyObject - constant
INITIALPROTHEIGHT   =   109 ;initial Y-position of protagonist.
INITIALPROTX    =   40  ;initial x-position of protagonist.
SUBTIMERMAX =   60  ;50 for PAL


POLARBEARTALL       =   0
NORTHPOLE           =   1
IMPERIALWALKER      =   2
OLDTRAINTALL        =   3
HELICOPTER          =   4
WATERTOWER          =   5
BLIMP               =   6
NEWTRAINTALL        =   7
SATELLITEDISH       =   8
CELLTOWER           =   9
ATARITRUCKTALL      =   10
ASNOWMAN            =   11
ATARIFLAG           =   12
AIRPLANE            =   13
USFLAG              =   14
SNOWMAN             =   15
DOGSLEDTALL         =   16
SCHOOLBUSTALL       =   17
TANKERTALL          =   18
MONSTERTRUCKTALL    =   19
PICKUPTALL          =   20
MINIVAN             =   21

POLARBEARSHORT      =   0
OLDTRAINSHORT       =   1
SPEEDER             =   2
CAR                 =   3
NEWTRAINSHORT       =   4
ATARITRUCKSHORT     =   5
SNOWMOBILE          =   6
SKIER               =   7
SUPERMAN            =   8
BLANK               =   9
DOGSLEDSHORT        =   10
SCHOOLBUSSHORT      =   11
TANKERSHORT         =   12
MONSTERTRUCKSHORT   =   13
PICKUPSHORT         =   14
MINIVANCAR          =   15

DIGITHEIGHT         =   8

KERNELTYPE_BITS     =   %11000000

TITLESCREEN         =   %00000000
GAMEOVERSCREEN      =   %01000000
FINALSCREEN         =   %10000000
GAMEKERNEL          =   %11000000

SCROLLPF_BIT        =   %00000001
PLAYERCONTROL_BIT   =   %00000010
ANIMATESANTA_BIT    =   %00000100
ANIMATEOTHER_BIT    =   %00001000
MOVESANTA_BIT       =   %00010000
BETWEENLEVELS_BIT   =   %00100000

TITLESCREENTEMPO    =   TEMPO225
GAMEOVERTEMPO       =   TEMPO75
FINALSCREENTEMPO    =   TEMPO225

  IF TV_MODE = NTSC
VBLANKTIME          =   47
KERNELTIME          =   237
OVERSCANTIME        =   32
  ELSE
VBLANKTIME          =   62
KERNELTIME          =   246
OVERSCANTIME        =   44
  ENDIF

	IF TV_MODE = NTSC
LEVEL0BACKGROUNDCOLOR	=	BLUE2+10
LEVEL1BACKGROUNDCOLOR	=	BLUE2+8
LEVEL2BACKGROUNDCOLOR	=	GRAY+4
LEVEL3BACKGROUNDCOLOR	=	GRAY+2
	ELSE
LEVEL0BACKGROUNDCOLOR	=	BLUE2+8
LEVEL1BACKGROUNDCOLOR	=	BLUE2+6
LEVEL2BACKGROUNDCOLOR	=	GRAY+6
LEVEL3BACKGROUNDCOLOR	=	GRAY+4
	ENDIF
;-------------------------COLOR CONSTANTS (NTSC)--------------------------

 IF TV_MODE = NTSC
GRAY          =       $00
GOLD          =       $10
ORANGE        =       $20
BURNTORANGE   =       $30
RED           =       $40
;PURPLE        =       $50     ; unused
;PURPLEBLUE    =       $60     ; unused
;BLUE          =       $70     ; unused
BLUE2         =       $80
LIGHTBLUE     =       $90     ; unused - whoops!  It turns out I need to use it afterall!
TURQUOISE     =       $A0
GREEN         =       $B0
BROWNGREEN    =       $C0
TANGREEN      =       $D0
;TAN           =       $E0     ; unused
BROWN         =       $F0
;-------------------------COLOR CONSTANTS (PAL)--------------------------
 ELSE
GRAY          =       $00
GOLD          =       $20     ; + BELLCOLOR, EnergyColor07
ORANGE        =       $40     ; + REINDEERCOLOR
BURNTORANGE   =       $40     ; + FACECOLOR (TODO EnergyColor11: -2)
RED           =       $60     ;
BLUE2         =       $d0     ; + PF background blue, FinalScreenKernel
TURQUOISE     =       $90
GREEN         =       $50
BROWNGREEN    =       $50-2   ; + ELFCOLOR, ORNAMENTCOLOR, TitleColorData
TANGREEN      =       $30     ; + METHANECOLOR
BROWN         =       $20-2   ; + COOKIESCOLOR
LIGHTBLUE	=	$B0
 ENDIF

;LOGOCOLOR       =       BURNTORANGE+4 unused
TIMERCOLOR      =   GRAY+14
SCORECOLOR      =   GRAY+14

EVILBIRDCOLOR   =   GRAY+0
BIRDCOLOR       =   GRAY+0

REINDEERCOLOR   =   ORANGE+2
METHANECOLOR    =   TANGREEN+10
SNOWFLURRYCOLOR =   GRAY+14
LIGHTNINGCOLOR  =   TURQUOISE+14
FLYINGHATCOLOR  =   RED+4
SNOWSPEEDERCOLOR    =   GRAY+14
LISTCOLOR       =   GRAY+14
TORNADOCOLOR    =   GRAY+14
ELFCOLOR        =   BROWNGREEN+2
SNOWFLAKECOLOR  =   GRAY+14

COOKIESCOLOR    =   BROWN+6
LEFTARROWCOLOR  =   GRAY+0
RIGHTARROWCOLOR =   GRAY+0
SPRINGCOLOR     =   GRAY+8
SNOWMANCOLOR    =   GRAY+14
GIFTCOLOR       =   RED+4
TOYSACKCOLOR    =   GRAY+10
ORNAMENTCOLOR   =   BROWNGREEN+2
CANDYCANECOLOR  =   RED+4
COALCOLOR       =   GRAY+0
BOWCOLOR        =   RED+4
 IF TV_MODE = NTSC
LIGHTSTRINGCOLOR	=	BROWNGREEN+2
COCOACOLOR      =   BROWN+2
 ELSE
COCOACOLOR      =   ORANGE
LIGHTSTRINGCOLOR	=	BROWNGREEN+4
 ENDIF
MILKCOLOR       =   GRAY+14
BELLCOLOR       =   GOLD+12

;--------------------------TIA CONSTANTS----------------------------------

    ;--NUSIZx CONSTANTS
    ;   player:
ONECOPYNORMAL       =   $00
TWOCOPIESCLOSE      =   $01
TWOCOPIESMED        =   $02
THREECOPIESCLOSE    =   $03
TWOCOPIESWIDE       =   $04
ONECOPYDOUBLE       =   $05
THREECOPIESMED      =   $06
ONECOPYQUAD     =   $07
    ;   missile:
SINGLEWIDTHMISSILE  =   $00
DOUBLEWIDTHMISSILE  =   $10
QUADWIDTHMISSILE    =   $20
OCTWIDTHMISSILE     =   $30

    ;---CTRLPF CONSTANTS
    ;   playfield:
REFLECTEDPF     =   %00000001
SCOREPF         =   %00000010
PRIORITYPF      =   %00000100
    ;   ball:
SINGLEWIDTHBALL     =   SINGLEWIDTHMISSILE
DOUBLEWIDTHBALL     =   DOUBLEWIDTHMISSILE
QUADWIDTHBALL       =   QUADWIDTHMISSILE
OCTWIDTHBALL        =   OCTWIDTHMISSILE

    ;---HMxx CONSTANTS
LEFTSEVEN       =   $70
LEFTSIX         =   $60
LEFTFIVE        =   $50
LEFTFOUR        =   $40
LEFTTHREE       =   $30
LEFTTWO         =   $20
LEFTONE         =   $10
NOMOVEMENT      =   $00
RIGHTONE        =   $F0
RIGHTTWO        =   $E0
RIGHTTHREE      =   $D0
RIGHTFOUR       =   $C0
RIGHTFIVE       =   $B0
RIGHTSIX        =   $A0
RIGHTSEVEN      =   $90
RIGHTEIGHT      =   $80

    ;---AUDCx CONSTANTS (P Slocum's naming convention)
SAWSOUND        =   1
ENGINESOUND     =   3
SQUARESOUND     =   4
BASSSOUND       =   6
PITFALLSOUND    =   7
NOISESOUND      =   8
LEADSOUND       =   12
BUZZSOUND       =   15

    ;---SWCHA CONSTANTS (JOYSTICK)
J0RIGHT     =   %10000000
J0LEFT      =   %01000000
J0DOWN      =   %00100000
J0UP        =   %00010000
J1RIGHT     =   %00001000
J1LEFT      =   %00000100
J1DOWN      =   %00000010
J1UP        =   %00000001

    ;---SWCHB CONSTANTS (CONSOLE SWITCHES)
P1DIFF      =   %10000000
P0DIFF      =   %01000000
BWCOLOR     =   %00001000
SELECT      =   %00000010
RESET           =   %00000001

;-------------------------End Constants-----------------------------------

RUNSOUND    =   NOISESOUND
RUNFREQ     =   16


    ;--colors for the protagonist.

BOOTCOLOR   =   GRAY+0
SUITCOLOR   =   RED+4
BELTCOLOR   =   GRAY+14
BEARDCOLOR  =   GRAY+14
FACECOLOR   =   BURNTORANGE+12
HAIRCOLOR   =   GRAY+14
HATCOLOR    =   RED+4

;---END COLOR CONSTANTS

;--Scroll Speed Constants

FASTSCROLL  =   %00000000
MEDFASTSCROLL   =   %00000101
MEDSLOWSCROLL   =   %00001010
SLOWSCROLL  =   %00001111

;--End Scroll Speed Constants


GRAVITY =   %00000010   ;gravity constant. effective value is actual value * two
INITJUMPVEL =   106 ;initial jump velocity divided by two.  Max=127
INITRAMPVEL =   127+128 ;initial upward velocity off the ramp/spring, divided by two.  Max=127
                ;'+128' is cuz jump flag (bit 7) is also set in this constant
JUMPBOOST   =   4   ;initial boost off of ramp/spring - in pixels

;----Item identifier constants

    ;--sky items

EVILBIRD        =   $10
REINDEER1       =   $20
SNOWFLURRY      =   $30
METHANE         =   $40
REINDEER2       =   $50
REINDEER3       =   $60
LIGHTNING       =   $70
FLYINGHAT       =   $80
SNOWSPEEDER     =   $90
LIST            =   $A0
TORNADO     =   $B0
ELF         =   $C0
SNOWFLAKE       =   $D0
SLEIGH1     =   $E0
SLEIGH2     =   $F0
    ;SKY ITEM action constants

SI_DOWN1    =   %00001000
SI_DOWN2    =   %00010000
SI_DOWN3    =   %00011000
SI_DOWN4    =   %00100000
SI_UP1  =   %10001000
SI_UP2  =   %10010000
SI_UP3  =   %10011000
SI_UP4  =   %10100000
SI_LEFT1    =   %00000000
SI_LEFT2    =   %00000001
SI_LEFT3    =   %00000010
SI_LEFT4    =   %00000011


    ;--floor items

COMPRESSEDSPRING    =   $01
EXPANDEDSPRING      =   $02
RIGHTARROW      =   $03
LEFTARROW       =   $04
GIFT            =   $05
COOKIES         =   $06
LURKINGSNOWMAN      =   $07
LUNGINGSNOWMAN      =   $08
TOYSACK         =   $09
ORNAMENT        =   $0A
CANDYCANE       =   $0B
COAL            =   $0C
BELL            =   $0D
COCOA           =   $0E
MILK            =   $0F

    ;--MUSIC CONSTANTS FOLLOW:

THIRTYSECOND    =   %00000000
SIXTEENTH       =   %00010000
EIGHTH      =   %00110000
QUARTER     =   %01110000
HALF        =   %11110000
LONG8TH =   %01000000
SHORT8TH    =   %00100000
DOTTEDEIGHTH    =   %01010000
DOTTEDQUARTER   =   %10110000

V0      =   %00000000
V1      =   %00000001
V2      =   %00000010
V3      =   %00000011
V4      =   %00000100
V5      =   %00000101
V6      =   %00000110
V7      =   %00000111
V8      =   %00001000
V9      =   %00001001
V10     =   %00001010
V11     =   %00001011
V12     =   %00001100
V13     =   %00001101
V14     =   %00001110
V15     =   %00001111

    ;--Tempos available:
TEMPO900    =   0
TEMPO450    =   %00000001   ;450 BPM
TEMPO225    =   %00000010
TEMPO150    =   %00000011
TEMPO112    =   %00000100   ;112.5 BPM
TEMPO90     =   %00000101
TEMPO75     =   %00000110
TEMPO64     =   %00000111   ;64.2857142857143 BPM

SOUND0      =   %00000000
SOUND1      =   %00100000
SOUND2      =   %01000000
SOUND3      =   %01100000

ARTICULATE  =   %10000000

TONE0       =   SQUARESOUND
TONE1       =   LEADSOUND
TONE2       =   BASSSOUND
TONE3       =   SAWSOUND

LSOLEFT_BIT =   %01000000
MSOLEFT_BIT =   %10000000
MSOCOUNTER_BITS =   %00111000
LSOCOUNTER_BITS =   %00000111
MSOCOUNTER_INC  =   %00001000
LSOCOUNTER_INC  =   %00000001

HAT_BIT			=	%00100000
NEWDATA_BITS		=	%00001111
NUMREINDEER_BITS	=	%11000000

;--------Variables To Follow-------------

    SEG.U Variables
    org $80
Counter ds 1        ;+1   1
LevelIndex ds 1     ;+1   2 index of how far (in bytes) into the level
            ;       PF data table we are for this level (implies level PF data <=256 bytes)
LevelPFDataPtr ds 2 ;+2   4 pointer to level PF data table
NewDataCounter ds 1 ;+1   5 this really needs to be combined with something else, seeing as how
            ;       this only ranges between 0 and 8 or something.
            ;       going to combine with NumberOfReindeer - NumberOfReindeer stored in top two bits (6 & 7)
		;	ok, now using bit 5 to track flying hats collected on each level
		;	plan: only can collect 1 flying hat per level; when you do this bit is set.
		;		bit is reset upon advancing to a new level and when starting a new game.
PF0Data ds 8        ;+8  13
PF1Data ds 8        ;+8  21
PF2Data ds 8        ;+8  29
PF3Data ds 8        ;+8  37
PF4Data ds 8        ;+8  45
PF5Data ds 8        ;+8  53

;---Player Variables

ProtY ds 1      ;+1  54 *RELATIVE* Y position of protagonist: in scanlines above floor.
            ;       2nd byte is fractional for realistic jumping/falling
P0DataPtr ds 2      ;+2  78 location of datatable for prot image
P0DataColorPtr ds 2 ;+2  80 location of color table for prot
FloorItemPtr ds 2   ;+1  81 offset into table of image data for FloorItem
ItemFlags ds 1      ;+1  82 flag/info for both items.  bit 7 is flag for show FloorItem
ScrollSpeedCounter ds 1 ;+1  83 how fast to scroll: how many frames to skip
            ;       between scrolling PF data.  This variable should be combined with another.
            ;       range between 0 and 3 -- 0 = scroll every frame, 1 = scroll every other frame, etc.
            ;       And on third thought, the value of 4 is kinda hard on the eyes.
            ;       stored in bits 2 and 3
            ;       bits 0-1 tell us how many frames until we scroll again.
SkyItemAnimation ds 1   ;+1
GameFlags ds 1
BetweenLevelCounter
ForcedActionCounter ds 1
DelayCounter ds 1
EnergyExtraLives ds 1       ;+1  86 Number of extra lives - with a max of 3 extra lives (and a min of 0)
            ;       this should be rolled in with another variable.
SantaAnimation ds 1 ;       bottom nibble is counter until frame change, top nibble is which frame#
HighSkyDataPtr ds 2 ;+2  90
MidSkyDataPtr ds 2  ;+2  92
LowSkyDataPtr ds 2  ;+2  94
SkyItemDataPtr ds 2 ;+2  96
Level ds 1      ;+1  97 The Level number.  0 is the title sequence.
            ;       Might be able to combine this with something else, since 256 levels is unlikely :)
MSOX ds 2       ;+2  99 X position for mid sky object
            ;       two bytes for sub-pixel positioning.  Use second byte (fractional pixel)
            ;       for LowSkyObject positioning also
LSOX ds 1       ;+1 100 X position (integer part) for low sky object
HorizonObjectFlags ds 1 ;+1     7th bit = which side MSO is on, 6th bit is LSO (1 == L, 0 == R)
ProtX ds 1      ;+1 101 X position for protagonist (running man)
SkyItemX ds 1       ;+1 102 X position for item in sky
FloorItemX ds 1     ;+1 103 X position of floor item
SkyItemY ds 1       ;+1 105 relative vert pos of SkyItem.
SkyItemTemp ds 1
LevelItemIndex ds 1 ;+1 107 used to index into item data table.  won't be greater than...30ish.  I think.
ScoreAdder ds 2
Score ds 3      ;+3 112 three bytes for score, bcd, range is 0 to 999,999
HighScore ds 3      ;+3
SantaTemp ds 1      ;+1     use with DoDraw
JumpIndex ds 1      ;+1     used for jumping/falling rather than with fractional positioning
ConsoleSwitchTimer ds 1 ;+1     to prevent rapid switching :)
    ;--music variables
SongPtr ds 2
NoteLengthC0 ds 1
GlobalVolume ds 1
TempoCounter ds 1
MSOMask ds 1
LSOMask ds 1
SoundEffectsCounter ds 1
SoundEffectsType ds 1
    ;--end music variables
Temp ds 15      ;+16    126 All purpose temp variable(s).  The ones at the end may be overwritten
            ;       by subroutine calls and should be cautiously written to within subroutines

;---need at least 6 bytes at end for subroutine calls

;---End Variables

    SEG Bank0
    org $1000
    rorg $F000
;generic start up stuff...

    .byte 0,0,0

Start
    CLEAN_START

;---Initial Tasks---

	jsr InitialSetupSubroutine


;---VSYNC ----------------------------------------------------


MainLoop
    lda #2
    sta WSYNC
    sta VSYNC
    sta WSYNC
    sta WSYNC
    sta WSYNC
    lda #VBLANKTIME
    sta TIM64T
    lda #0
    sta VSYNC

    ;---update timer here.

    jsr UpdateTimerSubroutineBank2

;   these two combined with subroutine above
;   jsr ReadConsoleSwitchesSubroutineBank2
;   jsr UpdateScoreSubroutineBank2





    lda GameFlags
    and #SCROLLPF_BIT
    beq DoNotScrollScreen1
    jsr ScrollSubroutineBank0   ;scroll the screen :)
DoNotScrollScreen1

    lda GameFlags
    and #ANIMATEOTHER_BIT
    beq DoNotMoveSkyItemThisFrame
	lda GameFlags
	and #KERNELTYPE_BITS
	cmp #TITLESCREEN
	beq DoNotMoveSkyItemOnTitleScreen
    jsr MoveSkyItemSubroutineBank2
DoNotMoveSkyItemThisFrame
DoNotMoveSkyItemOnTitleScreen


;---Prep for Kernel below

    jsr KernelPrepSubroutineBank2

WaitForVblankEnd
    lda INTIM
;   bmi BreakStuff
    bne WaitForVblankEnd
;   beq SkipThis
;BreakStuff
;   .byte $02
;SkipThis
    sta WSYNC
    lda #KERNELTIME
    sta TIM64T
    lda #0

    sta WSYNC

    lda GameFlags
    and #KERNELTYPE_BITS
    cmp #GAMEKERNEL
    beq RegularKernel
    cmp #TITLESCREEN
    bne NotTitleScreenKernel
    jsr TitleScreenKernelBank2
    jmp OverscanBank1
NotTitleScreenKernel
    cmp #GAMEOVERSCREEN
    bne MustBeFinalScreenKernel
    jsr GameOverScreenKernelBank2
    jmp OverscanBank1
MustBeFinalScreenKernel
    jsr FinalScreenKernelBank4
    jmp OverscanBank1
RegularKernel
    jsr HorizonKernelSubroutineBank4

	jmp MainKernel




;---visible screen begins...--------------------------------------------------------------------


;Visible screen is as follows:
;       2    scanlines of background only
;       8    scanlines of sun/moon/etc (unmoving P1) and
;                   tall scrolling mountain/etc. (P0) [P0 starts at 3 scanlines from top]
;       5   scanlines of tall scrolling mountains/etc. (P1)
;                   reset P0 position here
;       9   scanlines of tall scrolling mountains/etc. (P1) and
;                   short scrolling mountains/etc. (P0)
;       7   scanlines of background - reset P0/P1 positions here
;       44  scanlines of background, protagonist (P0) and
;                   items/enemies/clouds/etc. (P1)
;       5   scanlines of prot (P0) reset P1 position here
;       55  scanlines of scrolling PF and prot (P0) in 9 bands:
;                   band 0 - 4 scanlines
;                   bands 1 & 2 - 9 scanlines each
;                   bands 3 & 4 - 4 scanlines each
;                   bands 5 & 6 - 9 scanlines each
;                   band 7 - 4 scanlines
;                   band 8 - 3 scanlines
;       6   scanlines of scrolling PF, prot (P0), and items/enemies/etc. (P1)
;       8   scanlines of floor (background)
;       30  scanlines of score, timer, and extra lives (each on sep line, P0/2)
;       13  scanlines of logo
;   sum=    192

;---First section of screen: 2 scanlines of background only

;   align 256
SantaColor0
SantaColor0Level1
    .byte 0
    .byte LEVEL1BACKGROUNDCOLOR
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte BELTCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte BEARDCOLOR
    .byte FACECOLOR
    .byte FACECOLOR
    .byte HAIRCOLOR
    .byte HATCOLOR
    .byte HATCOLOR
SantaColor0Level2
    .byte 0
    .byte LEVEL2BACKGROUNDCOLOR
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte BELTCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte BEARDCOLOR
    .byte FACECOLOR
    .byte FACECOLOR
    .byte HAIRCOLOR
    .byte HATCOLOR
    .byte HATCOLOR
SantaColor0Level3
    .byte 0
    .byte LEVEL3BACKGROUNDCOLOR
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte BELTCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte BEARDCOLOR
    .byte FACECOLOR
    .byte FACECOLOR
    .byte HAIRCOLOR
    .byte HATCOLOR
    .byte HATCOLOR




EvilBirdSleighB4
        .byte #%11111110;--
        .byte #%00010000;--
        .byte #%00100000;--
        .byte #%11111100;--
        .byte #%11111100;--
        .byte #%11111110;--
        .byte #%11111110;--
        .byte #%11111110;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%00011111;--
        .byte #%00010001;--
        .byte #%00010000;--
        .byte #%00010000;--
        .byte #%10010000;--
        .byte #%11111111;--
        .byte #%10111110;--
        .byte #%01111111;--
        .byte #%00011100;--
        .byte #%00000000;--

;---Sixth section of screen: 44 scanlines of protagonist (P0) and items/enemies/etc. (P1)
    align 256
Screen6a1                   ;   45
    jsr Ret             ;+12    57
    nop
    lda #P0HEIGHT-1         ;+2 61
    dcp SantaTemp           ;+5 66
    bcs DoDrawScreen5           ;+2 68
    SLEEP 9             ;+9  1
    lda #0              ;+2  3
    sta GRP0                ;+3  6
    beq SkipDrawScreen5     ;+3  9  branch always
DoDrawScreen5
    lda (P0DataPtr),Y
    sta GRP0                ;+8  1
    lda (P0DataColorPtr),Y
    sta COLUP0              ;+8  9
SkipDrawScreen5

    lda #%00110000          ;+2 11
    sta PF0             ;+3 14


    lda Temp
    dcp SkyItemTemp
    bcs DoDrawScreen6a1a
    lda #0
    .byte $2C
DoDrawScreen6a1a
    lda (SkyItemDataPtr),Y
    sta GRP1                ;+19    33  VDELed

    lda #0
    sta PF0             ;+5 38

    dey
    dex             ;+4 42
    bne Screen6a1           ;+3 45
                    ;   44


    ldx #23             ;+2 46
    SLEEP 3


Screen6a2
    lda #%11000000
    sta PF2             ;+5 54
    SLEEP 4             ;+4 58
    lda #P0HEIGHT-1         ;+2 60
    dcp SantaTemp           ;+5 65
    bcs DoDrawScreen6       ;+2 67
    SLEEP 9             ;+9 76
    lda #0              ;+2  2
    sta GRP0            ;+3  5
    beq SkipDrawScreen6     ;+3  8  branch always
DoDrawScreen6
    lda (P0DataPtr),Y
    sta GRP0                ;+8 76
    lda (P0DataColorPtr),Y
    sta COLUP0              ;+8  8
SkipDrawScreen6
    lda #0              ;+2 10
    sta PF2             ;+3 13

    lda Temp            ;+3 16
    dcp SkyItemTemp         ;+5 21
    bcs DoDrawScreen6a2     ;+2 23
    lda #0              ;+2 25
    .byte $2C           ;-1 24
DoDrawScreen6a2
    lda (SkyItemDataPtr),Y      ;+5 29
    sta GRP1            ;+3 32  VDELed

    rol $80
    ror $80                 ;+10    42
    dey                 ;+2 44
    dex
    bne Screen6a2               ;+5 49
                        ;   48


    stx VDELP1              ;+3 51  turn off VDELP1


    SLEEP 9                 ;+9 60

    lda #P0HEIGHT-1
    dcp SantaTemp
    bcs DoDrawScreen8
    lda #0
    sta GRP0
    SLEEP 9
    beq SkipDrawScreen8         ;       branch always
DoDrawScreen8
    lda (P0DataPtr),Y
    sta GRP0
    lda (P0DataColorPtr),Y
    sta COLUP0
SkipDrawScreen8                 ;+26    10

    dey                 ;+2 12

    lda #P0HEIGHT-1
    dcp SantaTemp
    bcs DoDrawScreen9
    lda #0
    sta GRP0
    sta Temp+2
    sta Temp+3
    SLEEP 3
    beq SkipDrawScreen9         ;       branch always
DoDrawScreen9
    lda (P0DataPtr),Y
    sta Temp+2
    lda (P0DataColorPtr),Y
    sta Temp+3
SkipDrawScreen9                 ;+26    38

    dey                 ;+2 40

    lda #P0HEIGHT-1             ;+2 42
    dcp SantaTemp               ;+5 47
    bcs DoDrawScreen10          ;+2 49
    lda #0                  ;+2 51
    sta.w GRP0              ;+4 55
    sec                 ;+2 57
    sta Temp
    sta Temp+1              ;+6 63
    beq SkipDrawScreen10            ;+3 66      branch always
DoDrawScreen10
    lda (P0DataPtr),Y
    sta Temp                ;+8 58
    lda (P0DataColorPtr),Y
    sta Temp+1              ;+8 66
SkipDrawScreen10                ;+26    66



    ;--now reposition P1 and set P1 and PF color
    lda Temp+2
    sta.w GRP0          ;+7 73
    lda Temp+3
    sta COLUP0          ;+6  3

    lda FloorItemX      ;+3  6
DivideLoop4
    sbc #15
    bcs DivideLoop4     ;+4/5   10/15/20/25/30/35/40/45/50/55

    eor #7          ;+2 12/17...
    asl
    asl
    asl
    asl             ;+8 20/25...

    sta RESP1           ;+3 23/28/33/38/43/48/53/58/63/68/73
    sta WSYNC           ;+3  0  begin line 2
    sta HMP1            ;+3  3
    lda Temp
    sta GRP0
    lda Temp+1
    sta COLUP0          ;+12    15

    dey             ;+2 17

    ldx Level
    lda FloorColorTable,X
    sta COLUPF              ;+10    27

    jsr Ret
    jsr Ret
    nop
    nop             ;+28    55

    lda #P0HEIGHT-1     ;+2 57
    dcp SantaTemp       ;+5 62
    bcs DoDrawScreen12  ;+2 64
    lda #0          ;+2 66
    SLEEP 4         ;+4 70
    sta HMOVE
    sta WSYNC           ;+6 76
    SLEEP 5
    sta GRP0            ;+8  8
    beq SkipDrawScreen12    ;+3 11  branch always
DoDrawScreen12
    lda (P0DataPtr),Y       ;+5 70
    sta HMOVE
    sta WSYNC           ;+6 76
    sta GRP0
    lda (P0DataColorPtr),Y
    sta COLUP0          ;+11    11
SkipDrawScreen12

    dey             ;+2 13

    ;---get size/duplication and color of FloorItem and set here?
    ;---get next line of Prot data

    lda ItemFlags
    and #$0F
    tax             ;+7 20
    lda FloorItemColorTable,X   ;+4 24  get FloorItemColor
    sta COLUP1          ;+3 27

    ;---wait...

    lda #P0HEIGHT-1
    dcp SantaTemp
    bcs DoDrawScreen11
    lda #0
    .byte $2C
DoDrawScreen11
    lda (P0DataPtr),Y       ;+15    42

    jsr Ret
    jsr Ret             ;+24    66

;   sta CXCLR           ;+3 69  clear playfield collisions
    SLEEP 3
    ldx #BAND0HEIGHT        ;+2 71
    jmp BeginBand0          ;+3 74  branch always


;---Eighth section of screen: 55 scanlines of scrolling PF and prot (P0)
;   in 9 bands of the following heights: 4, 9, 9, 4, 4, 9, 9, 4, 3
;   Note: will not display P1 in any of these bands.

;   align 256
;   At beginning:
;       Y holds absolute scanline value (i.e., 0-192)
;       X holds relative scanline value (i.e., 0-10)
;       A can hold anything


;---Draw Second Band (Band1):


;---end initialization


;---Draw Third Band (Band2):

LoopBand2
    nop         ;+2 72
    nop         ;+2 74
BeginBand2
    .byte  $8D,$1B,$00  ;+4  2  !!4-CYCLE WRITE TO GRP0!!
    lda (P0DataColorPtr),Y  ;+5  7
    sta COLUP0      ;+3 10

    dey         ;+2 12  decrement absolute scanline value by one here
    sec         ;+2 14

;---Next 12 lines (machine cycles 15-50) draw an asymmetrical playfield---
;---Note: I think that PF2 is written, the 2nd time, after it is done drawing the first time -
;---      but I'm not sure.  Something to check.  Check Result: Seems to display fine.
;---
    lda PF0Data+2   ;+3 17
    sta PF0     ;+3 20  PF0 drawn to screen at machine cycle (MC) 22.7
    lda PF1Data+2   ;+3 23
    sta PF1     ;+3 26  PF1 drawn to screen at MC 28
    lda PF2Data+2   ;+3 29
    sta PF2     ;+3 32  PF2 drawn to screen at MC 38.7
    lda PF3Data+2   ;+3 35
    sta PF0     ;+3 38  PF0 finished at MC 28, drawn to screen again at MC 49.3
    lda PF4Data+2   ;+3 41
    sta PF1     ;+3 44  PF1 finished at MC 38, drawn to screen again at MC 54.7
    lda PF5Data+2   ;+3 47
    sta PF2     ;+3 50  PF2 finished at MC 49.3, drawn to screen again at MC 65.3

;---End draw of asy playfield---

    lda #P0HEIGHT-1
    dcp SantaTemp
    bcs DoDrawBand2     ;+2/3   59/60
    lda #0          ;+2 61
    .byte $2C       ;-1 60
DoDrawBand2
    lda (P0DataPtr),Y   ;+5 65

    dex         ;+2 67
    bne LoopBand2       ;+2/3   69/70

    ldx #BAND3HEIGHT    ;+2 71
    jmp BeginBand3      ;+3 74  branch always

SantaColor3Level1
    .byte 0
    .byte LEVEL1BACKGROUNDCOLOR
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte BELTCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte BEARDCOLOR
    .byte FACECOLOR
    .byte FACECOLOR
    .byte   HAIRCOLOR
    .byte HATCOLOR
    .byte HATCOLOR
SantaColor3Level2
    .byte 0
    .byte LEVEL2BACKGROUNDCOLOR
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte BELTCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte BEARDCOLOR
    .byte FACECOLOR
    .byte FACECOLOR
    .byte   HAIRCOLOR
    .byte HATCOLOR
    .byte HATCOLOR
SantaColor3Level3
    .byte 0
    .byte LEVEL3BACKGROUNDCOLOR
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte BELTCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte BEARDCOLOR
    .byte FACECOLOR
    .byte FACECOLOR
    .byte   HAIRCOLOR
    .byte HATCOLOR
    .byte HATCOLOR


EvilBirdSleighB3
        .byte #%00000000;--
        .byte #%11111110;--
        .byte #%00010000;--
        .byte #%00100000;--
        .byte #%11111100;--
        .byte #%11111100;--
        .byte #%11111110;--
        .byte #%11111110;--
        .byte #%11111110;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%00011111;--
        .byte #%00010001;--
        .byte #%00010000;--
        .byte #%10010000;--
        .byte #%11111111;--
        .byte #%10111110;--
        .byte #%01111111;--
        .byte #%00000000;--
        .byte #%00000000;--

;---Draw Fourth Band (Band3):

    align 256

LoopBand3
    nop         ;+2 72
    nop         ;+2 74
BeginBand3
    .byte  $8D,$1B,$00  ;+4  2  4-CYCLE WRITE TO GRP0
    lda (P0DataColorPtr),Y  ;+5  7
    sta COLUP0      ;+3 10

    dey         ;+2 12  decrement absolute scanline value by one here
    sec         ;+2 14

;---Next 12 lines (machine cycles 15-50) draw an asymmetrical playfield---

    lda PF0Data+3   ;+3 17
    sta PF0     ;+3 20  PF0 drawn to screen at machine cycle (MC) 22.7
    lda PF1Data+3   ;+3 23
    sta PF1     ;+3 26  PF1 drawn to screen at MC 28
    lda PF2Data+3   ;+3 29
    sta PF2     ;+3 32  PF2 drawn to screen at MC 38.7
    lda PF3Data+3   ;+3 35
    sta PF0     ;+3 38  PF0 finished at MC 28, drawn to screen again at MC 49.3
    lda PF4Data+3   ;+3 41
    sta PF1     ;+3 44  PF1 finished at MC 38, drawn to screen again at MC 54.7
    lda PF5Data+3   ;+3 47
    sta PF2     ;+3 50  PF2 finished at MC 49.3, drawn to screen again at MC 65.3

;---End draw of asym playfield---

    lda #P0HEIGHT-1
    dcp SantaTemp
    bcs DoDrawBand3     ;+2/3   59/60
    lda #0          ;+2 61
    .byte $2C       ;-1 60
DoDrawBand3
    lda (P0DataPtr),Y   ;+5 65

    dex         ;+2 67
    bne LoopBand3       ;+2/3   69/70

;---Initialization between bands

    ldx #BAND4HEIGHT    ;+2 71
    bne BeginBand4      ;+3 74

;---End initialization


;---Draw Fifth Band (Band4):

LoopBand4
    nop         ;+2 72
    nop         ;+2 74
BeginBand4
    sta.w GRP0
    lda (P0DataColorPtr),Y  ;+5  7
    sta COLUP0      ;+3 10

    dey         ;+2 12  decrement absolute scanline value by one here
    nop
;---Next 12 lines (machine cycles 15-50) draw an asymmetrical playfield---

    lda PF0Data+4   ;+3 17
    sta PF0     ;+3 20  PF0 drawn to screen at machine cycle (MC) 22.7
    lda PF1Data+4   ;+3 23
    sta PF1     ;+3 26  PF1 drawn to screen at MC 28
    lda PF2Data+4   ;+3 29
    sta PF2     ;+3 32  PF2 drawn to screen at MC 38.7
    lda PF3Data+4   ;+3 35
    sta PF0     ;+3 38  PF0 finished at MC 28, drawn to screen again at MC 49.3
    lda PF4Data+4   ;+3 41
    sta PF1     ;+3 44  PF1 finished at MC 38, drawn to screen again at MC 54.7
    lda PF5Data+4   ;+3 47
    sta PF2     ;+3 50  PF2 finished at MC 49.3, drawn to screen again at MC 65.3

;---End draw of asym playfield---

;---Draw Player 0---

    lda #P0HEIGHT-1
    dcp SantaTemp
    bcs DoDrawBand4     ;+2/3   59/60
    lda #0          ;+2 61
    .byte $2C       ;-1 60
DoDrawBand4
    lda (P0DataPtr),Y   ;+5 65

    dex         ;+2 67
    bne LoopBand4       ;+2/3   69/70

;---Initialization between bands:

    ldx #BAND5HEIGHT    ;+2 72
    jmp BeginBand5      ;+3 75  branch always



SantaColor4
SantaColor4Level1
    .byte 0
    .byte LEVEL1BACKGROUNDCOLOR
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte BELTCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte BEARDCOLOR
    .byte FACECOLOR
    .byte FACECOLOR
    .byte   HAIRCOLOR
    .byte HATCOLOR
    .byte HATCOLOR
SantaColor4Level2
    .byte 0
    .byte LEVEL2BACKGROUNDCOLOR
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte BELTCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte BEARDCOLOR
    .byte FACECOLOR
    .byte FACECOLOR
    .byte   HAIRCOLOR
    .byte HATCOLOR
    .byte HATCOLOR
SantaColor4Level3
    .byte 0
    .byte LEVEL3BACKGROUNDCOLOR
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte BELTCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte BEARDCOLOR
    .byte FACECOLOR
    .byte FACECOLOR
    .byte   HAIRCOLOR
    .byte HATCOLOR
    .byte HATCOLOR


EvilBirdSleighB5
        .byte #%11111110;--
        .byte #%00010000;--
        .byte #%00100000;--
        .byte #%11111100;--
        .byte #%11111100;--
        .byte #%11111110;--
        .byte #%11111110;--
        .byte #%11111110;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%00011111;--
        .byte #%00010001;--
        .byte #%00010000;--
        .byte #%10010000;--
        .byte #%11111111;--
        .byte #%10111110;--
        .byte #%01111111;--
        .byte #%00011100;--
        .byte #%00001100;--
        .byte #%00000110;--

    align 256

SkipDrawBand7       ;   60
    SLEEP 4     ;+4 64
    bcc ReturnFromSkipDraw  ;+3 67

LoopBand7               ;   72
;---Draw Player 0---
    lda #P0HEIGHT-1 ;+2 58
    dcp SantaTemp   ;+5 63
    bcc SkipDrawBand7   ;+2 65
    lda (P0DataPtr),Y   ;+5 70
    sta GRP0        ;+3 73
ReturnFromSkipDraw

    lda (FloorItemPtr),Y    ;+5  2
    sta GRP1            ;+3  5
    nop             ;+2  7
BeginBand7              ;    7
    lda (P0DataColorPtr),Y
    sta COLUP0          ;+8 15

    lda PF0Data+7   ;+3 18
    sta PF0     ;+3 21  PF0 drawn to screen at machine cycle (MC) 22.7
    lda PF1Data+7   ;+3 24
    sta PF1     ;+3 27  PF1 drawn to screen at MC 28
    lda PF2Data+7   ;+3 30
    sta PF2     ;+3 33  PF2 drawn to screen at MC 38.7
    lda PF3Data+7   ;+3 36
    sta PF0     ;+3 39  PF0 finished at MC 28, drawn to screen again at MC 49.3
    lda PF4Data+7   ;+3 42
    sta PF1     ;+3 45  PF1 finished at MC 38, drawn to screen again at MC 54.7
    lda PF5Data+7   ;+3 48
    sta PF2     ;+3 51  PF2 finished at MC 49.3, drawn to screen again at MC 65.3

;---End draw of asy playfield---

    dey         ;+2 53
    bpl LoopBand7   ;+3 56


;---Ninth section of screen: 8 scanlines of floor (background)
;   we are done counting total screen scanlines now, so we will stop
;   decrementing Y and will use it otherwise when we need to
;   I will continue to use X to count down the scanlines within each screen section
;   clear PF also, and maybe prep players for score/timer/lives display
;   also must clear both players here!
;   also reset Player Colors here for Timer.



    jsr DisplayScoreSubroutineBank2





WaitForKernelEnd
    lda INTIM
;   bmi ErrorHalt
    bne WaitForKernelEnd


;--------------------------------------------
;-------------Overscan-----------------------
;--------------------------------------------
OverscanBank1
    jsr OverscanBank2

WaitForOverscanEnd
    lda INTIM
;   bmi ErrorHaltOverscan
    bne WaitForOverscanEnd

    jmp  MainLoop

ErrorHalt
;   .byte $02
ErrorHaltOverscan
;   .byte $02

;-------------------------------------------------------------------
;----------------------END OVERSCAN---------------------------------
;-------------------------------------------------------------------




;----------------------------------------------------------------------
;--------------------------Data Follows--------------------------------
;----------------------------------------------------------------------




    org $145A
    rorg $F45A
EvilBirdSleighA3
        .byte #%00000000;--
        .byte #%00111111;--
        .byte #%01010000;--
        .byte #%10001000;--
        .byte #%10001111;--
        .byte #%10001111;--
        .byte #%01011111;--
        .byte #%00010011;--
        .byte #%00110001;--
        .byte #%00110001;--
        .byte #%00110000;--
        .byte #%00010000;--
        .byte #%00010000;--
        .byte #%00010000;--
        .byte #%10010000;--
        .byte #%11111111;--
        .byte #%10111110;--
        .byte #%01111111;--
        .byte #%00000000;--
        .byte #%00000000;--
EvilBirdSleighA4
        .byte #%00111111;--
        .byte #%01010000;--
        .byte #%10001000;--
        .byte #%10001111;--
        .byte #%10001111;--
        .byte #%01011111;--
        .byte #%00010011;--
        .byte #%00110001;--
        .byte #%00110001;--
        .byte #%00110000;--
        .byte #%00010000;--
        .byte #%00010000;--
        .byte #%00010000;--
        .byte #%00010000;--
        .byte #%10010000;--
        .byte #%11111111;--
        .byte #%10111110;--
        .byte #%01111111;--
        .byte #%00011100;--
        .byte #%00000000;--
EvilBirdSleighA5
        .byte #%00111111;--
        .byte #%01010000;--
        .byte #%10001000;--
        .byte #%10001111;--
        .byte #%10001111;--
        .byte #%01011111;--
        .byte #%00010011;--
        .byte #%00110001;--
        .byte #%00110001;--
        .byte #%00110000;--
        .byte #%00010000;--
        .byte #%00010000;--
        .byte #%00010000;--
        .byte #%10010000;--
        .byte #%11111111;--
        .byte #%10111110;--
        .byte #%01111111;--
        .byte #%00011100;--
        .byte #%00001100;--
        .byte #%00000110;--


Snowflake1
        .byte #%00010000;--
        .byte #%01000100;--
        .byte #%00101000;--
        .byte #%01010100;--
        .byte #%00111000;--
        .byte #%00010000;--
        .byte #%10111010;--
        .byte #%01101100;--
        .byte #%01101100;--
        .byte #%10111010;--
        .byte #%00010000;--
        .byte #%00111000;--
        .byte #%01010100;--
        .byte #%00101000;--
        .byte #%01000100;--
        .byte #%00010000;--
Snowflake2
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%01010100;--
        .byte #%00101000;--
        .byte #%01010100;--
        .byte #%00111000;--
        .byte #%10010010;--
        .byte #%01101100;--
        .byte #%01101100;--
        .byte #%10010010;--
        .byte #%00111000;--
        .byte #%01010100;--
        .byte #%00101000;--
        .byte #%01010100;--
        .byte #%00000000;--
        .byte #%00000000;--
Snowflake3
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%01010100;--
        .byte #%00101000;--
        .byte #%10010010;--
        .byte #%01101100;--
        .byte #%10010010;--
        .byte #%00101000;--
        .byte #%01010100;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
Snowflake4
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00010000;--
        .byte #%10101010;--
        .byte #%01010100;--
        .byte #%10101010;--
        .byte #%00010000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
Snowflake5
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00010000;--
        .byte #%10101010;--
        .byte #%00010000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
EvilBirdSleighB6
        .byte #%11111110;--
        .byte #%00010000;--
        .byte #%00100000;--
        .byte #%11111100;--
        .byte #%11111100;--
        .byte #%11111110;--
        .byte #%11111110;--
        .byte #%11111110;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%00011111;--
        .byte #%00010001;--
        .byte #%10010000;--
        .byte #%11111111;--
        .byte #%10111110;--
        .byte #%01111111;--
        .byte #%00001100;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--

    align 256

FloorItemColorTable
    .byte GRAY+0,SPRINGCOLOR,SPRINGCOLOR,RIGHTARROWCOLOR
    .byte LEFTARROWCOLOR,GIFTCOLOR,COOKIESCOLOR,SNOWMANCOLOR,SNOWMANCOLOR
    .byte TOYSACKCOLOR,ORNAMENTCOLOR,CANDYCANECOLOR,COALCOLOR
    .byte BELLCOLOR,COCOACOLOR,MILKCOLOR


RArrow
        .byte #%00000000;--
        .byte #%10001000;--
        .byte #%11001100;--
        .byte #%11101110;--
        .byte #%11111111;--
        .byte #%11101110;--
        .byte #%11001100;--
        .byte #%10001000;--
        .byte #%00000000;--
LArrow
        .byte #%00000000;--
        .byte #%00010001;--
        .byte #%00110011;--
        .byte #%01110111;--
        .byte #%11111111;--
        .byte #%01110111;--
        .byte #%00110011;--
        .byte #%00010001;--
        .byte #%00000000;--
Gift
        .byte #%11101110;--
        .byte #%11101110;--
        .byte #%00000000;--
        .byte #%11101110;--
        .byte #%11101110;--
        .byte #%00010000;--
        .byte #%00101000;--
        .byte #%00101000;--
        .byte #%00000000;--
Ornament
        .byte #%00100000;--
        .byte #%01110000;--
        .byte #%11111000;--
        .byte #%11111000;--
        .byte #%10111000;--
        .byte #%11011010;--
        .byte #%01110001;--
        .byte #%00100001;--
        .byte #%00011110;--
Bell
        .byte #%00010000;--
        .byte #%01111100;--
        .byte #%00111000;--
        .byte #%00111000;--
        .byte #%00111000;--
        .byte #%00111000;--
        .byte #%00010000;--
        .byte #%00010000;--
        .byte #%00010000;--

    org $155A
    rorg $F55A
EvilBirdSleighA1
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00111111;--
        .byte #%01010000;--
        .byte #%10001000;--
        .byte #%10001111;--
        .byte #%10001111;--
        .byte #%01011111;--
        .byte #%00010011;--
        .byte #%00110001;--
        .byte #%00110001;--
        .byte #%00110000;--
        .byte #%00010000;--
        .byte #%00011110;--
        .byte #%00011100;--
        .byte #%10011101;--
        .byte #%11111110;--
        .byte #%10111110;--
        .byte #%01111111;--
        .byte #%00000000;--
EvilBirdSleighA2
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00111111;--
        .byte #%01010000;--
        .byte #%10001000;--
        .byte #%10001111;--
        .byte #%10001111;--
        .byte #%01011111;--
        .byte #%00010011;--
        .byte #%00110001;--
        .byte #%00110001;--
        .byte #%00110000;--
        .byte #%00010000;--
        .byte #%00010000;--
        .byte #%00010000;--
        .byte #%10011100;--
        .byte #%11111111;--
        .byte #%10111110;--
        .byte #%01111111;--
        .byte #%00000000;--
EvilBirdSleighA6
        .byte #%00111111;--
        .byte #%01010000;--
        .byte #%10001000;--
        .byte #%10001111;--
        .byte #%10001111;--
        .byte #%01011111;--
        .byte #%00010011;--
        .byte #%00110001;--
        .byte #%00110001;--
        .byte #%00110000;--
        .byte #%00010000;--
        .byte #%00010000;--
        .byte #%10010000;--
        .byte #%11111111;--
        .byte #%10111110;--
        .byte #%01111111;--
        .byte #%00001100;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--

Elf6
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%01000000;--
        .byte #%10000110;--
        .byte #%11100101;--
        .byte #%00111100;--
        .byte #%00111100;--
        .byte #%00001000;--
        .byte #%00111100;--
        .byte #%00111100;--
        .byte #%11111111;--
        .byte #%00111000;--
        .byte #%00000000;--
        .byte #%00011000;--
        .byte #%00011000;--
        .byte #%00011000;--
        .byte #%00011000;--
        .byte #%00110000;--
        .byte #%01000000;--
Elf7
        .byte #%00000000;--
        .byte #%00100000;--
        .byte #%01001100;--
        .byte #%01101010;--
        .byte #%00101000;--
        .byte #%00111000;--
        .byte #%00111100;--
        .byte #%00001000;--
        .byte #%00111100;--
        .byte #%00111100;--
        .byte #%00111100;--
        .byte #%01111010;--
        .byte #%10000001;--
        .byte #%00011000;--
        .byte #%00011000;--
        .byte #%00011000;--
        .byte #%00111000;--
        .byte #%01010000;--
        .byte #%00000000;--
Elf8
        .byte #%00001000;--
        .byte #%00010000;--
        .byte #%00011000;--
        .byte #%00101000;--
        .byte #%00101000;--
        .byte #%00111000;--
        .byte #%00111100;--
        .byte #%00001000;--
        .byte #%00111100;--
        .byte #%00111100;--
        .byte #%11111111;--
        .byte #%00111000;--
        .byte #%00000000;--
        .byte #%00011000;--
        .byte #%00011000;--
        .byte #%00011000;--
        .byte #%01111000;--
        .byte #%00010000;--
        .byte #%00000000;--
EvilBird5
        .byte #%00000000;--
        .byte #%10000000;--
        .byte #%11111111;--
        .byte #%10111110;--
        .byte #%01111111;--
        .byte #%00011100;--
        .byte #%00001100;--
        .byte #%00000110;--
EvilBird6
        .byte #%10000000;--
        .byte #%11111111;--
        .byte #%10111110;--
        .byte #%01111111;--
        .byte #%00001100;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
EvilBird7
        .byte #%00000000;--
        .byte #%10000001;--
        .byte #%11111110;--
        .byte #%10111110;--
        .byte #%01111111;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
EvilBird8
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%10011101;--
        .byte #%11111110;--
        .byte #%10111110;--
        .byte #%01111111;--
        .byte #%00000000;--
        .byte #%00000000;--
Snowflake6
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%11111110;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--


    align 256

PositionASpriteSubroutine           ;come in with A as horiz position and X as index into RESPx
    sec             ;+2 70
    sta HMCLR           ;+3 73
    sta WSYNC
DivideLoop2
    sbc #15
    bcs DivideLoop2     ;+4/5    4/ 9...

    eor #7          ;+2  6/11...
    asl
    asl
    asl
    asl             ;+8 14/...

    sta.wx HMP0,X       ;+5 19/...
    sta RESP0,X             ;+4 23/28/33/38/43/48/53/58/63/68/73
    sta WSYNC           ;+3 0   begin line 2
    txa
    eor #1
    tax             ;+6  6
    lda #$80            ;+2  8
    sta HMP0,X          ;+4 12
    jsr Ret
    jsr Ret
    jsr Ret
    jsr Ret
    rol $80
    ror $80         ;+58    70
    sta HMOVE
    sta WSYNC           ;+6 76
    rts             ;+6  6


Cocoa
        .byte #%00110000;--
        .byte #%01111000;--
        .byte #%01111000;--
        .byte #%01111100;--
        .byte #%01111010;--
        .byte #%01111010;--
        .byte #%01111100;--
        .byte #%01111000;--
        .byte #%00000000;--
Milk
        .byte #%00011000;--
        .byte #%00111100;--
        .byte #%00111100;--
        .byte #%00111100;--
        .byte #%00111100;--
        .byte #%00111100;--
        .byte #%00100100;--
        .byte #%00100100;--
        .byte #%00011000;--


    org $165A
    rorg $F65A
Tornado7
        .byte #%00001000;--
        .byte #%00000000;--
        .byte #%00001000;--
        .byte #%00110000;--
        .byte #%00000000;--
        .byte #%00110000;--
        .byte #%00000000;--
        .byte #%00010000;--
        .byte #%00001100;--
        .byte #%00000000;--
        .byte #%00001100;--
        .byte #%00000000;--
        .byte #%00001100;--
        .byte #%00010000;--
        .byte #%00001110;--
        .byte #%00010000;--
        .byte #%00001110;--
        .byte #%00110000;--
        .byte #%00001111;--
        .byte #%11110000;--
Tornado8
        .byte #%00000100;--
        .byte #%00000000;--
        .byte #%00001100;--
        .byte #%00010000;--
        .byte #%00001000;--
        .byte #%00110000;--
        .byte #%00000000;--
        .byte #%00110000;--
        .byte #%00000000;--
        .byte #%00110000;--
        .byte #%00001100;--
        .byte #%00010000;--
        .byte #%00001100;--
        .byte #%00000000;--
        .byte #%00001110;--
        .byte #%00000000;--
        .byte #%00001110;--
        .byte #%00110000;--
        .byte #%00001111;--
        .byte #%11110000;--
Elf1
        .byte #%00000000;--
        .byte #%00100000;--
        .byte #%01001100;--
        .byte #%01101010;--
        .byte #%00101000;--
        .byte #%00111000;--
        .byte #%00111100;--
        .byte #%00001000;--
        .byte #%10111101;--
        .byte #%01111110;--
        .byte #%00111100;--
        .byte #%00111000;--
        .byte #%00000000;--
        .byte #%00011000;--
        .byte #%00011000;--
        .byte #%01011000;--
        .byte #%00111000;--
        .byte #%00010000;--
        .byte #%00000000;--
Elf2
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%01000000;--
        .byte #%10000110;--
        .byte #%11100101;--
        .byte #%00111100;--
        .byte #%00111100;--
        .byte #%00001000;--
        .byte #%00111100;--
        .byte #%00111100;--
        .byte #%11111111;--
        .byte #%00111000;--
        .byte #%00000000;--
        .byte #%00011000;--
        .byte #%00011000;--
        .byte #%01011000;--
        .byte #%00111000;--
        .byte #%00010000;--
        .byte #%00000000;--
Elf3
        .byte #%00000000;--
        .byte #%00100000;--
        .byte #%01001100;--
        .byte #%01101010;--
        .byte #%00101000;--
        .byte #%00111000;--
        .byte #%00111100;--
        .byte #%00001000;--
        .byte #%00111100;--
        .byte #%00111100;--
        .byte #%00111100;--
        .byte #%01111010;--
        .byte #%10000001;--
        .byte #%00011000;--
        .byte #%00011000;--
        .byte #%00011000;--
        .byte #%01011000;--
        .byte #%00110000;--
        .byte #%00000000;--
Elf4
        .byte #%00001000;--
        .byte #%00010000;--
        .byte #%00011000;--
        .byte #%00101000;--
        .byte #%00101000;--
        .byte #%00111000;--
        .byte #%00111100;--
        .byte #%00001000;--
        .byte #%00111100;--
        .byte #%00111100;--
        .byte #%11111111;--
        .byte #%00111000;--
        .byte #%00000000;--
        .byte #%00011000;--
        .byte #%00011000;--
        .byte #%00011000;--
        .byte #%00011000;--
        .byte #%01110000;--
        .byte #%00000000;--
EvilBirdSleighA7
        .byte #%00111111;--
        .byte #%01010000;--
        .byte #%10001000;--
        .byte #%10001111;--
        .byte #%10001111;--
        .byte #%01011111;--
        .byte #%00010011;--
        .byte #%00110001;--
        .byte #%00110001;--
        .byte #%00110000;--
        .byte #%00010000;--
        .byte #%00010000;--
        .byte #%00010000;--
        .byte #%10010001;--
        .byte #%11111110;--
        .byte #%10111110;--
        .byte #%01111111;--
        .byte #%00000000;--
        .byte #%00000000;--
    ;shares 1 byte with following table
Elf5
        .byte #%00000000;--
        .byte #%00100000;--
        .byte #%01001100;--
        .byte #%01101010;--
        .byte #%00101000;--
        .byte #%00111000;--
        .byte #%00111100;--
        .byte #%00001000;--
        .byte #%10111101;--
        .byte #%01111110;--
        .byte #%00111100;--
        .byte #%00111000;--
        .byte #%00000000;--
        .byte #%00011000;--
        .byte #%00011000;--
        .byte #%00011000;--
        .byte #%00011000;--
        .byte #%00110000;--
        .byte #%01000000;--

Snowspeeder4
        .byte #%00001110;--
        .byte #%00011110;--
        .byte #%01111111;--
        .byte #%11111111;--
        .byte #%01100010;--
        .byte #%01011110;--
        .byte #%01011110;--
        .byte #%01100010;--
        .byte #%11111111;--
        .byte #%01111111;--
        .byte #%00011110;--
        .byte #%00001110;--


    align 256

CandyCane
        .byte #%00100000;--
        .byte #%00000000;--
        .byte #%00100000;--
        .byte #%00000000;--
        .byte #%00100000;--
        .byte #%00001000;--
        .byte #%00100000;--
        .byte #%00001000;--
        .byte #%00010000;--
Coal
        .byte #%00111100;--
        .byte #%01111110;--
        .byte #%01111110;--
        .byte #%00111100;--
        .byte #%00111000;--
        .byte #%00011000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--

Cookies
        .byte #%00000110;--
        .byte #%00001111;--
        .byte #%00001101;--
        .byte #%01101111;--
        .byte #%11111011;--
        .byte #%10110110;--
        .byte #%11110000;--
        .byte #%11010000;--
        .byte #%01100000;--
LurkingSnowman
        .byte #%00101011;--
        .byte #%00011110;--
        .byte #%00001010;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
LungingSnowman
        .byte #%00111111;--
        .byte #%00010111;--
        .byte #%00000101;--
        .byte #%00000001;--
        .byte #%00010011;--
        .byte #%00111111;--
        .byte #%00101011;--
        .byte #%00011110;--
        .byte #%00001010;--
ToySack
        .byte #%01111000;--
        .byte #%11111100;--
        .byte #%11111100;--
        .byte #%11111100;--
        .byte #%01111100;--
        .byte #%01111000;--
        .byte #%00110000;--
        .byte #%11000000;--
        .byte #%01000000;--

CompressedSpring
        .byte #%01111110;--
        .byte #%11111111;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
ExpandedSpring
        .byte #%01111110;--
        .byte #%00010000;--
        .byte #%00001000;--
        .byte #%00010000;--
        .byte #%00001000;--
        .byte #%00010000;--
        .byte #%00001000;--
        .byte #%01111110;--
        .byte #%11111111;--










    org $175A
    rorg $F75A
List8
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%11100000;--
        .byte #%11100000;--
        .byte #%11100000;--
        .byte #%11100000;--
        .byte #%11100000;--
        .byte #%11100000;--
        .byte #%11100000;--
        .byte #%11100000;--
        .byte #%11100000;--
        .byte #%11100000;--
        .byte #%11100000;--
        .byte #%11100000;--
        .byte #%01110000;--
        .byte #%00000000;--
        .byte #%00000000;--
Tornado1
        .byte #%00000010;--
        .byte #%00000000;--
        .byte #%00000110;--
        .byte #%00000000;--
        .byte #%00001000;--
        .byte #%00110000;--
        .byte #%00000000;--
        .byte #%01100000;--
        .byte #%00000000;--
        .byte #%01110000;--
        .byte #%00001000;--
        .byte #%00110000;--
        .byte #%00001100;--
        .byte #%00010000;--
        .byte #%00001110;--
        .byte #%00110000;--
        .byte #%00001110;--
        .byte #%01110000;--
        .byte #%00001111;--
        .byte #%11110000;--
Tornado2
        .byte #%00000100;--
        .byte #%00000000;--
        .byte #%00001100;--
        .byte #%00000000;--
        .byte #%00001000;--
        .byte #%00110000;--
        .byte #%00001000;--
        .byte #%00110000;--
        .byte #%00000000;--
        .byte #%00110000;--
        .byte #%00001000;--
        .byte #%00010000;--
        .byte #%00001100;--
        .byte #%00010000;--
        .byte #%00001100;--
        .byte #%00110000;--
        .byte #%00001110;--
        .byte #%01110000;--
        .byte #%00001110;--
        .byte #%11110000;--
Tornado3
        .byte #%00001000;--
        .byte #%00000000;--
        .byte #%00001000;--
        .byte #%00010000;--
        .byte #%00001000;--
        .byte #%00000000;--
        .byte #%00001110;--
        .byte #%00000000;--
        .byte #%00000110;--
        .byte #%00000000;--
        .byte #%00001110;--
        .byte #%00000000;--
        .byte #%00001100;--
        .byte #%00010000;--
        .byte #%00001100;--
        .byte #%00110000;--
        .byte #%00001100;--
        .byte #%01110000;--
        .byte #%00001110;--
        .byte #%11110000;--
Tornado4
        .byte #%00000000;--
        .byte #%00100000;--
        .byte #%00000000;--
        .byte #%00010000;--
        .byte #%00001000;--
        .byte #%00000000;--
        .byte #%00000110;--
        .byte #%00000000;--
        .byte #%00000011;--
        .byte #%00000000;--
        .byte #%00000011;--
        .byte #%00000000;--
        .byte #%00001110;--
        .byte #%00110000;--
        .byte #%00001100;--
        .byte #%01110000;--
        .byte #%00001000;--
        .byte #%01110000;--
        .byte #%00001110;--
        .byte #%11110000;--
Tornado5
        .byte #%00000000;--
        .byte #%10000000;--
        .byte #%00000000;--
        .byte #%01100000;--
        .byte #%00001000;--
        .byte #%00010000;--
        .byte #%00001110;--
        .byte #%00000000;--
        .byte #%00000111;--
        .byte #%00000000;--
        .byte #%00000011;--
        .byte #%00000000;--
        .byte #%00001110;--
        .byte #%00010000;--
        .byte #%00001100;--
        .byte #%00110000;--
        .byte #%00001100;--
        .byte #%01110000;--
        .byte #%00001110;--
        .byte #%11110000;--
Tornado6
        .byte #%00000000;--
        .byte #%00100000;--
        .byte #%00000000;--
        .byte #%00010000;--
        .byte #%00001000;--
        .byte #%00010000;--
        .byte #%00001100;--
        .byte #%00000000;--
        .byte #%00001110;--
        .byte #%00000000;--
        .byte #%00001110;--
        .byte #%00000000;--
        .byte #%00001100;--
        .byte #%00010000;--
        .byte #%00001100;--
        .byte #%00110000;--
        .byte #%00001110;--
        .byte #%01110000;--
        .byte #%00001111;--
        .byte #%11110000;--

EvilBirdSleighA8
        .byte #%00000000;--
        .byte #%00111111;--
        .byte #%01010000;--
        .byte #%10001000;--
        .byte #%10001111;--
        .byte #%10001111;--
        .byte #%01011111;--
        .byte #%00010011;--
        .byte #%00110001;--
        .byte #%00110001;--
        .byte #%00110000;--
        .byte #%00010000;--
        .byte #%00010000;--
        .byte #%00010000;--
        .byte #%10011101;--
        .byte #%11111110;--
        .byte #%10111110;--
        .byte #%01111111;--
        .byte #%00000000;--
        .byte #%00000000;--



    align 256
SkyItemHeightTable1     ;duplicate of table in bank 2
    .byte 1,8,18,16,14,18,18,40,16,12,20,20,19,16,20,20
SkyItemColorTable
    .byte GRAY+0,EVILBIRDCOLOR,REINDEERCOLOR,SNOWFLURRYCOLOR,METHANECOLOR
    .byte REINDEERCOLOR,REINDEERCOLOR,LIGHTNINGCOLOR,FLYINGHATCOLOR,SNOWSPEEDERCOLOR
    .byte LISTCOLOR,TORNADOCOLOR
    .byte ELFCOLOR,SNOWFLAKECOLOR,EVILBIRDCOLOR,EVILBIRDCOLOR


    org $185A
    rorg $F85A
List1
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00111000;--
        .byte #%01110000;--
        .byte #%01110000;--
        .byte #%01110000;--
        .byte #%11110000;--
        .byte #%11100000;--
        .byte #%11100000;--
        .byte #%11100000;--
        .byte #%11100000;--
        .byte #%11100000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
List2
        .byte #%00011100;--
        .byte #%00111110;--
        .byte #%01111000;--
        .byte #%01110000;--
        .byte #%11110000;--
        .byte #%11100000;--
        .byte #%11100000;--
        .byte #%11100000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
List3
        .byte #%00111100;--
        .byte #%01111110;--
        .byte #%00001110;--
        .byte #%00001110;--
        .byte #%00000111;--
        .byte #%00000111;--
        .byte #%00000111;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
List4
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00001110;--
        .byte #%00001111;--
        .byte #%00000111;--
        .byte #%00000111;--
        .byte #%00000111;--
        .byte #%00000111;--
        .byte #%00000111;--
        .byte #%00000111;--
        .byte #%00000111;--
        .byte #%00000011;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
List5
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000111;--
        .byte #%00000111;--
        .byte #%00000111;--
        .byte #%00000111;--
        .byte #%00000111;--
        .byte #%00000111;--
        .byte #%00000111;--
        .byte #%00000111;--
        .byte #%00000111;--
        .byte #%00000111;--
        .byte #%00000111;--
        .byte #%00000000;--
        .byte #%00000000;--
List6
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000111;--
        .byte #%00000111;--
        .byte #%00000111;--
        .byte #%00000111;--
        .byte #%00001110;--
        .byte #%00111100;--
List7
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%11100000;--
        .byte #%11100000;--
        .byte #%11110000;--
        .byte #%11110000;--
        .byte #%01110000;--
        .byte #%01111000;--
        .byte #%00111100;--
EvilBirdSleighB1
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%11111110;--
        .byte #%00010000;--
        .byte #%00100000;--
        .byte #%11111100;--
        .byte #%11111100;--
        .byte #%11111110;--
        .byte #%11111110;--
        .byte #%11111110;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%00011111;--
        .byte #%00011111;--
        .byte #%00011100;--
        .byte #%10011101;--
        .byte #%11111110;--
        .byte #%10111110;--
        .byte #%01111111;--
        .byte #%00000000;--

    align 256
DisplayReindeerAndSantaOnTitleScreen
    ldy #17         ;height of reindeer minus 1
DisplayReindeerOnTitleScreenLoop
    sta WSYNC
    lda (SkyItemDataPtr),Y
    sta GRP1
    dey
    bpl DisplayReindeerOnTitleScreenLoop

    sta WSYNC
    lda #0
    sta GRP1

    ldy #21         ;height of santa minus 1
DisplaySantaOnTitleScreenLoop
    sta WSYNC
    lda (P0DataPtr),Y
    sta GRP0
    lda (P0DataColorPtr),Y
    sta COLUP0

    dey
    bpl DisplaySantaOnTitleScreenLoop

    sta WSYNC
    lda #0
    sta GRP0
	lda #GRAY+14
	sta COLUBK		;same as floor color in level 0

    jmp GoBackToMiddleOfTitleScreen

    org $195A
    rorg $195A
EvilBirdSleighB7
        .byte #%11111110;--
        .byte #%00010000;--
        .byte #%00100000;--
        .byte #%11111100;--
        .byte #%11111100;--
        .byte #%11111110;--
        .byte #%11111110;--
        .byte #%11111110;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%00011111;--
        .byte #%00010001;--
        .byte #%00010000;--
        .byte #%10010001;--
        .byte #%11111110;--
        .byte #%10111110;--
        .byte #%01111111;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
FlyingHat3
        .byte #%00000110;--
        .byte #%00000110;--
        .byte #%00001001;--
        .byte #%00001001;--
        .byte #%00011001;--
        .byte #%00011001;--
        .byte #%00011001;--
        .byte #%00111001;--
        .byte #%00111001;--
        .byte #%01111001;--
        .byte #%01100110;--
        .byte #%01000110;--
        .byte #%01000000;--
        .byte #%10100000;--
        .byte #%10100000;--
        .byte #%01000000;--
FlyingHat4
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%01000000;--
        .byte #%10110000;--
        .byte #%10111000;--
        .byte #%01011100;--
        .byte #%00011110;--
        .byte #%00011101;--
        .byte #%00011001;--
        .byte #%00011001;--
        .byte #%00100001;--
        .byte #%00100010;--
        .byte #%00100100;--
        .byte #%00011000;--
FlyingHat5
        .byte #%00000000;--
        .byte #%01000000;--
        .byte #%10100000;--
        .byte #%10110000;--
        .byte #%01011000;--
        .byte #%00011000;--
        .byte #%00011100;--
        .byte #%00011100;--
        .byte #%00011110;--
        .byte #%00011110;--
        .byte #%00100001;--
        .byte #%00100001;--
        .byte #%00100001;--
        .byte #%00011110;--
        .byte #%00000000;--
        .byte #%00000000;--
FlyingHat6
        .byte #%00010000;--
        .byte #%00101000;--
        .byte #%00101100;--
        .byte #%00011100;--
        .byte #%00001100;--
        .byte #%00001100;--
        .byte #%00011100;--
        .byte #%00011100;--
        .byte #%01111100;--
        .byte #%10111000;--
        .byte #%10111000;--
        .byte #%10011000;--
        .byte #%10001000;--
        .byte #%01000100;--
        .byte #%00100100;--
        .byte #%00011000;--
FlyingHat7
        .byte #%00000010;--
        .byte #%00000101;--
        .byte #%00000101;--
        .byte #%00000010;--
        .byte #%01100010;--
        .byte #%01100110;--
        .byte #%10011110;--
        .byte #%10011100;--
        .byte #%10011100;--
        .byte #%10011000;--
        .byte #%10011000;--
        .byte #%10011000;--
        .byte #%10010000;--
        .byte #%10010000;--
        .byte #%01100000;--
        .byte #%01100000;--
FlyingHat8
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00011000;--
        .byte #%00100100;--
        .byte #%01000100;--
        .byte #%10000100;--
        .byte #%10011000;--
        .byte #%10011000;--
        .byte #%10111000;--
        .byte #%01111000;--
        .byte #%00111010;--
        .byte #%00011101;--
        .byte #%00001101;--
        .byte #%00000010;--
        .byte #%00000000;--
        .byte #%00000000;--
Snowspeeder1
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00001110;--
        .byte #%01111111;--
        .byte #%11111111;--
        .byte #%00111111;--
        .byte #%00000010;--
        .byte #%00011100;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
Snowspeeder2
Snowspeeder6
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00001110;--
        .byte #%00011110;--
        .byte #%11111111;--
        .byte #%01111110;--
        .byte #%01000010;--
        .byte #%11011111;--
        .byte #%00011110;--
        .byte #%00001110;--
        .byte #%00000000;--
        .byte #%00000000;--
Snowspeeder3
Snowspeeder5
        .byte #%00000000;--
        .byte #%00001110;--
        .byte #%00011110;--
        .byte #%01111111;--
        .byte #%11111111;--
        .byte #%01000010;--
        .byte #%01011110;--
        .byte #%01011110;--
        .byte #%11111111;--
        .byte #%00011110;--
        .byte #%00001110;--
        .byte #%00000000;--

    align 256
LoopBand5
    nop         ;+2 72
    nop         ;+2 74
BeginBand5
    sta.w GRP0      ;+4  2  4-CYCLE WRITE TO GRP0
    lda (P0DataColorPtr),Y  ;+5  7
    sta COLUP0      ;+3 10

    dey         ;+2 12  decrement absolute scanline value by one here
    nop         ;+2 14

;---Next 12 lines (machine cycles 15-50) draw an asymmetrical playfield---

    lda PF0Data+5   ;+3 17
    sta PF0     ;+3 20  PF0 drawn to screen at machine cycle (MC) 22.7
    lda PF1Data+5   ;+3 23
    sta PF1     ;+3 26  PF1 drawn to screen at MC 28
    lda PF2Data+5   ;+3 29
    sta PF2     ;+3 32  PF2 drawn to screen at MC 38.7
    lda PF3Data+5   ;+3 35
    sta PF0     ;+3 38  PF0 finished at MC 28, drawn to screen again at MC 49.3
    lda PF4Data+5   ;+3 41
    sta PF1     ;+3 44  PF1 finished at MC 38, drawn to screen again at MC 54.7
    lda PF5Data+5   ;+3 47
    sta PF2     ;+3 50  PF2 finished at MC 49.3, drawn to screen again at MC 65.3

;---End draw of asym playfield---

;---Draw Player 0---

    lda #P0HEIGHT-1
    dcp SantaTemp
    bcs DoDrawBand5     ;+2/3   59/60
    lda #0          ;+2 61
    .byte $2C       ;-1 60
DoDrawBand5
    lda (P0DataPtr),Y   ;+5 65

    dex         ;+2 67
    bne LoopBand5       ;+2/3   69/70

;---Initialization between bands:

    ldx #BAND6HEIGHT        ;+2 71
    jmp BeginBand6      ;+3 74  branch always

    org $1A48
    rorg $FA48
    .byte 0
Lightning1
Lightning5
    .byte 0,0,0,0,0,0,0,0,0
Lightning2
    .byte 0,0,0,0,0,0,0,0
    .byte 0,0,0,0,0,0,0,0
    .byte 0,0,0,0,0,0,0,0
    .byte 0,0,0,0,0,0,0
        .byte #%00100000;--
        .byte #%00100000;--
        .byte #%00100000;--
        .byte #%00100000;--
        .byte #%00100000;--
        .byte #%01000000;--
        .byte #%01000000;--
        .byte #%01000000;--
Lightning3
NoFloorItem

    .byte 0,0,0,0,0,0,0,0
    .byte 0,0,0,0,0,0,0
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00010000;--
        .byte #%00010000;--
        .byte #%00011000;--
        .byte #%00011000;--
        .byte #%00001000;--
        .byte #%00000100;--
        .byte #%00000100;--
        .byte #%00000100;--
        .byte #%00001000;--
        .byte #%00001000;--
        .byte #%00011000;--
        .byte #%00010000;--
        .byte #%00010000;--
        .byte #%00010000;--
        .byte #%00110000;--
        .byte #%00100000;--
        .byte #%00100000;--
        .byte #%00100000;--
        .byte #%00100000;--
        .byte #%00100000;--
        .byte #%01000000;--
        .byte #%01000000;--
        .byte #%01000000;--
Lightning4
Lightning6
        .byte #%10000000;--
        .byte #%10010000;--
        .byte #%11010000;--
        .byte #%01001000;--
        .byte #%01001010;--
        .byte #%01101010;--
        .byte #%00101010;--
        .byte #%00100100;--
        .byte #%00100100;--
        .byte #%00100100;--
        .byte #%00100100;--
        .byte #%00100100;--
        .byte #%00100100;--
        .byte #%00100100;--
        .byte #%00101000;--
        .byte #%00010000;--
        .byte #%00010000;--
        .byte #%00010000;--
        .byte #%00010000;--
        .byte #%00011000;--
        .byte #%00011000;--
        .byte #%00001000;--
        .byte #%00000100;--
        .byte #%00000100;--
        .byte #%00000100;--
        .byte #%00001000;--
        .byte #%00001000;--
        .byte #%00011000;--
        .byte #%00010000;--
        .byte #%00010000;--
        .byte #%00010000;--
        .byte #%00110000;--
        .byte #%00100000;--
        .byte #%00100000;--
        .byte #%00100000;--
        .byte #%00100000;--
        .byte #%00100000;--
        .byte #%01000000;--
        .byte #%01000000;--
        .byte #%01000000;--
FlyingHat1

        .byte #%01111000;--
        .byte #%10000100;--
        .byte #%10000100;--
        .byte #%10000100;--
        .byte #%01111000;--
        .byte #%01111000;--
        .byte #%00111000;--
        .byte #%00111000;--
        .byte #%00011000;--
        .byte #%00011010;--
        .byte #%00001101;--
        .byte #%00000101;--
        .byte #%00000010;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
FlyingHat2
        .byte #%00011000;--
        .byte #%00100100;--
        .byte #%00100010;--
        .byte #%00010001;--
        .byte #%00011001;--
        .byte #%00011101;--
        .byte #%00011101;--
        .byte #%00111110;--
        .byte #%00111000;--
        .byte #%00111000;--
        .byte #%00110000;--
        .byte #%00110000;--
        .byte #%00111000;--
        .byte #%00010100;--
        .byte #%00010100;--
        .byte #%00001000;--
EvilBirdSleighB2
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%11111110;--
        .byte #%00010000;--
        .byte #%00100000;--
        .byte #%11111100;--
        .byte #%11111100;--
        .byte #%11111110;--
        .byte #%11111110;--
        .byte #%11111110;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%00011111;--
        .byte #%00010001;--
        .byte #%00010000;--
        .byte #%10011100;--
        .byte #%11111111;--
        .byte #%10111110;--
        .byte #%01111111;--
        .byte #%00000000;--

    align 256
LoopBand0
    nop         ;+2 72
    nop         ;+2 74
BeginBand0
    sta.w GRP0
    lda (P0DataColorPtr),Y  ;+5  7
    sta COLUP0      ;+3 10

    dey         ;+2 12  decrement absolute scanline value by one here
    nop

    lda PF0Data ;+3 17
    sta PF0     ;+3 20  PF0 drawn to screen at machine cycle (MC) 22.7
    lda PF1Data ;+3 23
    sta PF1     ;+3 26  PF1 drawn to screen at MC 28
    lda PF2Data ;+3 29
    sta PF2     ;+3 32  PF2 drawn to screen at MC 38.7
    lda PF3Data ;+3 35
    sta PF0     ;+3 38  PF0 finished at MC 28, drawn to screen again at MC 49.3
    lda PF4Data ;+3 41
    sta PF1     ;+3 44  PF1 finished at MC 38, drawn to screen again at MC 54.7
    lda PF5Data ;+3 47
    sta PF2     ;+3 50  PF2 finished at MC 49.3, drawn to screen again at MC 65.3

;---End draw of assy playfield---


;---Draw Player 0---
;------!!carry must be set!!---

    lda #P0HEIGHT-1
    dcp SantaTemp
    bcs DoDrawBand0
    lda #0
    .byte $2C
DoDrawBand0
    lda (P0DataPtr),Y   ;+15    65

    dex         ;+2 67
    bne LoopBand0       ;+2/3   69/70

    ldx #BAND1HEIGHT    ;+2 71
    jmp BeginBand1      ;+3 74  branch always



    org $1B5A
    rorg $FB5A
EvilBirdSleighB8
        .byte #%00000000;--
        .byte #%11111110;--
        .byte #%00010000;--
        .byte #%00100000;--
        .byte #%11111100;--
        .byte #%11111100;--
        .byte #%11111110;--
        .byte #%11111110;--
        .byte #%11111110;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%00011111;--
        .byte #%00010001;--
        .byte #%00010000;--
        .byte #%10011101;--
        .byte #%11111110;--
        .byte #%10111110;--
        .byte #%01111111;--
        .byte #%00000000;--
        .byte #%00000000;--
SnowFlurry0
        .byte #%00001100;--
        .byte #%00001100;--
        .byte #%00010000;--
        .byte #%00000000;--
        .byte #%10000000;--
        .byte #%10000000;--
        .byte #%00001000;--
        .byte #%00000001;--
        .byte #%00100001;--
        .byte #%00100000;--
        .byte #%00000100;--
        .byte #%00000000;--
        .byte #%01000010;--
        .byte #%00000010;--
        .byte #%00011000;--
        .byte #%00011000;--
SnowFlurry1
        .byte #%00011000;--
        .byte #%00011000;--
        .byte #%00100000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%10010000;--
        .byte #%10000001;--
        .byte #%00000001;--
        .byte #%00000000;--
        .byte #%00100100;--
        .byte #%00100000;--
        .byte #%00000010;--
        .byte #%00000010;--
        .byte #%00100000;--
        .byte #%00001100;--
        .byte #%00001100;--
SnowFlurry2
        .byte #%00110000;--
        .byte #%00110000;--
        .byte #%01000000;--
        .byte #%00000000;--
        .byte #%00000001;--
        .byte #%00000001;--
        .byte #%10100000;--
        .byte #%10000100;--
        .byte #%00000000;--
        .byte #%00000010;--
        .byte #%00100010;--
        .byte #%00100000;--
        .byte #%00000000;--
        .byte #%00010000;--
        .byte #%00000110;--
        .byte #%00000110;--
SnowFlurry3
        .byte #%00000000;--
        .byte #%00110000;--
        .byte #%00110000;--
        .byte #%01000010;--
        .byte #%00000010;--
        .byte #%00000100;--
        .byte #%00000000;--
        .byte #%10100000;--
        .byte #%10000001;--
        .byte #%00000001;--
        .byte #%00000000;--
        .byte #%00100000;--
        .byte #%00100000;--
        .byte #%00000011;--
        .byte #%00001011;--
        .byte #%00000000;--
SnowFlurry4
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%01100100;--
        .byte #%01100100;--
        .byte #%10000000;--
        .byte #%00001000;--
        .byte #%00000000;--
        .byte #%00000001;--
        .byte #%00000001;--
        .byte #%10100000;--
        .byte #%10000000;--
        .byte #%00000011;--
        .byte #%00000011;--
        .byte #%00100100;--
        .byte #%00100000;--
        .byte #%00000000;--
SnowFlurry5
        .byte #%00000000;--
        .byte #%00001000;--
        .byte #%00001000;--
        .byte #%01100000;--
        .byte #%01110000;--
        .byte #%10000001;--
        .byte #%00000001;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000011;--
        .byte #%00000011;--
        .byte #%01010000;--
        .byte #%01000100;--
        .byte #%00000000;--
        .byte #%00010000;--
        .byte #%00010000;--
SnowFlurry6
        .byte #%00010000;--
        .byte #%00010000;--
        .byte #%00000010;--
        .byte #%00100010;--
        .byte #%00000000;--
        .byte #%01100000;--
        .byte #%01100000;--
        .byte #%00000011;--
        .byte #%10000011;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000010;--
        .byte #%00101000;--
        .byte #%00100000;--
        .byte #%00001000;--
        .byte #%00001000;--
SnowFlurry7
        .byte #%00100000;--
        .byte #%00100100;--
        .byte #%00000100;--
        .byte #%01000000;--
        .byte #%00000000;--
        .byte #%00000011;--
        .byte #%00000011;--
        .byte #%01100000;--
        .byte #%01100000;--
        .byte #%00000010;--
        .byte #%10000000;--
        .byte #%00000000;--
        .byte #%00000100;--
        .byte #%00010000;--
        .byte #%00010100;--
        .byte #%00000100;--
SnowFlurry8
        .byte #%00001000;--
        .byte #%01001000;--
        .byte #%01000000;--
        .byte #%00000000;--
        .byte #%10000011;--
        .byte #%00000011;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000010;--
        .byte #%01100000;--
        .byte #%01100000;--
        .byte #%00000100;--
        .byte #%10000000;--
        .byte #%00000010;--
        .byte #%00001010;--
        .byte #%00001000;--

    align 256

LoopBand6
    nop         ;+2 72
    nop         ;+2 74
BeginBand6
    sta.w GRP0      ;+4  2
    lda (P0DataColorPtr),Y  ;+5  7
    sta COLUP0      ;+3 10

    dey         ;+2 12  decrement absolute scanline value by one here
    nop         ;+2 14

;---Next 12 lines (machine cycles 15-50) draw an asymmetrical playfield---

    lda PF0Data+6   ;+3 17
    sta PF0     ;+3 20  PF0 drawn to screen at machine cycle (MC) 22.7
    lda PF1Data+6   ;+3 23
    sta PF1     ;+3 26  PF1 drawn to screen at MC 28
    lda PF2Data+6   ;+3 29
    sta PF2     ;+3 32  PF2 drawn to screen at MC 38.7
    lda PF3Data+6   ;+3 35
    sta PF0     ;+3 38  PF0 finished at MC 28, drawn to screen again at MC 49.3
    lda PF4Data+6   ;+3 41
    sta PF1     ;+3 44  PF1 finished at MC 38, drawn to screen again at MC 54.7
    lda PF5Data+6   ;+3 47
    sta PF2     ;+3 50  PF2 finished at MC 49.3, drawn to screen again at MC 65.3

;---End draw of asy playfield---

;---Draw Player 0---

    lda #P0HEIGHT-1
    dcp SantaTemp
    bcs DoDrawBand6     ;+2/3   59/60
    lda #0          ;+2 61
    .byte $2C       ;-1 60
DoDrawBand6
    lda (P0DataPtr),Y   ;+5 65

    dex         ;+2 67
    bne LoopBand6       ;+2/3   69/70



;---Initialization between bands:

    sta GRP0        ;+3 74
    stx GRP1        ;+3  1  X == 0
    sty VDELP0      ;+3  4  Y == 5, so bit 1 is set.
    jmp BeginBand7  ;+3  7  branch always




    org $1C5A
    rorg $FC5A

SantaColor4Level0
    .byte 0
    .byte LEVEL0BACKGROUNDCOLOR
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte BELTCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte BEARDCOLOR
    .byte FACECOLOR
    .byte FACECOLOR
    .byte   HAIRCOLOR
    .byte HATCOLOR
    .byte HATCOLOR

SantaColor5
    .byte 0
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte BELTCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte BEARDCOLOR
    .byte FACECOLOR
    .byte FACECOLOR
    .byte   HAIRCOLOR
    .byte HATCOLOR
    .byte HATCOLOR
    .byte HATCOLOR


EvilBird1
        .byte #%00000000;--
        .byte #%00001110;--
        .byte #%00011100;--
        .byte #%10011101;--
        .byte #%11111110;--
        .byte #%10111110;--
        .byte #%01111111;--
        .byte #%00000000;--
EvilBird2
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%10001100;--
        .byte #%11111111;--
        .byte #%10111110;--
        .byte #%01111111;--
        .byte #%00000000;--
EvilBird3
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%10000000;--
        .byte #%11111111;--
        .byte #%10111110;--
        .byte #%01111111;--
        .byte #%00000000;--
        .byte #%00000000;--
EvilBird4
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%10000000;--
        .byte #%11111111;--
        .byte #%10111110;--
        .byte #%01111111;--
        .byte #%00011100;--
        .byte #%00000000;--
Reindeer0
        .byte #%00000000;--
        .byte #%00000001;--
        .byte #%11000001;--
        .byte #%01100010;--
        .byte #%00111110;--
        .byte #%00011110;--
        .byte #%00111110;--
        .byte #%00111110;--
        .byte #%00111111;--
        .byte #%00110111;--
        .byte #%01110000;--
        .byte #%11100000;--
        .byte #%11100000;--
        .byte #%01100000;--
        .byte #%00100000;--
        .byte #%01100000;--
        .byte #%00100000;--
        .byte #%01000000;--
Reindeer1
        .byte #%00000010;--
        .byte #%01000010;--
        .byte #%01100010;--
        .byte #%00100010;--
        .byte #%00111110;--
        .byte #%00011110;--
        .byte #%00111110;--
        .byte #%00111111;--
        .byte #%00111111;--
        .byte #%01110110;--
        .byte #%11100000;--
        .byte #%11100000;--
        .byte #%01100000;--
        .byte #%00100000;--
        .byte #%01100000;--
        .byte #%00100000;--
        .byte #%01000000;--
        .byte #%00000000;--
Reindeer2
        .byte #%00000000;--
        .byte #%00010100;--
        .byte #%00110100;--
        .byte #%00100010;--
        .byte #%00011110;--
        .byte #%00011110;--
        .byte #%00111110;--
        .byte #%00111110;--
        .byte #%00111111;--
        .byte #%00110111;--
        .byte #%01110000;--
        .byte #%01110000;--
        .byte #%00110000;--
        .byte #%00010000;--
        .byte #%00110000;--
        .byte #%00010000;--
        .byte #%00100000;--
        .byte #%00000000;--
Reindeer3
        .byte #%00000010;--
        .byte #%01000010;--
        .byte #%01100001;--
        .byte #%00100011;--
        .byte #%00111110;--
        .byte #%00011110;--
        .byte #%00111110;--
        .byte #%00111111;--
        .byte #%00111111;--
        .byte #%00110110;--
        .byte #%00110000;--
        .byte #%01110000;--
        .byte #%01110000;--
        .byte #%00110000;--
        .byte #%00010000;--
        .byte #%00110000;--
        .byte #%00010000;--
        .byte #%00100000;--
SnowFlurry12
        .byte #%00000110;--
        .byte #%00000110;--
        .byte #%00000000;--
        .byte #%01001000;--
        .byte #%01000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%01000101;--
        .byte #%01000001;--
        .byte #%00000000;--
        .byte #%10000000;--
        .byte #%00000010;--
        .byte #%00000010;--
        .byte #%00110000;--
        .byte #%00110000;--
        .byte #%00001000;--


    align 256
LoopBand1
    nop         ;+2 72
    nop         ;+2 74
BeginBand1
    .byte  $8D,$1B,$00  ;+4  2  !!4-CYCLE WRITE TO GRP0!!
    lda (P0DataColorPtr),Y  ;+5  7
    sta COLUP0      ;+3 10

    dey         ;+2 12  decrement absolute scanline value by one here
    nop

;---Next 12 lines (machine cycles 15-50) draw an asymmetrical playfield---

    lda PF0Data+1   ;+3 17
    sta PF0     ;+3 20  PF0 drawn to screen at machine cycle (MC) 22.7
    lda PF1Data+1   ;+3 23
    sta PF1     ;+3 26  PF1 drawn to screen at MC 28
    lda PF2Data+1   ;+3 29
    sta PF2     ;+3 32  PF2 drawn to screen at MC 38.7
    lda PF3Data+1   ;+3 35
    sta PF0     ;+3 38  PF0 finished at MC 28, drawn to screen again at MC 49.3
    lda PF4Data+1   ;+3 41
    sta PF1     ;+3 44  PF1 finished at MC 38, drawn to screen again at MC 54.7
    lda PF5Data+1   ;+3 47
    sta PF2     ;+3 50  PF2 finished at MC 49.3, drawn to screen again at MC 65.3

;---End draw of asym playfield---

;------!!carry must be set!!---

    lda #P0HEIGHT-1
    dcp SantaTemp
    bcs DoDrawBand1     ;+2/3   59/60
    lda #0          ;+2 61
    .byte $2C       ;-1 60
DoDrawBand1
    lda (P0DataPtr),Y   ;+5 65

    dex         ;+2 67
    bne LoopBand1       ;+2/3   69/70

;---Initialization between bands:

    ldx #BAND2HEIGHT    ;+2 71
    jmp BeginBand2      ;+3 74  branch always





    org $1D5F
    rorg $FD5F

SantaFrame0
    .byte 0
        .byte #%11111111
        .byte #%10000000
        .byte #%11100111
        .byte #%11100110
        .byte #%01110110
        .byte #%00000110
        .byte #%00111110
        .byte #%00111110
        .byte #%00111110
        .byte #%00111111
        .byte #%01111111
        .byte #%01001111
        .byte #%01001110
        .byte #%01011110
        .byte #%01111100
        .byte #%00111100
        .byte #%00011100
        .byte #%00011000
        .byte #%00011000
        .byte #%01011000
        .byte #%00111000
        .byte #%00010000

SantaFrame1
    .byte 0
        .byte #%00001110
        .byte #%01001100
        .byte #%01101100
        .byte #%01101100
        .byte #%01101100
        .byte #%00011100
        .byte #%00111110
        .byte #%00111110
        .byte #%00111111
        .byte #%01111111
        .byte #%01111111
        .byte #%01100111
        .byte #%01000110
        .byte #%01011110
        .byte #%00111100
        .byte #%00011100
        .byte #%00011000
        .byte #%00011000
        .byte #%01011000
        .byte #%00111000
        .byte #%00010000
        .byte #%00000000

SantaFrame2
    .byte 0
        .byte #%00011100
        .byte #%00111000
        .byte #%00111100
        .byte #%00111100
        .byte #%00011100
        .byte #%00111110
        .byte #%00111110
        .byte #%00111111
        .byte #%01111111
        .byte #%01111111
        .byte #%01100110
        .byte #%01000110
        .byte #%01011110
        .byte #%00111100
        .byte #%00011100
        .byte #%00011000
        .byte #%00011000
        .byte #%01011000
        .byte #%00111000
        .byte #%00010000
        .byte #%00000000
        .byte #%00000000

SantaFrame3
    .byte 0
        .byte #%00111000
        .byte #%00110100
        .byte #%00110100
        .byte #%00110110
        .byte #%00110110
        .byte #%00111010
        .byte #%00111110
        .byte #%00111111
        .byte #%01111111
        .byte #%01111111
        .byte #%01110010
        .byte #%01100010
        .byte #%01100100
        .byte #%00111100
        .byte #%00011100
        .byte #%00011000
        .byte #%00011000
        .byte #%01011000
        .byte #%00111000
        .byte #%00010000
        .byte #%00000000
        .byte #%00000000

SantaFrame4
    .byte 0
        .byte #%11111111
        .byte #%01110000
        .byte #%01100010
        .byte #%01100010
        .byte #%01110110
        .byte #%01110110
        .byte #%00111010
        .byte #%00111110
        .byte #%00111111
        .byte #%01111111
        .byte #%01111111
        .byte #%01110010
        .byte #%01100010
        .byte #%01101100
        .byte #%01111100
        .byte #%00111100
        .byte #%00011100
        .byte #%00011000
        .byte #%00011000
        .byte #%01011000
        .byte #%00111000
        .byte #%00010000

SantaFrame5
    .byte 0
        .byte #%11111111
        .byte #%10000000
        .byte #%11100111
        .byte #%11100110
        .byte #%01110110
        .byte #%01110110
        .byte #%00111010
        .byte #%00111010
        .byte #%00111110
        .byte #%00111111
        .byte #%01111111
        .byte #%01110011
        .byte #%01100010
        .byte #%01101110
        .byte #%01111100
        .byte #%00111100
        .byte #%00011100
        .byte #%00011000
        .byte #%00011000
        .byte #%01011000
        .byte #%00111000
        .byte #%00010000

SantaFrame6
    .byte 0
        .byte #%00001110
        .byte #%01001100
        .byte #%01110100
        .byte #%01111000
        .byte #%01111100
        .byte #%00111100
        .byte #%00111110
        .byte #%00111110
        .byte #%00111111
        .byte #%01110011
        .byte #%01100011
        .byte #%01101111
        .byte #%01111110
        .byte #%01111110
        .byte #%00111100
        .byte #%00011100
        .byte #%00011000
        .byte #%00011000
        .byte #%01011000
        .byte #%00111000
        .byte #%00010000
        .byte #%00000000

    align 256

MainKernel
    lda #0
    ldx Level           ;+3  3
    sta WSYNC
    sta GRP1
    sta GRP0
    sta PF0
    sta PF1
    sta PF2

    lda BackgroundColorTable,X  ;+4  7  get background color for next line
    sta COLUBK      ;+3  3  Set Background color here if not set already.
    sta COLUPF      ;+3     PF used for masking should be invisible, hence same color as background.
    lda #PRIORITYPF     ;PF is in foreground (cuz I use it to mask players), unreflected.
    sta CTRLPF

    lda ProtX
    clc         ;+2
    adc #8          ;+2
    cmp #160        ;+2
    bcc NoAdjustScreen4a    ;2/3
    sbc #160        ;+2
NoAdjustScreen4a
    ldx #0
    jsr PositionASpriteSubroutine

    lda SkyItemX
    clc         ;+2
    adc #8          ;+2
    cmp #160        ;+2
    bcc NoAdjustScreen4b    ;2/3
    sbc #160        ;+2
NoAdjustScreen4b
    ldx #1
    jsr PositionASpriteSubroutine

	jmp Kernel5


    org $1E5F
    rorg $FE5F

SantaColor1
    .byte 0
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte BELTCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte BEARDCOLOR
    .byte FACECOLOR
    .byte FACECOLOR
    .byte   HAIRCOLOR
    .byte HATCOLOR
    .byte HATCOLOR
    .byte HATCOLOR

SantaColor2
    .byte 0
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte BELTCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte BEARDCOLOR
    .byte FACECOLOR
    .byte FACECOLOR
    .byte   HAIRCOLOR
    .byte HATCOLOR
    .byte HATCOLOR
    .byte HATCOLOR
    .byte HATCOLOR
SantaColor3
SantaColor3Level0
    .byte 0
    .byte LEVEL0BACKGROUNDCOLOR
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte BELTCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte BEARDCOLOR
    .byte FACECOLOR
    .byte FACECOLOR
    .byte   HAIRCOLOR
    .byte HATCOLOR
    .byte HATCOLOR


SantaColor0Level0
    .byte 0
    .byte LEVEL0BACKGROUNDCOLOR
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte BOOTCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte BELTCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte SUITCOLOR
    .byte BEARDCOLOR
    .byte FACECOLOR
    .byte FACECOLOR
    .byte HAIRCOLOR
    .byte HATCOLOR
    .byte HATCOLOR



SantaFrame7
    .byte 0
        .byte #%00011100
        .byte #%00111000
        .byte #%00111100
        .byte #%00111100
        .byte #%00111100
        .byte #%00111110
        .byte #%00111110
        .byte #%00111111
        .byte #%01100111
        .byte #%01000111
        .byte #%01011110
        .byte #%01111110
        .byte #%01111110
        .byte #%00111100
        .byte #%00011100
        .byte #%00011000
        .byte #%00011000
        .byte #%01011000
        .byte #%00111000
        .byte #%00010000
        .byte #%00000000
        .byte #%00000000

SantaFrame8
    .byte 0
        .byte #%00111000
        .byte #%00110100
        .byte #%00110100
        .byte #%00000110
        .byte #%00111110
        .byte #%00111110
        .byte #%00111110
        .byte #%00111111
        .byte #%01100111
        .byte #%01000111
        .byte #%01011110
        .byte #%01111110
        .byte #%01111100
        .byte #%00111100
        .byte #%00011100
        .byte #%00011000
        .byte #%00011000
        .byte #%01011000
        .byte #%00111000
        .byte #%00010000
        .byte #%00000000
        .byte #%00000000

SantaFrame9
    .byte 0
        .byte #%11111111
        .byte #%01110000
        .byte #%01100010
        .byte #%01100010
        .byte #%00000110
        .byte #%01111110
        .byte #%00111110
        .byte #%00111110
        .byte #%00111111
        .byte #%01111111
        .byte #%01001111
        .byte #%01001110
        .byte #%01011110
        .byte #%01111100
        .byte #%01111100
        .byte #%00111100
        .byte #%00011100
        .byte #%00011000
        .byte #%00011000
        .byte #%01011000
        .byte #%00111000
        .byte #%00010000

    align 256

  IF TV_MODE = NTSC
BackgroundColorTable
    .byte BLUE2+10,BLUE2+8,GRAY+4,GRAY+2
FloorColorTable
    .byte GRAY+14,GRAY+12,GRAY+6,GRAY+0
  ELSE
BackgroundColorTable
        .byte BLUE2+8,BLUE2+6,GRAY+6,GRAY+4
FloorColorTable
        .byte GRAY+14,GRAY+12,GRAY+8,GRAY+0
  ENDIF

Kernel5


    lda #ONECOPYNORMAL
    sta NUSIZ0
    sta NUSIZ1          ;+8  8

    lda #1
    sta VDELP1          ;+5
    sta CXCLR           ;+3  3

    sta WSYNC

    lda ItemFlags       ;+3  3
    lsr
    lsr
    lsr
    lsr
    tax             ;+10    13
    lda SkyItemColorTable,X ;+4 17
    sta COLUP1          ;+3 20

    lda SkyItemHeightTable1,X
    sec
    sbc #1
    sta Temp            ;+11    31

    ldy #PLAYAREAHEIGHT         ;+2 33

    ldx #23         ;+2 35
    SLEEP 7
    jmp Screen6a1

;---------------------------------

InitialSetupSubroutine

    lda #<[JingleBells-2]
    sta SongPtr
    lda #>[JingleBells-2]
    sta SongPtr+1

    lda #P0HEIGHT-1
    sta ProtY

    lda #REINDEER1
    sta ItemFlags

    lda #18
    sta SkyItemY

    lda GameFlags
    ora #ANIMATESANTA_BIT|ANIMATEOTHER_BIT
	IF TESTVERSION = 1
	ora #FINALSCREEN	;for testing only
	ENDIF
    sta GameFlags

    lda SkyItemAnimation
    and #$0F
    ora #$30
    sta SkyItemAnimation    ;set max number of reindeer frames

	rts

    org $1F60
    rorg $FF60
SnowFlurry9
        .byte #%00000000;--
        .byte #%00010000;--
        .byte #%01010000;--
        .byte #%01000011;--
        .byte #%00000011;--
        .byte #%10000000;--
        .byte #%00000000;--
        .byte #%00000010;--
        .byte #%00000000;--
        .byte #%00000100;--
        .byte #%01100000;--
        .byte #%01100000;--
        .byte #%00000001;--
        .byte #%01000101;--
        .byte #%00000100;--
        .byte #%00000000;--


SnowFlurry10
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00100011;--
        .byte #%00100011;--
        .byte #%01000000;--
        .byte #%01000100;--
        .byte #%00000000;--
        .byte #%10000000;--
        .byte #%00000100;--
        .byte #%00000000;--
        .byte #%00000001;--
        .byte #%00110001;--
        .byte #%00110100;--
        .byte #%00000100;--
        .byte #%00000000;--
        .byte #%00010000;--
SnowFlurry11
        .byte #%00000000;--
        .byte #%00000011;--
        .byte #%00000011;--
        .byte #%00100000;--
        .byte #%00101000;--
        .byte #%00000000;--
        .byte #%01000000;--
        .byte #%01000100;--
        .byte #%00000000;--
        .byte #%10000001;--
        .byte #%00000001;--
        .byte #%00000100;--
        .byte #%00110100;--
        .byte #%00110000;--
        .byte #%00000000;--
        .byte #%00001000;--
Methane1

        .byte #%01111000;--
        .byte #%11111111;--
        .byte #%00111110;--
        .byte #%00001100;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00111100;--
        .byte #%00001110;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00111000;--
        .byte #%11111110;--
        .byte #%01110000;--
Methane2
        .byte #%00110000;--
        .byte #%01111110;--
        .byte #%00011100;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00011000;--
        .byte #%00000100;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00010000;--
        .byte #%01111100;--
        .byte #%00100000;--




    org $1FBF
    rorg $FFBF
GoBackToMiddleOfTitleScreen
    sta $1FF9
    jmp DisplayReindeerAndSantaOnTitleScreen
HorizonKernelSubroutineBank4
    sta $1FF8
UpdateScoreSubroutineBank2
    sta $1FF7
UpdateTimerSubroutineBank2
    sta $1FF7
ReadConsoleSwitchesSubroutineBank2
    sta $1FF7
FinalScreenKernelBank4
    sta $1FF9
GameOverScreenKernelBank2
    sta $1FF9
DisplayScoreSubroutineBank2
    sta $1FF9
TitleScreenKernelBank2
    sta $1FF9
MoveSkyItemSubroutineBank2
    sta $1FF7
OverscanBank2
    sta $1FF8
KernelPrepSubroutineBank2
    sta $1FF7
StartNewLevelBank2
    sta $1FF7
SwitchToBank2MusicSubroutine
    sta $1FF8
    nop
    nop
    nop
ScrollSubroutineBank0
        sta $1FF7               ;$FFF2, $FFF3, $FFF4
Ret
        rts                     ;$FFF5


    org $1FFC
    rorg $FFFC
    .word Start
    .word Start

;---------------------------------------------------------
;---------------------------------------------------------
;---------------------------------------------------------
;------------------B A N K       T W O--------------------
;---------------------------------------------------------
;---------------------------------------------------------
;---------------------------------------------------------


    org $2000
    rorg $F000

Start2
    sta $FFF6

;---------------------------------------------------------
;---------------------------------------------------------
;---------------------------------------------------------

PositionASpriteSubroutineBank2          ;come in with A as horiz position and X as index into RESPx
    sec             ;+2 70
    sta WSYNC
    sta HMCLR           ;+3  3
DivideLoop3
    sbc #15
    bcs DivideLoop3     ;+4/5    7/12...

    eor #7          ;+2  9/...
    asl
    asl
    asl
    asl             ;+8 17/...

    sta HMP0       	;+3 20/...
    sta RESP0            ;+3 23/28/33/38/43/48/53/58/63/68/73
    sta WSYNC           ;+3 0   begin line 2
    jsr Ret2
    jsr Ret2
    jsr Ret2
    jsr Ret2
	jsr Ret2		;+60	60
	sta RESP1		;+3	63

	SLEEP 7

    sta HMOVE
    sta WSYNC           ;+6 76
Ret2
    rts             ;+6  6



;-------------------------------------------------------------------

KernelPrepSubroutine


;---Set FloorItemPtr

    lda ItemFlags
    and #$0F
    tax
    lda FloorItemTableLo,X
    sta FloorItemPtr
    lda FloorItemTableHi,X
    sta FloorItemPtr+1


;---Set PlayerDataPtr up correctly
    lda GameFlags
    and #ANIMATESANTA_BIT
    beq DoNotAnimateSanta

    lda SantaAnimation
    and #$F0
    sec
    sbc #$10
    bmi ResetSantaFrameCounter
    sta Temp
    lda SantaAnimation
    and #$0F
    ora Temp
    sta SantaAnimation


    jmp SetSantaPointers

ResetSantaFrameCounter
    lda SantaAnimation
    and #$0F
    ora #ANIMATIONDELAY
    sta SantaAnimation

    ;--change the Prot Animation counter
    lda SantaAnimation
    and #$0F
    clc
    adc #1
    sta Temp
    cmp #MAXANIMATIONFRAMES+1
    bne SetNewSantaAnimationCounter
    lda #0
    sta Temp
SetNewSantaAnimationCounter
    lda SantaAnimation
    and #$F0
    ora Temp
    sta SantaAnimation

DoNotAnimateSanta

SetSantaPointers
    lda SantaAnimation
    and #$0F
    tax
    lda SantaDataHi,X
    sta P0DataPtr+1
    lda SantaDataLo,X
    sec
    sbc ProtY
    clc
    adc #P0HEIGHT
    sta P0DataPtr

    ;---set player color ptr
	;--if on santa frame #s 0, 4, 5, or 9 we use different color tables depending on the level

	lda SetSpecialColorFrameTable,X
	bmi SetNormalColorFrame
	asl
	tay
	lda ColorFrameLookup,Y
	sta Temp
	lda ColorFrameLookup+1,Y
	sta Temp+1

	lda Level
	asl
	tay
	iny
	lda (Temp),Y
	sta P0DataColorPtr+1
	dey
	lda (Temp),Y
	jmp AdjustColorFramePtr

ColorFrameLookup
	.word SpecialColorFrame0Table,SpecialColorFrame3Table,SpecialColorFrame4Table

SpecialColorFrame0Table
	.word SantaColor0Level0,SantaColor0Level1,SantaColor0Level2,SantaColor0Level3
SpecialColorFrame3Table
	.word SantaColor3Level0,SantaColor3Level1,SantaColor3Level2,SantaColor3Level3

SpecialColorFrame4Table
	.word SantaColor4Level0,SantaColor4Level1,SantaColor4Level2,SantaColor4Level3

SetSpecialColorFrameTable
	.byte 0,128,128,128,1
	.byte 2,128,128,128,1


SetNormalColorFrame
    lda SantaColorHi,X
    sta P0DataColorPtr+1 
    lda SantaColorLo,X
AdjustColorFramePtr
    sec
    sbc ProtY
    clc
    adc #P0HEIGHT
    sta P0DataColorPtr  ;low byte

    lda GameFlags
    and #ANIMATEOTHER_BIT
    beq DoNotAnimateSkyItemObject

    ;----set SkyItem pointers and update animation frame
    lda ItemFlags
    lsr
    lsr
    lsr
    lsr
    tax
    lda Counter
    and SkyItemAnimationSpeed,X
    bne NoUpdateToSkyItemAnimation
    lda SkyItemAnimation
    and #$0F
    tax
    dex
    stx Temp
    bpl SetSkyItemAnimationFrame
    lda SkyItemAnimation
    lsr
    lsr
    lsr
    lsr
    sta Temp
SetSkyItemAnimationFrame
    lda SkyItemAnimation
    and #$F0
    ora Temp
    sta SkyItemAnimation
NoUpdateToSkyItemAnimation

    ;--set SkyItem pointers
DoNotAnimateSkyItemObject
    lda ItemFlags
    and #$F0
    lsr
    lsr
    lsr         ;sky item flag times two
    tax
    lda SkyItemDataLookup,X
    sta Temp
    lda SkyItemDataLookup+1,X
    sta Temp+1
    lda SkyItemAnimation
    and #$0F
    asl
    tay
    lda (Temp),Y
    sta SkyItemDataPtr
    iny
    lda (Temp),Y
    sta SkyItemDataPtr+1

    txa
    lsr
    tax

    lda SkyItemDataPtr
    sec
    sbc SkyItemY
    clc
    adc SkyItemHeightTable2,X
    sta SkyItemDataPtr

    lda GameFlags
    and #SCROLLPF_BIT
    beq DoNotScrollScreen
    jsr ScrollHorizonObjectsSubroutine  ;scroll the screen :)
DoNotScrollScreen

    ldx Level
    lda HorizonPF0Lo,X
    sta Temp
    lda HorizonPF0Hi,X
    sta Temp+1
    lda HorizonPF1Lo,X
    sta Temp+2
    lda HorizonPF1Hi,X
    sta Temp+3
    lda HorizonPF2Lo,X
    sta Temp+4
    lda HorizonPF2Hi,X
    sta Temp+5

    lda HorizonColor,X
    sta COLUPF

    lda #PLAYAREAHEIGHT+P0HEIGHT+1
    sec
    sbc ProtY
;   adc #P0HEIGHT
    sta SantaTemp

    lda ItemFlags
    lsr
    lsr
    lsr
    lsr
    tax

    lda #PLAYAREAHEIGHT
    sec
    sbc SkyItemY
    adc SkyItemHeightTable2,X
    sta SkyItemTemp

    lda MSOX
    jsr PositionASpriteSubroutineBank2

    ;--Get HighSkyObject
;    lda #150
;    ldx #1
;    jsr PositionASpriteSubroutineBank2

    ldx #0
	stx CTRLPF		;playfield does not have priority

    jmp SwitchToBank1


;---------------------------------------------------------




UpdateTimerSubroutine

    dec Counter

;    lda GameFlags
;    and #BETWEENLEVELS_BIT
;    bne NoUpdateEnergy

    lda Counter
    bne NoUpdateEnergy
    lda EnergyExtraLives
    beq NoUpdateEnergy
    sec
    sbc #$10
    sta EnergyExtraLives
NoUpdateEnergy
;   jmp SwitchToBank1





;-------------------------------------------------------------------

ReadConsoleSwitchesSubroutine
    ;--note: also read fire button here and start game if on title screen
    lda GameFlags
    and #KERNELTYPE_BITS
    cmp #TITLESCREEN
    bne CantStartGameWithFireIfNotOnTitleScreen
    lda INPT4
    bpl SwitchGameStatusToLevelRunningWithFire
NotHittingFireOnTitleScreen
CantStartGameWithFireIfNotOnTitleScreen
    lda SWCHB
	IF TESTVERSION = 1
    and #RESET|SELECT
    eor #RESET|SELECT
	ELSE
	and #RESET
	eor #RESET
	ENDIF
    bne ASwitchIsPressed
;    lda #0
    sta ConsoleSwitchTimer
ASwitchIsPressed
    lda ConsoleSwitchTimer
    bne DontReadSwitchThisFrame
    ;--read RESET
    lsr SWCHB
    bcs RESETNotPressed
    ;--every time RESET is pressed reset all music vars
SwitchGameStatusToLevelRunningWithFire
    lda #0
    sta NoteLengthC0
    sta TempoCounter
	sta GlobalVolume
	sta Level
	sta SkyItemAnimation



    lda GameFlags
    and #KERNELTYPE_BITS
    eor #TITLESCREEN
    beq SwitchGameStatusToLevelRunning
    ;--else switch to title screen
;    lda GameFlags
;    and #<(~KERNELTYPE_BITS|SCROLLPF_BIT|ANIMATESANTA_BIT|ANIMATEOTHER_BIT|PLAYERCONTROL_BIT|MOVESANTA_BIT)
;    ora #TITLESCREEN
	lda #TITLESCREEN
    sta GameFlags
    lda #<[JingleBells-2]
    sta SongPtr
    lda #>[JingleBells-2]
    sta SongPtr+1
    lda #30
    sta ConsoleSwitchTimer

;	lda #0
;	sta ScoreAdder
;	sta ScoreAdder+1
    jmp SwitchToBank1


RESETNotPressed
    ;--read SELECT
	IF TESTVERSION = 1
    lda SWCHB
    lsr
    lsr
    bcs SELECTNotPressed
    inc Level
    lda Level
    and #3
	ELSE
	jmp SELECTNotPressed
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	ENDIF
SwitchGameStatusToLevelRunning	;when arriving here from elsewhere A = 0
    sta Level
UserRestartedLevel
    ;--reset play variables
    lda #0
    sta ForcedActionCounter

	ldx #4
EraseScoresLoop
	sta ScoreAdder,X
	dex
	bpl EraseScoresLoop

    sta NewDataCounter  ;number of reindeer stored in top two bits


    lda GameFlags
    and #<~KERNELTYPE_BITS
    ora #GAMEKERNEL
    sta GameFlags
;    lda EnergyExtraLives
;    and #$F0
;    ora #INITIALEXTRALIVES
	lda #INITIALEXTRALIVES|$F0
    sta EnergyExtraLives


    lda #30
    sta ConsoleSwitchTimer
    jmp StartNewLevel

SELECTNotPressed
    .byte $2C
DontReadSwitchThisFrame
    dec ConsoleSwitchTimer

;	jmp SwitchToBank1
;---------------------------------------------------------

UpdateScoreSubroutine

    lda ScoreAdder+1
    bne IncreaseScoreSlow
    lda ScoreAdder
    bne IncreaseScoreFast
    jmp SwitchToBank1
IncreaseScoreFast
    ldx #0
    stx Temp
    inx
    stx Temp+1
    bne IncreaseScore   ;branch always
IncreaseScoreSlow
    lda #$05
    sta Temp
    lda #0
    sta Temp+1
IncreaseScore
    sed
    lda ScoreAdder+1
    sec
    sbc Temp
    sta ScoreAdder+1
    lda ScoreAdder
    sbc Temp+1
    sta ScoreAdder

    lda Score+2
    clc
    adc Temp
    sta Score+2
    lda Score+1
    adc Temp+1
    sta Score+1
    lda Score
    adc #0
    sta Score
    cld


    jmp SwitchToBank1

;---------------------------------------------------------

MoveSkyItemSubroutine

;---Update SkyItemX and SkyItemY position

    lda ItemFlags
    and #$F0
    beq NoUpdateSkyItemPos
    cmp #LIGHTNING
    beq MoveLightning
    ;-and only if SkyItemX is > eight.
    lda #8
    cmp SkyItemX
    bcs MoveSkyItemOffScreen
    lda #200
    cmp SkyItemX
    bcc MoveSkyItemOffScreen
    lda ItemFlags
    and #$F0
    lsr
    lsr
    lsr
    lsr
    tax
    lda ActionDataTableLo,X
    sta Temp
    lda ActionDataTableHi,X
    sta Temp+1
    ldy #0
FindActionData
    lda (Temp),Y
    iny
    iny
    cmp SkyItemX        ;is SkyItemX > ActionData.condition?
    bcs FindActionData
    dey
    lda (Temp),Y        ;get ActionData.action
    ;--first update X position
    and #%00000111
    tax
    lda Counter
    and #1
    sta Temp+2
UpdateSkyItemX
    lda SkyItemX
    sec
    sbc Temp+2
    sta SkyItemX
    dex
    bpl UpdateSkyItemX
    ;--next update Y position
    lda (Temp),Y
    bpl SkyItemSink
    and #%00111000
    beq NoUpdateSkyItemY
    lsr
    lsr
    lsr
    tax
RaiseSkyItem
    lda SkyItemY
    clc
    adc Temp+2
    sta SkyItemY
    dex
    bne RaiseSkyItem
    beq DoneUpdateSkyItemPos    ;branch always
SkyItemSink
    and #%00111000
    beq NoUpdateSkyItemY
    lsr
    lsr
    lsr
    tax
SinkSkyItem
    lda SkyItemY
    sec
    sbc Temp+2
    sta SkyItemY
    dex
    bne SinkSkyItem
    .byte $2C   ;skip next instruction
MoveSkyItemOffScreen
    dec SkyItemX
DoneUpdateSkyItemPos
NoUpdateSkyItemY
NoUpdateSkyItemPos

;--check here if SkyItem has reached left edge of screen:
    lda SkyItemX
    cmp #<-8
    bne SkyItemStillOnScreen
    lda ItemFlags
    and #$0F        ;clear SkyItemFlag
    sta ItemFlags
SkyItemStillOnScreen
    jmp SwitchToBank1

MoveLightning
    lda SkyItemAnimation
    and #$0F
    bne NoUpdateSkyItemPos
    lda #<-8
    sta SkyItemX
    lda #70
    sta SkyItemY
    lda ItemFlags
    and #$0F
    sta ItemFlags
    jmp SwitchToBank1




;---------------------------------------------------------

ScrollHorizonObjectsSubroutine

    lda ScrollSpeedCounter
    and #%00001100
    lsr
    lsr
    tay
    lda ScrollFractionalAddTable,Y
    clc
    adc MSOX+1
    sta MSOX+1
    bcs UpdateMSOXandLSOX
    jmp DoneWithMSOXandLSOX
UpdateMSOXandLSOX
    dec MSOX
    lda MSOX
    cmp #255
    bne DoneWithMSOX
    lda #159
    sta MSOX
DoneWithMSOX
    dec LSOX
    lda LSOX
    cmp #255
    bne DoneWithLSOX
    lda #159
    sta LSOX
DoneWithLSOX

    lda MSOX
    cmp #20
    bne NoMSOSwitch
    lda HorizonObjectFlags
    ora #MSOLEFT_BIT
    sta HorizonObjectFlags
NoMSOSwitch
    lda LSOX
    cmp #20
    bne NoLSOSwitch
    lda HorizonObjectFlags
    ora #LSOLEFT_BIT
    sta HorizonObjectFlags
NoLSOSwitch

    lda HorizonObjectFlags
    and #MSOLEFT_BIT
    beq NoNewMSO
    lda MSOX
    bne NoNewMSO
    ;--so, switch to new MSO, set to new starting position, and clear the "side" flag
    lda #7
    sta MSOX
    lda HorizonObjectFlags
    and #<~MSOLEFT_BIT
    sta HorizonObjectFlags  ;clear "side" flag
    ;--now increment counter
    and #MSOCOUNTER_BITS
    clc
    adc #MSOCOUNTER_INC
    and #MSOCOUNTER_BITS    ;so counter rolls (at 8)
    sta Temp
    lda HorizonObjectFlags
    and #<~MSOCOUNTER_BITS
    ora Temp
    sta HorizonObjectFlags
    and #MSOCOUNTER_BITS
    lsr
    lsr
    lsr
    tay
    ldx Level
    lda MidSkyObjectPointerTablesLo,X
    sta Temp
    lda MidSkyObjectPointerTablesHi,X
    sta Temp+1
    lda (Temp),Y
    tay
    lda MidSkyObjectPtrTableLo,Y
    sta MidSkyDataPtr
    lda MidSkyObjectPtrTableHi,Y
    sta MidSkyDataPtr+1
NoNewMSO
    lda HorizonObjectFlags
    and #LSOLEFT_BIT
    beq NoNewLSO
    lda LSOX
    bne NoNewLSO
    ;--so, switch to new LSO, set to new starting position, and clear the "side" flag
    lda #7
    sta LSOX
    lda HorizonObjectFlags
    and #<~LSOLEFT_BIT
    sta HorizonObjectFlags      ;clear "side" flag
    ;--now increment counter (which rolls at 8)
    and #LSOCOUNTER_BITS
    clc
    adc #LSOCOUNTER_INC
    and #LSOCOUNTER_BITS        ;so it rolls
    sta Temp
    lda HorizonObjectFlags
    and #<~LSOCOUNTER_BITS
    ora Temp
    sta HorizonObjectFlags
    and #LSOCOUNTER_BITS
    tay
    ldx Level
    lda LowSkyObjectPointerTablesLo,X
    sta Temp
    lda LowSkyObjectPointerTablesHi,X
    sta Temp+1
    lda (Temp),Y
    tay
    lda LowSkyObjectPtrTableLo,Y
    sta LowSkyDataPtr
    lda LowSkyObjectPtrTableHi,Y
    sta LowSkyDataPtr+1
NoNewLSO
DoneWithMSOXandLSOX
    lda HorizonObjectFlags
    and #MSOLEFT_BIT
    bne LeftSideMaskMSO
    ;--right side mask
    lda MSOX
    cmp #9
    bcs NoMaskMSO
    tax
    lda RightSideMaskTable,X
    sta MSOMask
    jmp LSOMaskSetup
LeftSideMaskMSO
    lda MSOX
    cmp #9
    bcs NoMaskMSO
    tax
    lda LeftSideMaskTable,X
    .byte $2C
NoMaskMSO
    lda #255
    sta MSOMask
LSOMaskSetup
    lda HorizonObjectFlags
    and #LSOLEFT_BIT
    bne LeftSideMaskLSO
    ;--right side mask
    lda LSOX
    cmp #9
    bcs NoMaskLSO
    tax
    lda RightSideMaskTable,X
    sta LSOMask
    jmp DoneWithMaskSetup
LeftSideMaskLSO
    lda LSOX
    cmp #9
    bcs NoMaskLSO
    tax
    lda LeftSideMaskTable,X
    .byte $2C
NoMaskLSO
    lda #255
    sta LSOMask
DoneWithMaskSetup

    rts

;---------------------------------------------------------


;---------------------------------------------------------

StartNewLevel

;--misc level setup
    ldy #255
    sty MSOMask
    sty LSOMask

    ;--clear PF data
    iny
    ldx #NUMBEROFBANDS*6
ClearPFDataLoop
    sty PF0Data-1,X
    dex
    bne ClearPFDataLoop


 ;   ldx #0
    stx ItemFlags
    stx JumpIndex

    stx FloorItemX  ;put FloorItem offscreen...is this necessary?
    stx SkyItemY    ;put SkyItem offscreen.

    ;--clear music vars
    stx TempoCounter
    stx GlobalVolume
    stx NoteLengthC0


    ;--set up level indices.  If number of reindeer = 1 then leave number of reindeer at 1
    ;   and set to start play at checkpoint mid-level
    ;   if number of reindeer is 2 or zero then set number of reindeer to zero
    ;   and set to start play at beginning of level
    ;   Also: update horizon objects also...

    lda NewDataCounter
    asl
    asl
    bcc StartAtBeginningOfLevel
    ;--else start at checkpoint
    ldx Level
    lda CheckPointItemTable,X
    sta LevelItemIndex
    lda CheckPointHorizonObjectTable,X
    sta HorizonObjectFlags
    lda CheckPointPFTable,X
    sta LevelIndex

    bne DoneSettingUpLevelIndices	;branch always

StartAtBeginningOfLevel
;    ldx #0			;X already zero
    stx LevelItemIndex
    stx HorizonObjectFlags
;    stx NewDataCounter  ;set to zero
    stx LevelIndex      ;we start at the beginning of the level



	lda NewDataCounter
	and #HAT_BIT
	sta NewDataCounter	;clear this var except for hat flag


DoneSettingUpLevelIndices

    lda #INITIALPROTHEIGHT      ;this is distance (in pixels) from floor
                    ;109 is as high as the player can go.
    sta ProtY

    lda NewDataCounter
    and #<~NEWDATA_BITS
    ora #1          ;set the counter for pulling new data in to scroll
    sta NewDataCounter  ;setting it to 1 will cause the scroll routine to pull
                ;in new data immediately

    lda #GAMEKERNEL|ANIMATESANTA_BIT|MOVESANTA_BIT|ANIMATEOTHER_BIT
    sta GameFlags

;--position player
    lda #INITIALPROTX
    sta ProtX

;--Set Level Data
    ldx Level
    ;--Get HighSkyObject
    lda HighSkyObjectPtrTableHi,X
    sta HighSkyDataPtr+1
    lda HighSkyObjectPtrTableLo,X
    sta HighSkyDataPtr



    ;---Set pointer to initial MidSkyObject
    lda HorizonObjectFlags
    and #MSOCOUNTER_BITS
    lsr
    lsr
    lsr
    tay

    lda MidSkyObjectPointerTablesLo,X
    sta Temp
    lda MidSkyObjectPointerTablesHi,X
    sta Temp+1
    lda (Temp),Y
    tay
    lda MidSkyObjectPtrTableLo,Y
    sta MidSkyDataPtr
    lda MidSkyObjectPtrTableHi,Y
    sta MidSkyDataPtr+1

    ;---set pointer to LowSkyObject
    lda HorizonObjectFlags
    and #LSOCOUNTER_BITS
    tay
    lda LowSkyObjectPointerTablesLo,X
    sta Temp
    lda LowSkyObjectPointerTablesHi,X
    sta Temp+1
    lda (Temp),Y
    tay
    lda LowSkyObjectPtrTableLo,Y
    sta LowSkyDataPtr
    lda LowSkyObjectPtrTableHi,Y
    sta LowSkyDataPtr+1

    ;--set music pointer
    lda SongTableLo,X
    sta SongPtr
    lda SongTableHi,X
    sta SongPtr+1

    lda MidSkyObjectPositionTable,X ;get MSO X position
    sta MSOX
    lda LowSkyObjectPositionTable,X ;get LSO X position
    sta LSOX

    lda ScrollSpeedCounter
    and #%11110000
    ora InitialScrollSpeedTable,X   ;set initial scrolling speed (and scroll counter)
    sta ScrollSpeedCounter

    lda LevelPFDataLo,X ;get low byte of level PF data address
    sta LevelPFDataPtr
    lda LevelPFDataHi,X ;get high byte of level PF data addy
    sta LevelPFDataPtr+1

    lda EnergyExtraLives
    ora #$F0
    sta EnergyExtraLives




    jmp SwitchToBank1

;---------------------------------------------------------









;---------------------------------------------------------




ScrollSubroutine


StartScroll
    lda ScrollSpeedCounter
    and #%00000011
    sec
    sbc #1          ;decrement scroll counter
    bmi DoScroll
    sta Temp
    lda ScrollSpeedCounter
    and #%11111100
    ora Temp
    sta ScrollSpeedCounter
    jmp DoneWithScroll
DoScroll    ;--reset Scroll Counter, then scroll data in.
    lda ScrollSpeedCounter
    and #%00001100
    lsr
    lsr
    sta Temp
    lda ScrollSpeedCounter
    and #%11111100
    ora Temp
    sta ScrollSpeedCounter
BeginScroll
    inc NewDataCounter
    lda NewDataCounter
    and #NEWDATA_BITS
    cmp #8
    beq NewDataScrollRoutine
    ldy LevelIndex
    lda (LevelPFDataPtr),Y
    jmp GetBandData
NewDataScrollRoutine
    lda NewDataCounter
    and #<~NEWDATA_BITS
    sta NewDataCounter
WrapScroll
    inc LevelIndex
    ldy LevelIndex
    lda (LevelPFDataPtr),Y
    bpl GetBandData         ;if bit 7 == 0, then no item data to load and level not over
    cmp #255            ;level PF data = 255 means level wraps and continue scrolling!
    bne NoLevelWrap
    sta LevelIndex          ;sets LevelIndex to 255
    lda #0
    sta LevelItemIndex
    iny
    lda (LevelPFDataPtr),Y
    sta Temp
    iny
    lda (LevelPFDataPtr),Y
    sta LevelPFDataPtr+1
    lda Temp
    sta LevelPFDataPtr
    jmp WrapScroll
NoLevelWrap
    sta Temp+2          ;save new PF data
    ldx Level
    lda LevelItemDataLo,X       ;low byte of LevelItem data
    sta Temp
    lda LevelItemDataHi,X       ;high byte of LevelItem data
    sta Temp+1
    ldy LevelItemIndex
    lda (Temp),Y            ;get next LevelItem
    inc LevelItemIndex      ;move LevelItemIndex up by one
    jsr ItemInitialSetup
    lda Temp+2          ;restore new PF data
GetBandData
    and #%01111111
    cmp #NONTRIVIALPRESETS      ;preset #s #NONTRIVIALPRESETS and greater have a different storage method.
    bcc GetBandDataRegular
    jsr GetBandDataCompressed
    jmp InitScrollRoutine
GetBandDataRegular
    tay
    lda Band0Presets,Y
    sta Temp
    lda Band1Presets,Y
    sta Temp+1
    lda Band2Presets,Y
    sta Temp+2
    lda Band3Presets,Y
    sta Temp+3
    lda Band4Presets,Y
    sta Temp+4
    lda Band5Presets,Y
    sta Temp+5
    lda Band6Presets,Y
    sta Temp+6
    lda Band7Presets,Y
    sta Temp+7
InitScrollRoutine
    ldx #NUMBEROFBANDS
ScrollRoutine
    lda NewDataCounter
    and #NEWDATA_BITS
    tay
    lda Temp-1,X
    cpy #0
    beq NoAdjustToPFData
SetupBandDataLoop
    asl
    dey
    bne SetupBandDataLoop
NoAdjustToPFData
    asl
    ror PF5Data-1,X
    rol PF4Data-1,X
    ror PF3Data-1,X
    clc
    lda #%00001000
    and PF3Data-1,X
    beq PF2Rotate
    sec
PF2Rotate
    ror PF2Data-1,X
    rol PF1Data-1,X
    ror PF0Data-1,X
    dex
    bne ScrollRoutine

;    jsr MoveFloorItem	;--inline now, to save ROM space.
MoveFloorItem
    lda ItemFlags
    and #$0F
    beq DoneWithFloorItem
    lda FloorItemX
    sec
    sbc #4
    sta FloorItemX
    cmp #8
    bcs DoneWithFloorItem
    lda ItemFlags       ;if floor item is at left edge, then kill it.
    and #$F0
    sta ItemFlags
DoneWithFloorItem
;    rts
DoneWithScroll
    jmp SwitchToBank1

;---------------------------------------------------------

GetBandDataCompressed   ;A holds preset #
    sec
    sbc #NONTRIVIALPRESETS      ;get offset back to zero :)
    tay
    lda CompressedBandPresets,Y ;now grab compressed data
    ldx #NUMBEROFBANDS-1
CompressedBandLoop1
    ldy #0
    rol
    bcc EmptyBand1
    ldy #%11111111
EmptyBand1
    sty Temp,X
    dex
    bpl CompressedBandLoop1
    rts

;---------------------------------------------------------






;---------------------------------------------------------

ItemInitialSetup    ;modifies A, X, Y, FloorItemX, and SkyItemX
    ;--A holds new item coming in
    sta Temp+5
    and #$0F
    beq ItsASkytem
    lda ItemFlags
    and #$F0
    ora Temp+5
    sta ItemFlags
    lda #164    ;initial X-pos of FloorItem
    sta FloorItemX
    jmp DoneSettingUpItem
ItsASkytem
    lda ItemFlags
    and #$0F
    ora Temp+5
    sta ItemFlags
    lda #160    ;initial X-pos of SkyItem
    sta SkyItemX
    lda ItemFlags
    and #$F0
    lsr
    lsr
    lsr
    lsr
    tax
    lda SkyItemInitY,X  ;get low byte of initial position
    sta SkyItemY            ;set initial Y position.
    lda SkyItemMaxFrames,X
    asl
    asl
    asl
    asl
    ora SkyItemMaxFrames,X
    sta SkyItemAnimation


    lda Temp+5
    cmp #LIGHTNING
    bne DoneSettingUpItem
    lda Counter
    lsr
    lsr
    clc
    adc #32
    sta SkyItemX



DoneSettingUpItem
    rts



LevelPlayfieldData      ;note: items can appear no oftener than every five PF data bytes.
                ;I think I will group these in fives, since every 5 bytes is a full screen
Level0
    .byte 91,91,92,93,94
    .byte 95,96,96,96,95
    .byte 8,37,38,39,40
    .byte 90,41,42,90
    .byte 43,44,90,45,45
    .byte 95,95,94,93,92
    .byte 91,90,90              ;level index=31 at end of this line

Level0Repeat
    .byte 90,128|90             ;cocoa
    .byte 91,91,91,92,92
    .byte 93,93,94,94,94
    .byte 95,95,128|95,94,94        ;snow flurry
    .byte 93,93,92,92,91
    .byte 91,90,128|90,90,91        ;cookies

    .byte 91,91,92,93,94
    .byte 95,95,96,96,96
    .byte 96,6,128|90           ;reindeer #1
    .byte 10,97,96,95,95
    .byte 94,93,92,93,94            ;checkpoint here at index=79 (I think) - should be the "92"

    .byte 95,95,96,96,97
    .byte 97,97,9,10,9
    .byte 90,128|10,97,9,90         ;snowflake
    .byte 46,90,10|128,9,90         ;evil bird
    .byte 10,97,9,90,10
    .byte 97,7,92,128|92,93		;flying hat

    .byte 93,93,94,94,95
    .byte 96,96,95,94,93
    .byte 128|90,128|90,93,93,94        ;reindeer1 & abominable snowman
    .byte 94,95,95,95,94
    .byte 8,90,128|90,90,90         ;bell
    .byte 255       ;end of level 0
    .word Level0Repeat

Level0ItemData
    .byte CANDYCANE,SNOWFLURRY,COOKIES,REINDEER1,SNOWFLAKE,EVILBIRD,SNOWFLAKE,REINDEER1,LURKINGSNOWMAN,BELL


Level1
    .byte 90,128|103,103,103,103    ;candy cane
    .byte 103,128|102,102,101,101	;snow flurry
    .byte 100,112,93,94,95
    .byte 95,95,96,96,97
    .byte 97,97,98,98,128|98        ;snowflake

    .byte 98,97,94,94,94
    .byte 109,109,128|109,109,109       ;elf
    .byte 93,95,93,111,112
    .byte 112,112,99,108,108
    .byte 113,113,128|113,128|99,99 ;snowflake, ornament

    .byte 108,113,113,108,108
    .byte 113,113,104,128|104,104       ;cocoa
    .byte 113,99,108,128|123,123        ;reindeer
    .byte 114,128|115,116,117,118       ;bell
    .byte 118,128|99,108,113,108        ;a. snowman

    .byte 113,128|99,113,108,113        ;coal
    .byte 99,128|99,108,108,113     	;a. snowman
    .byte 114,115,116,126,119
    .byte 124,120,125,128|121,122       ;snow flurry
    .byte 122,121,125,120,124

    .byte 119,117,117,116,115
    .byte 115,114,90,128|123,128|123	;sleigh piece,cookies
    .byte 114,115,116,126,119
    .byte 124,120,125,121,122
    .byte 122,121,128|125,120,124       ;snow flurry

    .byte 119,117,128|117,116,115		;toysack
    .byte 115,114,123,90,123
    .byte 114,115,116,126,119
    .byte 124,120,125,121,122
    .byte 122,110,111,112,99

    .byte 128|123,123,128|114,114,115       ;snowflake, right arrow
    .byte 116,126,119,124,120
    .byte 125,121,122,94,128|95     ;snowspeeder
    .byte 96,97,98,98,90
    .byte 128|90,128|103,90,103,90  ;gift, reindeer

    .byte 128|102,90,103,90,128|103     ;a. snowman, flying hat
    .byte 255
    .word Level1
Level1ItemData
    .byte CANDYCANE,SNOWFLURRY
	.byte SNOWFLAKE ;snowflake when through with testing
	.byte ELF,SNOWFLAKE,ORNAMENT,COCOA,REINDEER1,BELL
    .byte LURKINGSNOWMAN,COAL,LURKINGSNOWMAN,SNOWFLURRY
    .byte SLEIGH1,COOKIES,SNOWFLURRY,TOYSACK,SNOWFLAKE,RIGHTARROW,SNOWSPEEDER,GIFT,REINDEER2,LURKINGSNOWMAN
	.byte FLYINGHAT

Level2
    .byte 91,91,92,93,94        ;hill
    .byte 94,93,92,91,128|90    ;hill (tornado)
    .byte 18,16,17,90,16        ;low town
    .byte 17,90,5,1,2           ;low town
    .byte 3,15,90,90,128|15     ;street lamps (spring)

    .byte 32,33,90,90,128|90,91,91  ;hill (milk)
    .byte 92,93,94,95,95        ;hill
    .byte 96,97,98,98,95        ;hill
    .byte 92,91,26,28,29        ;high town
    .byte 91,27,21,128|28,29    ;high town (tornado)

    .byte 91,91,92,95,90        ;small hill
    .byte 15,90,1,2,3           ;low town
    .byte 90,4,128|90,128|90,4  ;low town (reindeer, gift)
    .byte 90,19,20,18,19        ;low town
    .byte 20,14,18,16,17        ;low town

    .byte 90,90,128|90,91,91    ;hill (coal) <-checkpoint at beginning of this line.
    .byte 92,92,93,94,95        ;hill
    .byte 95,128|95,96,97,98    ;hill (evil bird)
    .byte 97,7,92,22,23     ;big house on hill
    .byte 24,25,91,90,128|90    ;big house on hill and flat (left arrow)

    .byte 92,93,93,90,128|90    ;extra flat to squeeze in (milk)

    .byte 92,93,94,93,92        ;small hill
    .byte 91,90,128|14,4,16     ;low town (ornament)
    .byte 17,90,4,16,17     		;low town
    .byte 97,97,98,98,98        ;cliff
    .byte 128|28,29,27,27,27    ;high town (list)

    .byte 91,91,27,28,29        ;high town
    .byte 90,128|18,34,35,14    ;low factory (cocoa)
    .byte 0,90,0,90,90,128|90   ;telephone poles (spring)
    .byte 128|0,90,0,90,128|90  ;telephone poles and beginning of hill (elf, milk)
    .byte 91,92,94,96,91        ;hill

    .byte 30,31,91,27,27        ;high business and trees
    .byte 91,28,29,128|26,91    ;high town (evil bird)
    .byte 91,26,91,28,29        ;high town
    .byte 91,92,91,90,128|90    ;rolling hills (toysack)
    .byte 90,91,21,22,23        ;high house

    .byte 24,25,91,27,91        ;high house and tree
    .byte 91,92,128|91,90,128|90    ;rolling hills (reindeer, candycane)
    .byte 90,91,26,28,29        ;high house
    .byte 91,91,90,14,90        ;flat w/ trashcan
    .byte 4,90,19,20,90     ;low town

    .byte 90,90,1,2,3           ;low town
    .byte 90,15,128|90,90           ;street lamp (flying hat)
    .byte 255
    .word Level2
Level2ItemData

    .byte TORNADO,COMPRESSEDSPRING,MILK,TORNADO,REINDEER2,GIFT,COAL
    .byte EVILBIRD,LEFTARROW,MILK,ORNAMENT,LIST,COCOA,COMPRESSEDSPRING,ELF,MILK
    .byte EVILBIRD,TOYSACK,REINDEER2,CANDYCANE
	.byte FLYINGHAT
Level3
    .byte 90,128|90,90         ;flat (candycane)
    .byte 13,13,48,48,95        ;city scape
    .byte 11,92,63,64,12        ;city scape
    .byte 11,90,47,96,96        ;city scape
    .byte 48,13,13,90,90        ;city scape
    .byte 128|90,65,66,67,68    ;city scape (spring)

    .byte 56,69,70,71,48        ;city scape
    .byte 12,11,95,95,56        ;city scape
    .byte 72,73,128|74,63,64    ;city scape (snowflake)
    .byte 47,47,48,48,95        ;city scape
    .byte 12,93,48,96,91        ;city scape

    .byte 75,76,77,78,79        ;el
    .byte 80,128|78,79,80,91    ;el (snowflake)
    .byte 78,79,80,78,79        ;el
    .byte 80,78,79,80,78        ;el
    .byte 79,80,91,91,128|90    ;el (reindeer)
    .byte 90,128|90,91      ;el (spring) checkpoint is section with spring here.

    .byte 75,76,77,78,79        ;el
    .byte 80,78,128|79,80,128|78    ;el (lightning, lightning)
    .byte 79,80,128|78,79,128|80    ;el (lightning, lightning)
    .byte 78,79,80,78,79        ;el
    .byte 80,78,79,80,128|91    ;el (lightning)

    .byte 48,96,93,49,72        ;cityscape
    .byte 73,74,95,95,13        ;cityscape
    .byte 13,90,90,128|90,90    ;cityscape (bell)
    .byte 92,13,48,96,90        ;cityscape
    .byte 11,128|56,47,57,58    ;cityscape/factory (toxic cloud)

    .byte 59,56,13,92,96        ;factory
    .byte 60,61,62,48,13        ;factory
    .byte 47,95,97,12,91        ;cityscape
    .byte 49,50,51,52,53        ;factory
    .byte 54,55,128|47,13,97    ;factory (toxic cloud)

    .byte 65,66,67,68,90        ;cityscape
    .byte 92,13,48,96,13        ;cityscape
    .byte 13,47,95|128,97,128|12    ;cityscape (lightning, lightning)
    .byte 94,65,128|66,67,68    ;cityscape (hat)
    .byte 92,13,47,47,92        ;cityscape

    .byte 13,48,96,95,95        ;incline
    .byte 81,82,105,105,128|105 ;subway entrance (cookies)
    .byte 105,85,105,105,85     ;subway
    .byte 105,105,128|105,85,85 ;subway (left arrow)
    .byte 105,105,128|83,84,95  ;subway exit (reindeer)

    .byte 96,96,95,81,82        ;subway entrance
    .byte 105,105,86,105,105    ;subway
    .byte 86,86,128|105,105,85  ;subway (sleigh piece #2)
    .byte 105,105,128|105,83,84 ;subway exit (milk)
    .byte 95,95,96,96,49        ;cityscape

    .byte 49



    .byte 255
    .word Level3
Level3ItemData
    .byte CANDYCANE,COMPRESSEDSPRING,SNOWFLAKE,SNOWFLAKE
	.byte REINDEER3,COMPRESSEDSPRING
    .byte LIGHTNING,LIGHTNING,LIGHTNING,LIGHTNING,LIGHTNING
    .byte BELL,METHANE,METHANE,LIGHTNING,LIGHTNING,FLYINGHAT
    .byte COOKIES,REINDEER3,LEFTARROW,SLEIGH2,MILK



;---------------------------------------------------------

CompressedBandPresets
    .byte %00000000     ;90
    .byte %10000000     ;91
    .byte %11000000     ;92
    .byte %11100000     ;93
    .byte %11110000     ;94
    .byte %11111000     ;95
    .byte %11111100     ;96
    .byte %11111110     ;97
    .byte %11111111     ;98
    .byte %00000001     ;99
    .byte %00000011     ;100
    .byte %00000111     ;101
    .byte %00001111     ;102
    .byte %00011111     ;103
    .byte %00010001     ;104    two tunnels (wide low, wide high)
    .byte %00000100     ;105    subway roof
    .byte %00011001     ;106    two tunnels (wide low, narrow high) - unused
    .byte %00001001     ;107    two tunnels (very wide low, narrow high) - unused
    .byte %00100001     ;108    two tunnels (narrow low, very wide high)
    .byte %11110001     ;109    one tunnel #1
    .byte %11100001     ;110    one tunnel #2
    .byte %11000001     ;111    one tunnel #3
    .byte %10000001     ;112    one tunnel #4
    .byte %00110001     ;113
    .byte %00110000     ;114
    .byte %00011000     ;115
    .byte %00001100     ;116
    .byte %00000110     ;117
    .byte %00000011     ;118
    .byte %10000110     ;119
    .byte %11000011     ;120
    .byte %11100001     ;121
    .byte %11110001     ;122
    .byte %00100000     ;123
    .byte %10000010     ;124
    .byte %11000001     ;125
    .byte %00000100     ;126

;---------------------------------------------------------

;---Preset Playfield Tables follow below
;   plan right now is for (100)- make that 90 - presets, at 10 bands each that will require 1000 bytes!
;
;   --New Plan!--
;   First #NONTRIVIALPRESETS presets (0-89) are non-trivial band-sets
;   All following are trivial band-sets; i.e., ones where each band is either completely full
;       or completely empty.
;   Doesn't matter (or, to be precise, I don't think it will matter)
;   if page boundaries are crossed, so let's just make this the last 1000 bytes.
;   $FFFF-1000=$FC00 approximately
;   The order of these things is very important!
;   All descriptions will be found after the preset for band zero.
;


    ;    0 = Telephone pole -   done
    ;    1 = house #1 left  -   done
    ;    2 = house #1 middle    -   done
    ;    3 = house #1 right -   done
    ;    4 = car            -   done
    ;    5 = tree #1        -   done
    ;    6 = R overhang     -   done
    ;    7 = steep downslope #1 -   done
    ;    8 = steep downslope #2 -   done
    ;    9 = pillar left        -   done    tall
    ;   10 = pillar right       -   done    tall
    ;   11 = downtown building #1 (tall)    - done
    ;   12 = downtown building #2 (medium)  - done
    ;   13 = downtown building #3 (short)   - done
    ;   14 = trashcan       -   done
    ;   15 = street lamp        -   done
    ;   16 = house #2 left  -   done
    ;   17 = house #2 right -   done
    ;   18 = fence          -   done
    ;   19 = house #3 left  -   done
    ;   20 = house #3 right -   done
    ;   21 = dog house      -   done    ;tall here through 31
    ;   22 = big house part 1   -   done
    ;   23 = big house part 2   -   done
    ;   24 = big house part 3   -   done
    ;   25 = big house part 4   -   done
    ;   26 = mailbox        -   done
    ;   27 = tree #2        -   done
    ;   28 = house #4 left  -   done
    ;   29 = house #4 right -   done
    ;   30 = business w/ gar L  -   done
    ;   31 = business w/ gar R  -   done    ;--all above are from "Re:Oops... (or Sprite Mania - part 6), Mon Nov 28, 2005 10:45 PM"
    ;   32 = burb fence L       -   done
    ;   33 = burb fence R       -   done
    ;   34 = house #5 L     -   done
    ;   35 = house #5 R     -   done
    ;   36 = santa fence L  -   done
    ;   37 = santa wkshop 1 -   done
    ;   38 = santa wkshop 2 -   done
    ;   39 = santa wkshop 3 -   done
    ;   40 = santa wkshop 4 -   done
    ;   41 = santa barn L       -   done
    ;   42 = santa barn R       -   done
    ;   43 = santa house L  -   done
    ;   44 = santa house R  -   done
    ;   45 = santa fence R  -   done
    ;   46 = short pillar       -   done
    ;   47 = city building #4 (med) -   done
    ;   48 = city building #5 (med) -   done
    ;   49 = city building #6 (tall)    -   done
    ;   50-55 = large factory       -   done
    ;   56 = smokestack         -   done
    ;   57-59 = small factory #1    -   done
    ;   60-62 = small factory #2    -   done
    ;   63-64 = gothic #1       -   done
    ;   65-68 = gothic #2       -   done
    ;   69-71 = art deco #1     -   done
    ;   72-74 = art deco #2     -   done
    ;   75-77 = el engine       -   done
    ;   78-80 = el car          -   done
    ;   81-82 = subway entrance     -   done
    ;   83-84 = subway exit     -   done
    ;   85 = subway small obstacles -   done
    ;   86 = subway large obstacle  -   done


Band0Presets
    .byte %00111000 ;0
    .byte %00000000
    .byte %01000000
    .byte %00000000
    .byte %00000000
    .byte %00010000 ;5
    .byte %00000000
    .byte %00000000
    .byte %00000000
    .byte %00000000
    .byte %00000000 ;10
        .byte #%00111000;--
    .byte #%00000000;--
    .byte #%00000000;--
    .byte %00000000
    .byte %00111000 ;15
    .byte %00000000
    .byte %10000000
    .byte %00000000
    .byte %00000000
    .byte %00000010 ;20
    .byte %00000000
    .byte %11111111
    .byte %11111111
    .byte %11000000
    .byte %00000000 ;25
    .byte %00000000
    .byte %00000000
    .byte %00000001
    .byte %00000000
    .byte %11111111 ;30
    .byte %11000000
    .byte %00000000
    .byte %00000000
    .byte %00000000
    .byte %00010000 ;35
    .byte %00000000
    .byte %00001000
    .byte %00000000
    .byte %00000000
    .byte %10000000 ;40
    .byte %00000011
    .byte %10000000
    .byte %00000001
    .byte %00100000
    .byte %00000000 ;45
    .byte %00000000
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%10111101;--
        .byte #%00000000;-- ;50
        .byte #%01000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000100;--
        .byte #%00000000;-- ;55
        .byte #%00000000;--
        .byte #%00001000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;-- ;60
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000001;--
        .byte #%00000000;--
        .byte #%00000000;-- 65
        .byte #%00000011;--
        .byte #%11100000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;-- 70
        .byte #%00100000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00111111;-- 75
        .byte #%11111111;--
        .byte #%11111100;--
        .byte #%01111111;--
        .byte #%11111111;--
        .byte #%11111100;-- 80
        .byte #%00000000;--
        .byte #%00001110;--
        .byte #%01110000;--
        .byte #%00000000;--
        .byte #%00000000;-- 85
        .byte #%00000000;--
Band1Presets
    .byte %00010000 ;0
    .byte %00011000
    .byte %01000000
    .byte %00000000
    .byte %00000000
    .byte %00111000 ;5
    .byte %00000000
    .byte %10000000
    .byte %00000000
    .byte %11100000
    .byte %00000111 ;10
        .byte #%01111100;--
    .byte #%11111110;--
    .byte #%00000000;--
    .byte %00000000
    .byte %00101000 ;15
    .byte %00000000
    .byte %10000000
    .byte %00000000
    .byte %00010000
    .byte %00000010 ;20
    .byte %00000000
    .byte %11111111
    .byte %11111111
    .byte %11000000
    .byte %00000000 ;25
    .byte %00000000
    .byte %00001000
    .byte %01111111
    .byte %11111100
    .byte %01111111 ;30
    .byte %10000000
    .byte %00000000
    .byte %00000000
    .byte %00000000
    .byte %00010000 ;35
    .byte %00000000
    .byte %00011100
    .byte %00000000
    .byte %00000001
    .byte %11000000 ;40
    .byte %01111111
    .byte %11111100
    .byte %00000011
    .byte %10100000
    .byte %00000000 ;45
    .byte %00000000
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%11111111;--
        .byte #%00000000;-- ;50
        .byte #%01000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00001100;--
        .byte #%00000000;-- ;55
        .byte #%00000000;--
        .byte #%00001000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;-- ;60
        .byte #%00010000;--
        .byte #%00000000;--
        .byte #%00000001;--
        .byte #%00000000;--
        .byte #%00000000;-- 65
        .byte #%01001111;--
        .byte #%11111001;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;-- 70
        .byte #%00100000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%01010100;-- 75
        .byte #%11001001;--
        .byte #%10010010;--
        .byte #%10010011;--
        .byte #%10010011;--
        .byte #%10010010;-- 80
        .byte #%00000000;--
        .byte #%00000111;--
        .byte #%11100000;--
        .byte #%00000000;--
        .byte #%00000000;-- 85
        .byte #%00000000;--
Band2Presets
    .byte %00010000 ;0
    .byte %00111101
    .byte %11111111
    .byte %10000000
    .byte %00000000
    .byte %01111100 ;5
    .byte %11110000
    .byte %11000000
    .byte %00000000
    .byte %11000000
    .byte %00000011 ;10
        .byte #%11101110;--
    .byte #%10101010;--
    .byte #%00000000;--
    .byte %00000000
    .byte %00001000 ;15
    .byte %00111111
    .byte %11111000
    .byte %00000000
    .byte %00111011
    .byte %11111111 ;20
    .byte %00000000
    .byte %01111111
    .byte %11111111
    .byte %10011111
    .byte %11110000 ;25
    .byte %00000000
    .byte %00011100
    .byte %00111111
    .byte %11111000
    .byte %01111111 ;30
    .byte %10111110
    .byte %00000000
    .byte %00000000
    .byte %00011111
    .byte %11111000 ;35
    .byte %00000000
    .byte %00111110
    .byte %11111111
    .byte %11111011
    .byte %11100000 ;40
    .byte %01111111
    .byte %11111100
    .byte %00000111
    .byte %11100000
    .byte %00000000 ;45
    .byte %01111110
        .byte #%00000000;--
        .byte #%11111111;--
        .byte #%11100111;--
        .byte #%00000000;-- ;50
        .byte #%01010000;--
        .byte #%00000000;--
        .byte #%00000001;--
        .byte #%00001100;--
        .byte #%00000000;-- ;55
        .byte #%00010000;--
        .byte #%00001010;--
        .byte #%00000000;--
        .byte #%01000000;--
        .byte #%00000000;-- ;60
        .byte #%00010100;--
        .byte #%00000000;--
        .byte #%00000011;--
        .byte #%10000000;--
        .byte #%00000000;-- 65
        .byte #%01111111;--
        .byte #%11111111;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;-- 70
        .byte #%10100000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%11111111;-- 75
        .byte #%11111111;--
        .byte #%11111110;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111110;-- 80
        .byte #%00000000;--
        .byte #%00000011;--
        .byte #%11000000;--
        .byte #%00000000;--
        .byte #%11111111;-- 85
        .byte #%11111111;--
Band3Presets
    .byte %00010000 ;0
    .byte %01111111
    .byte %11111111
    .byte %10000000
    .byte %00001111
    .byte %00111000 ;5
    .byte %11100000
    .byte %11110000
    .byte %00000000
    .byte %11000000
    .byte %00000011 ;10
        .byte #%10101010;--
    .byte #%11111110;--
    .byte #%00000000;--
    .byte %00000000
    .byte %00001000 ;15
    .byte %00111111
    .byte %11111000
    .byte %00000000
    .byte %01111101
    .byte %11111111 ;20
    .byte %00010000
    .byte %01000010
    .byte %10101001
    .byte %11010001
    .byte %00010000 ;25
    .byte %00000000
    .byte %00111110
    .byte %00100010
    .byte %10101000
    .byte %01010010 ;30
    .byte %10100010
    .byte %00000000
    .byte %00000000
    .byte %00011111
    .byte %11111000 ;35
    .byte %00000000
    .byte %01111111
    .byte %11111111
    .byte %11111111
    .byte %11110000 ;40
    .byte %01111111
    .byte %11111100
    .byte %00001111
    .byte %11100000
    .byte %00000000 ;45
    .byte %00111100
        .byte #%11111111;--
        .byte #%10011001;--
        .byte #%10100101;--
        .byte #%00000000;-- ;50
        .byte #%01010100;--
        .byte #%00000000;--
        .byte #%00000101;--
        .byte #%00001100;--
        .byte #%00000000;-- ;55
        .byte #%00011000;--
        .byte #%00001010;--
        .byte #%10000000;--
        .byte #%01000000;--
        .byte #%00000001;-- ;60
        .byte #%00010100;--
        .byte #%00000000;--
        .byte #%00000111;--
        .byte #%11000000;--
        .byte #%00010000;-- 65
        .byte #%01010101;--
        .byte #%01010101;--
        .byte #%00000100;--
        .byte #%00010000;--
        .byte #%00001000;-- 70
        .byte #%10100100;--
        .byte #%00000000;--
        .byte #%00111110;--
        .byte #%00000000;--
        .byte #%10000000;-- 75
        .byte #%00000000;--
        .byte #%00001110;--
        .byte #%11000000;--
        .byte #%00000000;--
        .byte #%00001110;-- 80
        .byte #%11000000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00000011;--
        .byte #%00000000;-- 85
        .byte #%00000000;--
Band4Presets
    .byte %00010000 ;0
    .byte %10000001
    .byte %00000000
    .byte %00000000
    .byte %00010001
    .byte %01111100 ;5
    .byte %10000000
    .byte %11111000
    .byte %10000000
    .byte %10000000
    .byte %00000001 ;10
    .byte #%10101010;--
    .byte #%11111110;--
    .byte #%00000000;--
    .byte %00000000
    .byte %00001000 ;15
    .byte %00111111
    .byte %11111000
    .byte %00000000
    .byte %11111110
    .byte %00000000 ;20
    .byte %00111000
    .byte %01000010
    .byte %10101001
    .byte %10010001
    .byte %00010000 ;25
    .byte %00011000
    .byte %00011100
    .byte %00100010
    .byte %10101000
    .byte %01010010 ;30
    .byte %10100010
    .byte %10000000
    .byte %00000001
    .byte %00000000
    .byte %00000000 ;35
    .byte %00000000
    .byte %01111111
    .byte %11111111
    .byte %11111111
    .byte %11110000 ;40
    .byte %01111111
    .byte %11111100
    .byte %00001111
    .byte %11100000
    .byte %00000000 ;45
    .byte %00011100
        .byte #%10010101;--
        .byte #%11111001;--
        .byte #%10100101;--
        .byte #%00000000;-- ;50
        .byte #%01010110;--
        .byte #%00000000;--
        .byte #%00001101;--
        .byte #%00001100;--
        .byte #%00000000;-- ;55
        .byte #%00011000;--
        .byte #%00001010;--
        .byte #%11000000;--
        .byte #%01000000;--
        .byte #%00010011;-- ;60
        .byte #%00010100;--
        .byte #%00010000;--
        .byte #%00000110;--
        .byte #%11000000;--
        .byte #%00010100;-- ;65
        .byte #%01010101;--
        .byte #%01010101;--
        .byte #%00010100;--
        .byte #%00011000;--
        .byte #%00011100;-- 70
        .byte #%10101100;--
        .byte #%00000001;--
        .byte #%11111111;--
        .byte #%11000000;--
        .byte #%11111111;-- 75
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;-- 80
        .byte #%11110000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00001111;--
        .byte #%00000000;-- 85
        .byte #%00000000;--
Band5Presets
    .byte %00010000 ;0
    .byte %01111110
    .byte %11111111
    .byte %00000000
    .byte %00100001
    .byte %00111000 ;5
    .byte %00000000
    .byte %11111110
    .byte %11000000
    .byte %10000000
    .byte %00000001 ;10
    .byte #%10101010;--
    .byte #%11111110;--
    .byte #%00000000;--
    .byte %00000000
    .byte %00001000 ;15
    .byte %00011111
    .byte %11110000
    .byte %00000000
    .byte %01111101
    .byte %11111110 ;20
    .byte %01111100
    .byte %01000010
    .byte %10101001
    .byte %10010001
    .byte %00010000 ;25
    .byte %00011000
    .byte %00111110
    .byte %00100010
    .byte %10101000
    .byte %01010010 ;30
    .byte %10100010
    .byte %10000000
    .byte %00000001
    .byte %00001111
    .byte %11110000 ;35
    .byte %00010001
    .byte %01111111
    .byte %01111111
    .byte %11110111
    .byte %11110000 ;40
    .byte %00000000
    .byte %00000000
    .byte %00001111
    .byte %11100000
    .byte %10001000 ;45
    .byte %00011000
        .byte #%11111101;--
        .byte #%10011001;--
        .byte #%10100101;--
        .byte #%00000000;-- ;50
        .byte #%01010110;--
        .byte #%00000000;--
        .byte #%00001101;--
        .byte #%00001100;--
        .byte #%00000000;-- ;55
        .byte #%00011000;--
        .byte #%00001010;--
        .byte #%11000000;--
        .byte #%01000000;--
        .byte #%00011111;-- ;60
        .byte #%11111111;--
        .byte #%11110000;--
        .byte #%00000110;--
        .byte #%11000000;--
        .byte #%00011110;-- 65
        .byte #%01010101;--
        .byte #%01010101;--
        .byte #%00111100;--
        .byte #%00011100;--
        .byte #%00111110;-- 70
        .byte #%10111100;--
        .byte #%00000111;--
        .byte #%11111111;--
        .byte #%11110000;--
        .byte #%11111111;-- 75
        .byte #%11111111;--
        .byte #%11111110;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111110;-- 80
        .byte #%11110000;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00001111;--
        .byte #%00000000;-- 85
        .byte #%00000000;--
Band6Presets
    .byte %00010000 ;0
    .byte %01100110
    .byte %10100111
    .byte %00000000
    .byte %00111111
    .byte %00010000 ;5
    .byte %00000000
    .byte %11111111
    .byte %11100000
    .byte %11000000
    .byte %00000011 ;10
    .byte #%10101010;--
    .byte #%10101010;--
    .byte #%11111111;--
    .byte %00000000
    .byte %00001000 ;15
    .byte %00010101
    .byte %01010000
    .byte %00010000
    .byte %01010101
    .byte %01001110 ;20
    .byte %00101000
    .byte %01111111
    .byte %10111111
    .byte %10010001
    .byte %00010000 ;25
    .byte %00010000
    .byte %00001000
    .byte %00111110
    .byte %11111000
    .byte %01110011 ;30
    .byte %10100010
    .byte %11111111
    .byte %11111111
    .byte %00001010
    .byte %01110000 ;35
    .byte %11111111
    .byte %11010101
    .byte %10101010
    .byte %10101101
    .byte %01011000 ;40
    .byte %00111111
    .byte %00001000
    .byte %00011001
    .byte %01110000
    .byte %11111111 ;45
    .byte %00011000
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%00000001;-- ;50
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%10000000;-- ;55
        .byte #%00011000;--
        .byte #%00111111;--
        .byte #%11111111;--
        .byte #%11111000;--
        .byte #%00011111;-- ;60
        .byte #%11111111;--
        .byte #%11110000;--
        .byte #%00000110;--
        .byte #%11000000;--
        .byte #%00011111;-- 65
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111100;--
        .byte #%00011111;--
        .byte #%11111111;-- 70
        .byte #%11111100;--
        .byte #%00001110;--
        .byte #%11101011;--
        .byte #%10111000;--
        .byte #%00110110;-- 75
        .byte #%00000000;--
        .byte #%01101100;--
        .byte #%01101100;--
        .byte #%00000000;--
        .byte #%01101100;-- 80
        .byte #%11111100;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%00111111;--
        .byte #%00000000;-- 85
        .byte #%00000000;--
Band7Presets
    .byte %00010000 ;0
    .byte %01111110
    .byte %10111111
    .byte %00000000
    .byte %00010010
    .byte %00010000 ;5
    .byte %00000000
    .byte %11111111
    .byte %11111000
    .byte %11100000
    .byte %00000111 ;10
    .byte #%10101010;--
    .byte #%11111110;--
    .byte #%10111101;--
    .byte %00010000
    .byte %00001000 ;15
    .byte %00011101
    .byte %11110000
    .byte %00010000
    .byte %01011101
    .byte %11111110 ;20
    .byte %11111111
    .byte %11111111
    .byte %11111111
    .byte %11111111
    .byte %11111111 ;25
    .byte %11111111
    .byte %11111111
    .byte %11111111
    .byte %11111111
    .byte %11111111 ;30
    .byte %11111111
    .byte %11111111
    .byte %11111111
    .byte %00001111
    .byte %11110000 ;35
    .byte %11111111
    .byte %01110111
    .byte %00111111
    .byte %11100111
    .byte %01110000 ;40
    .byte %00111111
    .byte %00001000
    .byte %00001111
    .byte %01100000
    .byte %11111111 ;45
    .byte %00111100
        .byte #%11111111;--
        .byte #%11111001;--
        .byte #%10111101;--
        .byte #%00000001;-- ;50
        .byte #%11011011;--
        .byte #%01101101;--
        .byte #%10110110;--
        .byte #%11011011;--
        .byte #%10000000;-- ;55
        .byte #%00011000;--
        .byte #%00111011;--
        .byte #%01101101;--
        .byte #%10111000;--
        .byte #%00011011;-- ;60
        .byte #%01101101;--
        .byte #%10110000;--
        .byte #%00011011;--
        .byte #%10110000;--
        .byte #%00010101;-- 65
        .byte #%01010101;--
        .byte #%01010101;--
        .byte #%01010100;--
        .byte #%00011101;--
        .byte #%01101011;-- 70
        .byte #%01011100;--
        .byte #%00001011;--
        .byte #%10111110;--
        .byte #%11101000;--
        .byte #%11111111;-- 75
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;-- 80
        .byte #%11111111;--
        .byte #%00000000;--
        .byte #%00000000;--
        .byte #%11111111;--
        .byte #%00101000;-- 85
        .byte #%11101110;--
;---------------------------------------------------------

LevelItemDataLo
    .byte <Level0ItemData,<Level1ItemData,<Level2ItemData,<Level3ItemData
LevelItemDataHi
    .byte >Level0ItemData,>Level1ItemData,>Level2ItemData,>Level3ItemData

;---------------------------------------------------------






HighSkyObjectPtrTableLo
    .byte <Sun-13,<Moon-13,<Moon-13,<Moon-13
HighSkyObjectPtrTableHi
    .byte >[Sun-13],>[Moon-13],>[Moon-13],>[Moon-13]


FloorItemTableLo
    .byte <NoFloorItem,<CompressedSpring,<ExpandedSpring,<RArrow
    .byte <LArrow,<Gift,<Cookies,<LurkingSnowman,<LungingSnowman
    .byte <ToySack,<Ornament,<CandyCane,<Coal,<Bell
    .byte <Cocoa,<Milk
FloorItemTableHi
    .byte >NoFloorItem,>CompressedSpring,>ExpandedSpring,>RArrow
    .byte >LArrow,>Gift,>Cookies,>LurkingSnowman,>LungingSnowman
    .byte >ToySack,>Ornament,>CandyCane,>Coal,>Bell
    .byte >Cocoa,>Milk

SantaDataLo
    .byte <SantaFrame0,<SantaFrame1,<SantaFrame2,<SantaFrame3
    .byte <SantaFrame4,<SantaFrame5,<SantaFrame6,<SantaFrame7
    .byte <SantaFrame8,<SantaFrame9

SantaDataHi
    .byte >SantaFrame0,>SantaFrame1,>SantaFrame2,>SantaFrame3
    .byte >SantaFrame4,>SantaFrame5,>SantaFrame6,>SantaFrame7
    .byte >SantaFrame8,>SantaFrame9
SantaColorLo
    .byte <SantaColor0,<SantaColor1,<SantaColor2,<SantaColor2
    .byte <SantaColor3,<SantaColor4,<SantaColor5,<SantaColor2
    .byte <SantaColor2,<SantaColor3
SantaColorHi
    .byte >SantaColor0,>SantaColor1,>SantaColor2,>SantaColor2
    .byte >SantaColor3,>SantaColor4,>SantaColor5,>SantaColor2
    .byte >SantaColor2,>SantaColor3

CheckPointPFTable
    .byte 79,64,64,77

CheckPointItemTable
    .byte 4,8,5,5

CheckPointHorizonObjectTable
    .byte #%00001001,#%00001001,#%00001001,#%00010010


LevelPFDataLo
    .byte <Level0,<Level1,<Level2,<Level3
LevelPFDataHi
    .byte >Level0,>Level1,>Level2,>Level3

SongTableLo
    .byte <[JollyOldStNick-2],<[GoodChristianMenRejoice-2],<[UpOnTheHouseTop-2],<[GodRestYouMerryGentlemen-2]
    .byte <[SilentNight-2],<[SilentNight-2],<[SilentNight-2]
SongTableHi
    .byte >[JollyOldStNick-2],>[GoodChristianMenRejoice-2],>[UpOnTheHouseTop-2],>[GodRestYouMerryGentlemen-2]
    .byte >[SilentNight-2],>[SilentNight-2],>[SilentNight-2]
MidSkyObjectPtrTableLo
    .byte <PolarBearTall,<NorthPole,<ImperialWalker,<OldTrainTall,<Helicopter,<WaterTower
    .byte <Blimp,<NewTrainTall,<SatelliteDish,<CellPhoneTower,<AtariTruckTall
    .byte <ASnowman,<AtariFlag,<Airplane,<USFlag,<Snowman,<DogsledTall
    .byte <SchoolBusTall,<TankerTall,<MonsterTruckTall,<PickupTall,<Minivan
MidSkyObjectPtrTableHi
    .byte >PolarBearTall,>NorthPole,>ImperialWalker,>OldTrainTall,>Helicopter,>WaterTower
    .byte >Blimp,>NewTrainTall,>SatelliteDish,>CellPhoneTower,>AtariTruckTall
    .byte >ASnowman,>AtariFlag,>Airplane,>USFlag,>Snowman,>DogsledTall
    .byte >SchoolBusTall,>TankerTall,>MonsterTruckTall,>PickupTall,>Minivan
LowSkyObjectPtrTableLo
    .byte <PolarBear,<OldTrainShort,<Speeder,<Car,<NewTrainShort,AtariTruckShort
    .byte <Snowmobile,<Skier,<Superman,<BlankShort,<DogsledShort,<SchoolBusShort
    .byte <TankerShort,<MonsterTruckShort,<PickupShort,<MinivanCar
LowSkyObjectPtrTableHi
    .byte >PolarBear,>OldTrainShort,>Speeder,>Car,>NewTrainShort,>AtariTruckShort
    .byte >Snowmobile,>Skier,>Superman,>BlankShort,>DogsledShort,>SchoolBusShort
    .byte >TankerShort,>MonsterTruckShort,>PickupShort,>MinivanCar
SkyItemMaxFrames
    .byte 0,7,3,12,1,3,3,6,7,15,7,7,7,9,7,7
SkyItemAnimationSpeed
    .byte 0,3,7,1,0,3,3,3,3,3,3,3,3,7,7,7
SkyItemDataLookup
    .word NoObjectFrameTable,EvilBirdFrameTable,ReindeerFrameTable,SnowFlurryFrameTable
    .word MethaneFrameTable,ReindeerFrameTable,ReindeerFrameTable,LightningFrameTable
    .word FlyingHatFrameTable,SnowSpeederFrameTable,ListFrameTable,TornadoFrameTable
    .word ElfFrameTable,SnowflakeFrameTable,Sleigh1FrameTable,Sleigh2FrameTable
SkyItemHeightTable2     ;duplicate of table in bank 1
    .byte 1,8,18,16,14,18,18,40,16,12,20,20,19,16,20,20
NoObjectFrameTable
    .word Snowspeeder4
Sleigh1FrameTable
    .word EvilBirdSleighA8,EvilBirdSleighA7,EvilBirdSleighA6,EvilBirdSleighA5
    .word EvilBirdSleighA4,EvilBirdSleighA3,EvilBirdSleighA2,EvilBirdSleighA1
Sleigh2FrameTable
    .word EvilBirdSleighB8,EvilBirdSleighB7,EvilBirdSleighB6,EvilBirdSleighB5
    .word EvilBirdSleighB4,EvilBirdSleighB3,EvilBirdSleighB2,EvilBirdSleighB1
SnowflakeFrameTable
    .word Snowflake2,Snowflake3,Snowflake4,Snowflake5,Snowflake6,Snowflake5,Snowflake4
    .word Snowflake3,Snowflake2,Snowflake1
ElfFrameTable
    .word Elf8,Elf7,Elf6,Elf5,Elf4,Elf3,Elf2,Elf1
TornadoFrameTable
    .word Tornado8,Tornado7,Tornado6,Tornado5,Tornado4,Tornado3,Tornado2,Tornado1
ListFrameTable
    .word List8,List7,List6,List5,List4,List3,List2,List1
SnowSpeederFrameTable
    .word Snowspeeder6,Snowspeeder5,Snowspeeder4,Snowspeeder4,Snowspeeder4
    .word Snowspeeder4,Snowspeeder4,Snowspeeder4,Snowspeeder3,Snowspeeder2,Snowspeeder1
    .word Snowspeeder1,Snowspeeder1,Snowspeeder1,Snowspeeder1,Snowspeeder1
FlyingHatFrameTable
    .word FlyingHat8,FlyingHat7,FlyingHat6,FlyingHat5,FlyingHat4,FlyingHat3,FlyingHat2,FlyingHat1
LightningFrameTable
    .word Lightning1,Lightning6,Lightning5,Lightning4,Lightning3,Lightning2,Lightning1
MethaneFrameTable
    .word Methane1,Methane2
EvilBirdFrameTable
    .word EvilBird8,EvilBird7,EvilBird6,EvilBird5,EvilBird4,EvilBird3,EvilBird2,EvilBird1
ReindeerFrameTable
    .word Reindeer3,Reindeer2,Reindeer1,Reindeer0
SnowFlurryFrameTable
    .word SnowFlurry0,SnowFlurry1,SnowFlurry2,SnowFlurry3
    .word SnowFlurry4,SnowFlurry5,SnowFlurry6,SnowFlurry7
    .word SnowFlurry8,SnowFlurry9,SnowFlurry10,SnowFlurry11
    .word SnowFlurry12


SkyItemInitY
    ;--starting Y position  (110 is max - 77 is min [because of lack of trailing zeros])
    .byte 0,110,110,110,110,110,110,110,110,110,110,110,110,110,110,110

HorizonPF0Lo
    .byte <Horizon0PF0,<Horizon1PF0,<Horizon2PF0,<Horizon3PF0
HorizonPF0Hi
    .byte >Horizon0PF0,>Horizon1PF0,>Horizon2PF0,>Horizon3PF0
HorizonPF1Lo
    .byte <Horizon0PF1,<Horizon1PF1,<Horizon2PF1,<Horizon3PF1
HorizonPF1Hi
    .byte >Horizon0PF1,>Horizon1PF1,>Horizon2PF1,>Horizon3PF1
HorizonPF2Lo
    .byte <Horizon0PF2,<Horizon1PF2,<Horizon2PF2,<Horizon3PF2
HorizonPF2Hi
    .byte >Horizon0PF2,>Horizon1PF2,>Horizon2PF2,>Horizon3PF2

HorizonColor
  IF TV_MODE = NTSC
    .byte GRAY+10,GRAY+14,GRAY+2,GRAY+2
  ELSE
        .byte GRAY+10,GRAY+14,GRAY+4,GRAY+4
  ENDIF

ScrollFractionalAddTable
 ; IF TV_MODE = NTSC
    .byte 86,43,21,14
 ; ELSE
 ;   .byte 96,48,24,16
 ; ENDIF

RightSideMaskTable
    .byte $FF,$FE,$FC,$F8,$F0,$E0,$C0,$80,$00
LeftSideMaskTable
    .byte $00,$01,$03,$07,$0F,$1F,$3F,$7F,$FF

MidSkyObjectPointerTablesLo
    .byte <Level0MSOTable,<Level1MSOTable,<Level2MSOTable,<Level3MSOTable
MidSkyObjectPointerTablesHi
    .byte >Level0MSOTable,>Level1MSOTable,>Level2MSOTable,>Level3MSOTable
LowSkyObjectPointerTablesLo
    .byte <Level0LSOTable,<Level1LSOTable,<Level2LSOTable,<Level3LSOTable
LowSkyObjectPointerTablesHi
    .byte >Level0LSOTable,>Level1LSOTable,>Level2LSOTable,>Level3LSOTable

Level0MSOTable
    .byte NORTHPOLE,POLARBEARTALL,SNOWMAN,POLARBEARTALL,SNOWMAN,POLARBEARTALL,POLARBEARTALL,POLARBEARTALL
Level1MSOTable
    .byte DOGSLEDTALL,OLDTRAINTALL,IMPERIALWALKER,MONSTERTRUCKTALL,ASNOWMAN,AIRPLANE,IMPERIALWALKER,IMPERIALWALKER
Level2MSOTable
    .byte NEWTRAINTALL,BLIMP,TANKERTALL,PICKUPTALL,SCHOOLBUSTALL,MINIVAN,ATARITRUCKTALL,BLIMP
Level3MSOTable
    .byte WATERTOWER,HELICOPTER,SATELLITEDISH,USFLAG,CELLTOWER,ATARIFLAG,HELICOPTER,SATELLITEDISH

Level0LSOTable
    .byte POLARBEARSHORT,SNOWMOBILE,SKIER,POLARBEARSHORT,SNOWMOBILE,SKIER,POLARBEARSHORT,SKIER
Level1LSOTable
    .byte DOGSLEDSHORT,OLDTRAINSHORT,SPEEDER,MONSTERTRUCKSHORT,BLANK,BLANK,BLANK,SPEEDER
Level2LSOTable
    .byte NEWTRAINSHORT,CAR,TANKERSHORT,PICKUPSHORT,SCHOOLBUSSHORT,MINIVANCAR,ATARITRUCKSHORT,CAR
Level3LSOTable
    .byte BLANK,BLANK,BLANK,BLANK,BLANK,SUPERMAN,BLANK,BLANK

LowSkyObjectPositionTable
    .byte 72,48,108,140
MidSkyObjectPositionTable
    .byte 22,40,100,32


;SkyItem0 action data
    ;--format, for now: byte pairs: [cond],[action]
    ;   [cond] is X value that is used in the following way:
    ;       while SkyItemX > [cond], do associated [action]
    ;   [action] takes the following form:
    ;       bits 0-2 is [X speed], used like this:
    ;           SkyItemX = SkyItemX - [X speed] - 1
    ;           (i.e., SkyItems cannot remain motionless)
    ;       bits 3-5 is [Y speed], used with
    ;       bit 7, which is [Y dir]
    ;           they are used like this:
    ;           SkyItemY = SkyItemY + if([Y dir] == 1, [Y speed], 0-[Y speed])
    ;           i.e., [Y dir] == 1 means up, 0 means down.
    ;           if [Y speed] is zero, then SkyItem will not move vertically,
    ;           regardless of [Y dir]
    ;
    ;   Note:   SkyItemY should be greater than Y1 while SkyItemX > 152 and
    ;       SkyItemY should be less than Y2 while SkyItemX < 8.
ActionDataTableLo
    .byte <0,<EvilBirdActionData,<Reindeer1ActionData,<SnowflurryActionData,<MethaneAction
    .byte <Reindeer2ActionData,<Reindeer3ActionData,<LightningActionData,<FlyingHatActionData
    .byte <SnowspeederActionData,<ListActionData,<TornadoActionData,<ElfActionData
    .byte <SnowflakeActionData,<Sleigh1ActionData,<Sleigh2ActionData
ActionDataTableHi
    .byte >0,>EvilBirdActionData,>Reindeer1ActionData,>SnowflurryActionData,>MethaneAction
    .byte >Reindeer2ActionData,>Reindeer3ActionData,>LightningActionData,>FlyingHatActionData
    .byte >SnowspeederActionData,>ListActionData,>TornadoActionData,>ElfActionData
    .byte >SnowflakeActionData,>Sleigh1ActionData,>Sleigh2ActionData
LightningActionData     ;unused, label is just placeholder

ListActionData  ;done
    .byte 110,SI_LEFT1,100,SI_LEFT1|SI_DOWN1,95,SI_LEFT1|SI_DOWN2,90,SI_LEFT1|SI_DOWN1,85,SI_LEFT1
    .byte 80,SI_LEFT1|SI_UP1
    .byte 75,SI_LEFT1|SI_UP2,65,SI_LEFT1,60,SI_LEFT1|SI_DOWN1
    .byte 57,SI_LEFT1|SI_DOWN2,0,SI_LEFT1
Reindeer1ActionData ;done
SnowflurryActionData    ;done
    .byte 110,SI_LEFT1,100,SI_LEFT1|SI_DOWN1,80,SI_LEFT1,70,SI_LEFT1|SI_DOWN1
    .byte 40,SI_LEFT1,36,SI_LEFT1|SI_DOWN1,0,SI_LEFT1

Sleigh1ActionData   ;done
Sleigh2ActionData   ;done
    .byte 80,SI_LEFT1,57,SI_LEFT1|SI_DOWN1,0,SI_LEFT1
EvilBirdActionData  ;done
    .byte 80,SI_LEFT2,57,SI_LEFT1|SI_DOWN1,0,SI_LEFT2
FlyingHatActionData ;done
    .byte 100,SI_LEFT2,50,SI_LEFT2|SI_DOWN1,0,SI_LEFT2
ElfActionData       ;done
    .byte 135,SI_LEFT1,130,SI_LEFT1|SI_DOWN1
    .byte 110,SI_LEFT1,105,SI_LEFT1|SI_DOWN1
    .byte 85,SI_LEFT1,80,SI_LEFT1|SI_DOWN1
    .byte 60,SI_LEFT1,55,SI_LEFT1|SI_DOWN1
    .byte 35,SI_LEFT1,30,SI_LEFT1|SI_DOWN1,0,SI_LEFT1
TornadoActionData   ;done
    .byte 95,SI_LEFT2,80,SI_LEFT1|SI_DOWN1
    .byte 60,SI_LEFT2|SI_DOWN1,40,SI_LEFT2|SI_UP1
    .byte 30,SI_LEFT1|SI_DOWN1,0,SI_LEFT1
Reindeer2ActionData ;done
SnowflakeActionData ;done
    .byte 130,SI_LEFT2,120,SI_LEFT2|SI_DOWN1,110,SI_LEFT2|SI_DOWN2,100,SI_LEFT2|SI_DOWN1
    .byte 80,SI_LEFT2,70,SI_LEFT2|SI_UP1,60,SI_LEFT2|SI_UP2,50,SI_LEFT2|SI_UP1
    .byte 40,SI_LEFT2,30,SI_LEFT2|SI_DOWN1,20,SI_LEFT2|SI_DOWN2,10,SI_LEFT2|SI_DOWN1
    .byte 0,SI_LEFT2
SnowspeederActionData   ;done
    .byte 130,SI_LEFT2,120,SI_LEFT3|SI_DOWN1,110,SI_LEFT3|SI_DOWN2,100,SI_LEFT3|SI_DOWN1
    .byte 80,SI_LEFT3,70,SI_LEFT3|SI_UP1,60,SI_LEFT3|SI_UP2,50,SI_LEFT3|SI_UP1
    .byte 45,SI_LEFT3,35,SI_LEFT3|SI_DOWN1,25,SI_LEFT3|SI_DOWN2,10,SI_LEFT3|SI_DOWN3
    .byte 0,SI_LEFT3

Reindeer3ActionData ;done - I guess.
    .byte 140,SI_LEFT2,130,SI_LEFT2|SI_DOWN1,120,SI_LEFT2|SI_DOWN2
    .byte 110,SI_LEFT2|SI_DOWN1,100,SI_LEFT2
    .byte 90,SI_LEFT2|SI_UP1,80,SI_LEFT2|SI_UP2,70,SI_LEFT2|SI_UP1
    .byte 40,SI_LEFT2,30,SI_LEFT2|SI_DOWN1,20,SI_LEFT2|SI_DOWN2
    .byte 10,SI_LEFT2|SI_DOWN1,0,SI_LEFT2

MethaneAction       ;done
    .byte 140,SI_LEFT1,120,SI_LEFT1|SI_DOWN1
    .byte 100,SI_LEFT2,90,SI_LEFT1,70,SI_LEFT2,50,SI_LEFT1
    .byte 40,SI_LEFT2,35,SI_LEFT1|SI_DOWN1,20,SI_LEFT2,0,SI_LEFT1


InitialScrollSpeedTable         ;values: 1 to 4
    .byte SLOWSCROLL,SLOWSCROLL,MEDSLOWSCROLL,MEDFASTSCROLL







;---------------------------------------------------------



       org $2FCB
        rorg $FFCB
    jmp UpdateScoreSubroutine	;bcd
    jmp UpdateTimerSubroutine	;ef0
    jmp ReadConsoleSwitchesSubroutine	;123

    .byte 0,0,0 ;jmp FinalScreenKernel	;456
    .byte 0,0,0 ;jmp GameOverScreenKernel	;789
SwitchToBank3
	sta $1FF8
;    .byte 0,0,0 ;jmp DisplayScoreSubroutine	;abc
    .byte 0,0,0 ;jmp TitleScreenKernel	;def
    jmp MoveSkyItemSubroutine
    jmp Overscan
    jmp KernelPrepSubroutine
    jmp StartNewLevel
    .byte 0,0,0
SwitchToBank1
        sta $1FF6                       ;$FFF2, $FFF3, $FFF4


        jmp ScrollSubroutine            ;$FFF5, $FFF6, $FFF7

    org $2FFC
    rorg $FFFC

    .word Start2
    .word Start2

;---------------------------------------------------------
;---------------------------------------------------------
;---------------------------------------------------------
;------------------B A N K    T H R E E-------------------
;---------------------------------------------------------
;---------------------------------------------------------
;---------------------------------------------------------

    include RRMusic12182005.asm     ;this is bank three


;---------------------------------------------------------
;---------------------------------------------------------
;---------------------------------------------------------
;------------------B A N K      F O U R-------------------
;---------------------------------------------------------
;---------------------------------------------------------
;---------------------------------------------------------


    org $4000
    rorg $F000

Start4
    sta $FFF6


;---------------------------------------------------------

FinalScreenKernel
    sta WSYNC
    lda #0
    sta VBLANK
    sta GRP0
    lda #BLUE2+2
    sta COLUBK
    lda #GRAY+14
    sta COLUP0
    lda #ONECOPYNORMAL
    sta NUSIZ0
    sta RESP0

    ldy #3
FinalScreenUpperBufferLoop1
    sta WSYNC
    dey
    bne FinalScreenUpperBufferLoop1

    ldy #8
DisplayMoonOnFinalScreenLoop
    sta WSYNC
    lda MoonFinalScreen,Y
    sta GRP0
    dey
    bpl DisplayMoonOnFinalScreenLoop

    ldy #24
FinalScreenUpperBufferLoop2
    sta WSYNC
    dey
    bne FinalScreenUpperBufferLoop2



    lda #<SantaSleighBitmap1
    sta Temp
    lda #>SantaSleighBitmap1
    sta Temp+1

    lda #<SantaSleighBitmap2
    sta Temp+2
    lda #>SantaSleighBitmap2
    sta Temp+3
    lda #<SantaSleighBitmap3
    sta Temp+4
    lda #>SantaSleighBitmap3
    sta Temp+5
    lda #<SantaSleighBitmap4
    sta Temp+6
    lda #>SantaSleighBitmap4
    sta Temp+7
    lda #<SantaSleighBitmap5
    sta Temp+8
    lda #>SantaSleighBitmap5
    sta Temp+9
    lda #<SantaSleighBitmap6
    sta Temp+10
    lda #>SantaSleighBitmap6
    sta Temp+11
    lda #<SantaSleighColor
    sta Temp+12
    lda #>SantaSleighColor
    sta Temp+13
    lda #BLUE2+2
    sta Temp+14

    ldy #47
    jsr DisplayBitmapSubroutine


    ldy #18
FinalScreenMiddleBufferLoop
    sta WSYNC
    lda #GRAY+0
    sta COLUPF
    dey
    bne FinalScreenMiddleBufferLoop

    ldy #9
FinalScreenSkylineLoop
    sta WSYNC
    lda Horizon3PF0Bank4,Y
    sta PF0
    lda Horizon3PF1Bank4,Y
    sta PF1
    lda Horizon3PF2Bank4,Y
    sta PF2
    dey
    bpl FinalScreenSkylineLoop

    sta WSYNC
    lda #GRAY+0
    sta COLUBK
    lda #0
    sta PF0
    sta PF1
    sta PF2

    ldx #11
SetFinalScreenPointersLoop
    lda FinalScreenDataTable,X
    sta Temp,X
    dex
    bpl SetFinalScreenPointersLoop

    lda Counter
    lsr
    lsr
    lsr
    lsr
    sta Temp+14
    lda #<HappyHolidaysColor
    clc
    adc Temp+14
    sta Temp+12
    lda #>HappyHolidaysColor
    sta Temp+13

    lda #GRAY+0
    sta Temp+14

    ldy #7
FinalScreenMiddleBuffer2Loop
    sta WSYNC
    dey
    bne FinalScreenMiddleBuffer2Loop


    ldy #33
    jsr DisplayBitmapSubroutine
	ldx #0
	lda #3
	sta Temp+14
	jsr DisplayScoreSubroutine

WaitForFinalScreenKernelEnd
    lda INTIM
    bne WaitForFinalScreenKernelEnd


    jmp SwitchToBank1FromBank4

FinalScreenDataTable
    .word HappyHolidaysData0,HappyHolidaysData1,HappyHolidaysData2
    .word HappyHolidaysData3,HappyHolidaysData4,HappyHolidaysData5
;---------------------------------------------------------

GameOverScreenKernel

    sta WSYNC
    lda #0
    sta VBLANK

    ldx #14
SetGameOverScreenPointersLoop
    lda GameOverDataTable,X
    sta Temp,X
    dex
    bpl SetGameOverScreenPointersLoop

    ldy #50
GameOverBufferLines
    sta WSYNC
    dey
    bne GameOverBufferLines

    ldy #41
    jsr DisplayBitmapSubroutine

    ldy #67
GameOverBufferLines2
    sta WSYNC
    dey
    bne GameOverBufferLines2

    ldx #0
    lda #3
    sta Temp+14

    jsr DisplayScoreSubroutine

WaitForGameOverKernelEnd
    lda INTIM
    bne WaitForGameOverKernelEnd

    jmp SwitchToBank1FromBank4

GameOverDataTable
    .word GameOver0,GameOver1,GameOver2,GameOver3,GameOver4,GameOver5,GameOverColor
    .byte #GRAY+0


;---------------------------------------------------------

DisplayEnergyScoreSubroutine    ;displays floor, energy indicator, score, and extra lives
DrawFloor
    iny
    sta WSYNC
    ldx Level
    lda FloorColorTableBank4,X  ;+7  7  get floor color
    sta COLUBK      ;+2  5
    lda #0          ;+2  7
    sta GRP0        ;+3 10
    sta GRP1        ;+3 13
    sta PF0         ;+3 18
    sta PF1         ;+3 21
    sta PF2         ;+3 24
    sty VDELP0

  IF TV_MODE = NTSC
        ldx #5
  ELSE
        ldx #6
  ENDIF
FloorLoop
    sta WSYNC
    dex
    bne FloorLoop


    sta WSYNC
    lda #0
    sta COLUBK
  IF TV_MODE = PAL
        sta WSYNC
        sta WSYNC
  ENDIF




	;--original PF-to-player0 collision-reading code.  Does not work on TI EPROMs.

	lda CXP0FB
	sta SantaTemp
;	sta Score		;--for testing purposes only.

    ;--first, energy indicator
    lda EnergyExtraLives
    and #$F0
    lsr
    lsr
    lsr         ;energy times 2
    tax
    lda EnergyLookup0,X
    sta Temp
    lda EnergyLookup0+1,X
    sta Temp+1
    lda EnergyLookup1,X
    sta Temp+2
    lda EnergyLookup1+1,X
    sta Temp+3
    lda EnergyLookup2,X
    sta Temp+4
    lda EnergyLookup2+1,X
    sta Temp+5
    lda EnergyLookup3,X
    sta Temp+6
    lda EnergyLookup3+1,X
    sta Temp+7
    lda EnergyLookup4,X
    sta Temp+8
    lda EnergyLookup4+1,X
    sta Temp+9
    lda EnergyLookup5,X
    sta Temp+10
    lda EnergyLookup5+1,X
    sta Temp+11
    lda EnergyColorLookup,X
    sta Temp+12
    lda EnergyColorLookup+1,X
    sta Temp+13
    lda #GRAY+0
    sta Temp+14
    ldy #9
    jsr DisplayBitmapSubroutine



    ;pointers to digit data are as follows:
    ;   Temp, Temp+1:       low, high byte for 6th digit
    ;   Temp+2, Temp+3:     low, high byte for 5th digit
    ;   Temp+4, Temp+5:     low, high byte for 4th digit
    ;   Temp+6, Temp+7:     low, high byte for 3rd digit
    ;   Temp+8, Temp+9:     low, high byte for 2nd digit
    ;   Temp+10, Temp+11:   low, high byte for 1st digit

    ldx #0
    lda #3
    sta Temp+14

    jsr DisplayScoreSubroutine




    ;--now display extra lives
    lda EnergyExtraLives
    and #$0F
    tay
    ldx #0
SetExtraLivesPtrsLoop
    dey
    bmi SetPtrToBlank
    lda #<ExtraLivesGraphic
    sta Temp,X
    lda #>ExtraLivesGraphic
    sta Temp+1,X
    inx
    inx
    cpx #12
    bne SetExtraLivesPtrsLoop
    beq DoneSettingELPtrs       ;branch always
SetPtrToBlank
    lda #<ExtraLivesBlank
    sta Temp,X
    lda #>ExtraLivesBlank
    sta Temp+1,X
    inx
    inx
    cpx #12
    bne SetExtraLivesPtrsLoop
DoneSettingELPtrs
    lda #<ExtraLivesColor
    sta Temp+12
    lda #>ExtraLivesColor
    sta Temp+13
    lda #0
    sta Temp+14

    ldy #8
    jsr DisplayBitmapSubroutine



    jmp SwitchToBank1FromBank4
;---------------------------------------------------------

SuppressLeadingZeroRoutine1

    lda #<ExtraLivesBlank
    sta Temp,Y
    jmp ReturnFromLeadZero1

SuppressLeadingZeroRoutine2
    cpy #10
    beq DoNotSuppressFinalZero
    lda #<ExtraLivesBlank
    sta Temp,Y
    jmp ReturnFromLeadZero2

;---------------------------------------------------------

DisplayScoreSubroutine

    ;X set upon entering to index into either the score or the high score
    ;Temp+14 set upon entering for ending the loop (i.e., X+3)

    ldy #0
    sty Temp+13     ;suppress leading zeroes flag.
SetScorePointersLoop
    lda Score,X
    lsr
    lsr
    lsr
    lsr
    cmp Temp+13
    beq SuppressLeadingZeroRoutine1
    sty Temp+12
    tay
    lda DigitDataIndex,Y
    ldy Temp+12
    sta Temp,Y
    lda #255
    sta Temp+13     ;no more leading zeroes
ReturnFromLeadZero1
    iny
    iny
    lda Score,X
    and #$0F
    cmp Temp+13
    beq SuppressLeadingZeroRoutine2
DoNotSuppressFinalZero
    sty Temp+12
    tay
    lda DigitDataIndex,Y
    ldy Temp+12
    sta Temp,Y
    lda #255
    sta Temp+13     ;no more leading zeroes
ReturnFromLeadZero2
    iny
    iny
    inx
    cpx Temp+14
    bne SetScorePointersLoop

    sta WSYNC

    lda #>DigitData
    sta Temp+1
    sta Temp+3
    sta Temp+5
    sta Temp+7
    sta Temp+9
    sta Temp+11

                ;+218   239 total for whole loop (3 times through)

    lda #<ScoreColorTable
    sta Temp+12
    lda #>ScoreColorTable
    sta Temp+13
    lda #GRAY+0
    sta Temp+14

    ldy #DIGITHEIGHT-1
    jsr DisplayBitmapSubroutine

    rts

;---------------------------------------------------------

TitleScreenKernel
    sta WSYNC
	sta WSYNC
    sta VBLANK      ;+3  3  turn off Vertical Blank
	
	lda #LEVEL0BACKGROUNDCOLOR
	sta COLUBK

    ldx #14
SetTitleScreenPointersLoop
    lda TitleDataTable,X
    sta Temp,X
    dex
    bpl SetTitleScreenPointersLoop



	ldx #29
TitleScreenUpperBufferLoop
	sta WSYNC
	dex
	bne TitleScreenUpperBufferLoop

    ldy #21
    jsr DisplayBitmapSubroutine

    SLEEP 10
    sta RESP0
    SLEEP 30
    sta RESP1

	IF NTSC = 1
    ldy #44
	ELSE
	ldy #48
	ENDIF

TitleScreenMiddleBufferLoop1
    sta WSYNC
    dey
    bne TitleScreenMiddleBufferLoop1

    lda #REINDEERCOLOR
    sta COLUP1
    jsr DisplaySantaAndReindeerInBank1

  IF TV_MODE = NTSC
        ldx #5
  ELSE
        ldx #6
  ENDIF
FloorLoopTitleScreen
    sta WSYNC
    dex
    bne FloorLoopTitleScreen

	sta WSYNC
	stx COLUBK

	IF TV_MODE = NTSC
    ldy #15
	ELSE
	ldy #17
	ENDIF

TitleScreenMiddleBufferLoop2
    sta WSYNC
    dey
    bne TitleScreenMiddleBufferLoop2

    ldx #3
    lda #6
    sta Temp+14
    jsr DisplayScoreSubroutine

    ldy #2
TitleScreenMiddleBufferLoop3
    sta WSYNC
    dey
    bne TitleScreenMiddleBufferLoop3



    lda Counter                     ;+3     12
    lsr
    lsr
    lsr
    tay

    lda #<Copyright1
    clc
    adc AdjustCopyright,Y
    sta Temp
    lda #>Copyright1
    sta Temp+1

    lda #<Copyright2
    clc
    adc AdjustCopyright,Y
    sta Temp+2
    lda #>Copyright2
    sta Temp+3

    lda #<Copyright3
    clc
    adc AdjustCopyright,Y
    sta Temp+4
    lda #>Copyright3
    sta Temp+5

    lda #<Copyright4
    clc
    adc AdjustCopyright,Y
    sta Temp+6
    lda #>Copyright4
    sta Temp+7

    lda #<Copyright5
    clc
    adc AdjustCopyright,Y
    sta Temp+8
    lda #>Copyright5
    sta Temp+9

    lda #<Copyright6
    clc
    adc AdjustCopyright,Y
    sta Temp+10
    lda #>Copyright6
    sta Temp+11

    lda #<CopyrightColorTable
    sta Temp+12
    lda #>CopyrightColorTable
    sta Temp+13

    lda #GRAY+0
    sta Temp+14

    ldy #4
    jsr DisplayBitmapSubroutine

WaitForTitleKernelEnd
    lda INTIM
    bne WaitForTitleKernelEnd

    jmp SwitchToBank1FromBank4

AdjustCopyright
    .byte 0,0,0,0,0,0
    .byte 1,2,3
    .byte 4,5,6,6,6,6,6,7,8,9,10,11
    .byte 12,13,14,15,16,17,18,18,18,18,18

;---------------------------------------------------------

    align 256


DisplayBitmapSubroutine
    ;       7 pointers and 1 variable must be set upon entering (Temp through Temp+11 to graphics,
    ;                           Temp+12 through Temp+13 to PF color
    ;                           Temp+14 is players color)
    ;       Y must be set (height of bitmap)
    ;       will position sprites, set NUSIZx, VDELPx, CTRLPF, display bitmap,
    ;       then reset NUSIZx, VDELPx, CTRLPF, GRP0, and GRP1 to zero, then return.
    lda #THREECOPIESCLOSE
    sta WSYNC
    sta NUSIZ0
    sta NUSIZ1          ;+8  6
    lda #REFLECTEDPF
    sta CTRLPF          ;+5 11
    lda #64         ;+2 13
    sec             ;+2 15
DivideLoopBitmap
    sbc #15
    bcs DivideLoopBitmap    ;+4/5   19/24/...
    sta RESP0           ;+3 23
    sta RESP1           ;+3 26
    sta WSYNC
    lda #RIGHTONE
    sta HMP0
    lda #NOMOVEMENT
    sta HMP1            ;+10    10
    lda #$80
    sta HMM0
    sta HMM1
    sta HMBL            ;+11    21
    lda Temp+14
    sta COLUP0
    sta COLUP1          ;+9 30
    SLEEP 40            ;+40    40
    sta HMOVE
    sta WSYNC           ;+6 76
    lda #1
    sta VDELP0
    sta VDELP1          ;+8  8
    lda #0
    sta GRP0
    sta GRP1
    sta GRP0            ;+11    19


    SLEEP 34            ;+34    53
    sty SkyItemTemp         ;+3 56  doubling up with this variable
    lda #%11111100
    sta PF2             ;+5 61
DisplayBitmapLoop
    ldy SkyItemTemp         ;+3 64
    lda (Temp+12),Y
    sta COLUPF          ;+8 72
    lda (Temp),Y
    sta GRP0            ;+8  4
    lda (Temp+2),Y
    sta GRP1            ;+8 12
    lda (Temp+4),Y
    sta GRP0            ;+8 20
    lax (Temp+6),Y          ;+5 25
    lda (Temp+8),Y
    sta Temp+14         ;+8 33
    lda (Temp+10),Y         ;+5 38
    ldy Temp+14         ;+3 41

    stx GRP1            ;+3 44
    sty GRP0
    sta GRP1
    sta GRP0            ;+9 53
    dec SkyItemTemp         ;+5 58
    bpl DisplayBitmapLoop   ;+3 61
                    ;   60
    lda #0
    sta PF2         ;+5 65
    sta VDELP0
    sta VDELP1          ;+6 71
    sta NUSIZ0
    sta NUSIZ1          ;+6  1
    sta GRP0
    sta GRP1            ;+6  7
    sta CTRLPF          ;+3 10
Ret4
    rts             ;+6 16

;---------------------------------------------------------
;---------------------------------------------------------
;---------------------------------------------------------
;---------------------------------------------------------
;---------------------------------------------------------

    align 256

ExtraLivesGraphic
        .byte #%10000001;$1E
        .byte #%10000001;$1E
        .byte #%11000011;$32
        .byte #%11000011;$32
        .byte #%11000011;$32
        .byte #%11100111;$32
        .byte #%11100111;$32
        .byte #%11100111;$1E
        .byte #%11100111;$1E

ExtraLivesColor
    .byte GRAY+14
    .byte GRAY+14
    .byte RED+4
    .byte RED+4
    .byte RED+4
    .byte RED+4
    .byte RED+4
    .byte GRAY+14
    .byte GRAY+14
ExtraLivesBlank
    .byte $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

DigitData
DigitZero
        .byte #%10000111;--
        .byte #%00010011;--
        .byte #%00110011;--
        .byte #%00111001;--
        .byte #%00111001;--
        .byte #%10111001;--
        .byte #%10010001;--
        .byte #%11000011;--
DigitOne
        .byte #%10000001;--
        .byte #%11100111;--
        .byte #%11100111;--
        .byte #%11100111;--
        .byte #%10100111;--
        .byte #%11000111;--
        .byte #%11100111;--
        .byte #%11110111;--
DigitTwo
        .byte #%00000001;--
        .byte #%10001111;--
        .byte #%11100111;--
        .byte #%11110011;--
        .byte #%11111001;--
        .byte #%11111001;--
        .byte #%10010001;--
        .byte #%11000011;--
DigitThree
        .byte #%00000111;--
        .byte #%11100011;--
        .byte #%11110011;--
        .byte #%11100011;--
        .byte #%11000111;--
        .byte #%11110011;--
        .byte #%10011001;--
        .byte #%11000011;--
DigitFour
        .byte #%11110011;--
        .byte #%11110011;--
        .byte #%00000001;--
        .byte #%10110011;--
        .byte #%11010011;--
        .byte #%11100011;--
        .byte #%11110011;--
        .byte #%11111011;--
DigitFive
        .byte #%00000111;--
        .byte #%11110011;--
        .byte #%11111011;--
        .byte #%11110011;--
        .byte #%10000011;--
        .byte #%10001111;--
        .byte #%10011111;--
        .byte #%11000001;--
DigitSix
        .byte #%00000111;--
        .byte #%00110011;--
        .byte #%00110011;--
        .byte #%00000011;--
        .byte #%00000111;--
        .byte #%10111111;--
        .byte #%10011111;--
        .byte #%11000001;--
DigitSeven
        .byte #%00111111;--
        .byte #%10011111;--
        .byte #%11001111;--
        .byte #%11001111;--
        .byte #%11100111;--
        .byte #%11100111;--
        .byte #%11110011;--
        .byte #%10000001;--
DigitEight
        .byte #%00000111;--
        .byte #%00110011;--
        .byte #%00111011;--
        .byte #%10000011;--
        .byte #%11000111;--
        .byte #%10010011;--
        .byte #%10011001;--
        .byte #%11000011;--
DigitNine
        .byte #%00000111;--
        .byte #%11110011;--
        .byte #%11111011;--
        .byte #%10000001;--
        .byte #%10011001;--
        .byte #%10011001;--
        .byte #%10011001;--
        .byte #%11000011;--

HexA
        .byte #%01100110;--
        .byte #%01100110;--
        .byte #%01111110;--
        .byte #%01111110;--
        .byte #%01100110;--
        .byte #%01100110;--
        .byte #%00111100;--
        .byte #%00011000;--
HexB
        .byte #%01111100;--
        .byte #%01100110;--
        .byte #%01100110;--
        .byte #%01100110;--
        .byte #%01111100;--
        .byte #%01100110;--
        .byte #%01100110;--
        .byte #%01111100;--
HexC
        .byte #%00111100;--
        .byte #%01111110;--
        .byte #%01100110;--
        .byte #%01100000;--
        .byte #%01100000;--
        .byte #%01100110;--
        .byte #%01111110;--
        .byte #%00111100;--
HexD
        .byte #%01111100;--
        .byte #%01100110;--
        .byte #%01100110;--
        .byte #%01100110;--
        .byte #%01100110;--
        .byte #%01100110;--
        .byte #%01100110;--
        .byte #%01111100;--
HexE
        .byte #%01111110;--
        .byte #%01111110;--
        .byte #%01100000;--
        .byte #%01111000;--
        .byte #%01111000;--
        .byte #%01100000;--
        .byte #%01111110;--
        .byte #%01111110;--
HexF
        .byte #%01100000;--
        .byte #%01100000;--
        .byte #%01111100;--
        .byte #%01111100;--
        .byte #%01100000;--
        .byte #%01100000;--
        .byte #%01111110;--
        .byte #%01111110;--

    align 256

TitleData0
        .byte #%11111111;$D4
        .byte #%11111111;$D4
        .byte #%11111111;$D4
        .byte #%11111111;$D4
        .byte #%11111111;$D4
        .byte #%00111110;$D4
        .byte #%00111100;$D4
        .byte #%00111000;$D4
        .byte #%00110001;$D4
        .byte #%00100011;$D4
        .byte #%00100111;$1E
        .byte #%00100111;$32
        .byte #%00100111;$32
        .byte #%00110011;$32
        .byte #%00110001;$32
        .byte #%00111000;$32
        .byte #%00111100;$32
        .byte #%00111110;$32
        .byte #%00111111;$32
        .byte #%00111111;$32
        .byte #%00000000;$32
        .byte #%10000000;$32
TitleData1
        .byte #%11110000;$D4
        .byte #%11100000;$D4
        .byte #%11000111;$D4
        .byte #%10001110;$D4
        .byte #%00011110;$D4
        .byte #%00111110;$D4
        .byte #%01111110;$D4
        .byte #%11111110;$D4
        .byte #%11111110;$D4
        .byte #%11111110;$D4
        .byte #%11111111;$1E
        .byte #%11110000;$32
        .byte #%11110111;$32
        .byte #%11110011;$32
        .byte #%11110101;$32
        .byte #%11110110;$32
        .byte #%01110111;$32
        .byte #%00110000;$32
        .byte #%00011111;$32
        .byte #%10001111;$32
        .byte #%00000111;$32
        .byte #%00001111;$32
TitleData2
        .byte #%00000000;$D4
        .byte #%00000000;$D4
        .byte #%11111111;$D4
        .byte #%00001000;$D4
        .byte #%11111111;$D4
        .byte #%01111111;$D4
        .byte #%10111000;$D4
        .byte #%11011011;$D4
        .byte #%11101011;$D4
        .byte #%00001000;$D4
        .byte #%11111111;$1E
        .byte #%01010111;$32
        .byte #%11010111;$32
        .byte #%11010111;$32
        .byte #%11010111;$32
        .byte #%11010111;$32
        .byte #%01010111;$32
        .byte #%01010000;$32
        .byte #%11111111;$32
        .byte #%11011111;$32
        .byte #%11011111;$32
        .byte #%11111111;$32
TitleData3
        .byte #%00000000;$D4
        .byte #%00000000;$D4
        .byte #%11111111;$D4
        .byte #%00100000;$D4
        .byte #%10101111;$D4
        .byte #%10101111;$D4
        .byte #%00101111;$D4
        .byte #%11101111;$D4
        .byte #%11101111;$D4
        .byte #%00100000;$D4
        .byte #%11111111;$1E
        .byte #%01000001;$32
        .byte #%01011101;$32
        .byte #%01011101;$32
        .byte #%01011101;$32
        .byte #%01011101;$32
        .byte #%01011101;$32
        .byte #%01000001;$32
        .byte #%11111101;$32
        .byte #%11111101;$32
        .byte #%11111101;$32
        .byte #%11111101;$32
TitleData4
        .byte #%00000000;$D4
        .byte #%00000000;$D4
        .byte #%11111111;$D4
        .byte #%10000010;$D4
        .byte #%10111010;$D4
        .byte #%10111010;$D4
        .byte #%10111010;$D4
        .byte #%10111010;$D4
        .byte #%10111010;$D4
        .byte #%10111010;$D4
        .byte #%11111111;$1E
        .byte #%00000100;$32
        .byte #%01111101;$32
        .byte #%00111100;$32
        .byte #%01011101;$32
        .byte #%01101101;$32
        .byte #%01110101;$32
        .byte #%00000100;$32
        .byte #%11111111;$32
        .byte #%11111111;$32
        .byte #%11111111;$32
        .byte #%11111111;$32
TitleData5
        .byte #%00000000;$D4
        .byte #%00000000;$D4
        .byte #%11111111;$D4
        .byte #%00001111;$D4
        .byte #%11111111;$D4
        .byte #%01111111;$D4
        .byte #%10111111;$D4
        .byte #%11011111;$D4
        .byte #%11101111;$D4
        .byte #%00001111;$D4
        .byte #%11111111;$1E
        .byte #%00010111;$32
        .byte #%11110111;$32
        .byte #%11110111;$32
        .byte #%01110111;$32
        .byte #%10110111;$32
        .byte #%11010111;$32
        .byte #%00010000;$32
        .byte #%11111111;$32
        .byte #%11111111;$32
        .byte #%11111111;$32
        .byte #%11111111;$32

;---End Graphics Data---


;---Color Data from PlayerPal 2600---

TitleColorData
        .byte BROWNGREEN+2
        .byte BROWNGREEN+2
        .byte BROWNGREEN+2
        .byte BROWNGREEN+2
        .byte BROWNGREEN+2
        .byte BROWNGREEN+2
        .byte BROWNGREEN+2
        .byte BROWNGREEN+2
        .byte BROWNGREEN+2
        .byte BROWNGREEN+2
        .byte GRAY+14
        .byte RED+4
        .byte RED+4
        .byte RED+4
        .byte RED+4
        .byte RED+4
        .byte RED+4
        .byte RED+4
        .byte RED+4
        .byte RED+4
        .byte RED+4
        .byte RED+4
    align 256



HappyHolidaysData0
        .byte #%11011111;--
        .byte #%11101111;--
        .byte #%11110111;--
        .byte #%11110111;--
        .byte #%11110111;--
        .byte #%11110111;--
        .byte #%11110101;--
        .byte #%11110101;--
        .byte #%11110101;--
        .byte #%11110101;--
        .byte #%11110101;--
        .byte #%11100010;--
        .byte #%11110111;--
        .byte #%11110111;--
        .byte #%11110111;--
        .byte #%11110111;--
        .byte #%11111011;--
        .byte #%11111101;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111011;--
        .byte #%10110100;--
        .byte #%10110101;--
        .byte #%11010110;--
        .byte #%11010111;--
        .byte #%11000101;--
        .byte #%01010110;--
        .byte #%01010111;--
        .byte #%01010111;--
        .byte #%10010111;--
        .byte #%11110111;--
        .byte #%11111011;--
        .byte #%11111101;--
HappyHolidaysData1
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%00110101;--
        .byte #%01010101;--
        .byte #%01010101;--
        .byte #%01010101;--
        .byte #%01010000;--
        .byte #%10110101;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%01101111;--
        .byte #%10110111;--
        .byte #%11011011;--
        .byte #%11011011;--
        .byte #%11011011;--
        .byte #%11011011;--
        .byte #%01011011;--
        .byte #%01001001;--
        .byte #%01010010;--
        .byte #%01010010;--
        .byte #%01010010;--
        .byte #%11001001;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
HappyHolidaysData2
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%01101101;--
        .byte #%01101101;--
        .byte #%01100101;--
        .byte #%01110001;--
        .byte #%01010101;--
        .byte #%01010100;--
        .byte #%11011001;--
        .byte #%11101001;--
        .byte #%11110001;--
        .byte #%11111111;--
        .byte #%01111111;--
        .byte #%10111111;--
        .byte #%11011111;--
        .byte #%11011111;--
        .byte #%11011111;--
        .byte #%11011111;--
        .byte #%11011101;--
        .byte #%10011101;--
        .byte #%10101110;--
        .byte #%10101110;--
        .byte #%10101110;--
        .byte #%00101010;--
        .byte #%11111010;--
        .byte #%11111010;--
        .byte #%11111100;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
HappyHolidaysData3
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%10111111;--
        .byte #%01000101;--
        .byte #%01010101;--
        .byte #%01100101;--
        .byte #%01110101;--
        .byte #%01010101;--
        .byte #%00101110;--
        .byte #%01111111;--
        .byte #%01111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11011101;--
        .byte #%10100101;--
        .byte #%10101001;--
        .byte #%10101001;--
        .byte #%10101001;--
        .byte #%00101001;--
        .byte #%10110101;--
        .byte #%10111101;--
        .byte #%10111101;--
        .byte #%10111101;--
        .byte #%10111101;--
        .byte #%11011110;--
        .byte #%11101111;--
HappyHolidaysData4
        .byte #%11111111;--
        .byte #%11111110;--
        .byte #%11111110;--
        .byte #%11111110;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%10110110;--
        .byte #%10110110;--
        .byte #%10110010;--
        .byte #%10111000;--
        .byte #%10101010;--
        .byte #%10101010;--
        .byte #%11101100;--
        .byte #%11110100;--
        .byte #%10111000;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%01000100;--
        .byte #%01010101;--
        .byte #%01010110;--
        .byte #%01010111;--
        .byte #%01010101;--
        .byte #%01100110;--
        .byte #%11110111;--
        .byte #%11110111;--
        .byte #%01110111;--
        .byte #%11110111;--
        .byte #%11111011;--
        .byte #%01111101;--
HappyHolidaysData5
        .byte #%01111111;--
        .byte #%10111111;--
        .byte #%11011111;--
        .byte #%11011111;--
        .byte #%01011111;--
        .byte #%11011111;--
        .byte #%10010111;--
        .byte #%01001011;--
        .byte #%01001111;--
        .byte #%01000011;--
        .byte #%01001011;--
        .byte #%10010011;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%10111111;--
        .byte #%11011111;--
        .byte #%11101111;--
        .byte #%11101111;--
        .byte #%11101111;--
        .byte #%11101111;--
        .byte #%01101001;--
        .byte #%01001110;--
        .byte #%01010110;--
        .byte #%01010100;--
        .byte #%01010101;--
        .byte #%10010100;--
        .byte #%11111110;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--

    align 256

HappyHolidaysColor
    .byte RED+0,RED+2,RED+4,RED+5,RED+6,RED+8,RED+10,RED+12,RED+14
    .byte GREEN+0,GREEN+2,GREEN+4,GREEN+6,GREEN+8,GREEN+10,GREEN+12,GREEN+14
    .byte RED+0,RED+2,RED+4,RED+5,RED+6,RED+8,RED+10,RED+12,RED+14
    .byte GREEN+0,GREEN+2,GREEN+4,GREEN+6,GREEN+8,GREEN+10,GREEN+12,GREEN+14
    .byte RED+0,RED+2,RED+4,RED+5,RED+6,RED+8,RED+10,RED+12,RED+14
    .byte GREEN+0,GREEN+2,GREEN+4,GREEN+6,GREEN+8,GREEN+10,GREEN+12,GREEN+14
    .byte RED+0,RED+2,RED+4,RED+5,RED+6,RED+8,RED+10,RED+12,RED+14

    align 256

GameOver0
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11001111;--
        .byte #%10110111;--
        .byte #%11110111;--
        .byte #%11111011;--
        .byte #%11111011;--
        .byte #%11001011;--
        .byte #%10000010;--
        .byte #%10110010;--
        .byte #%01111010;--
        .byte #%01111011;--
        .byte #%01111011;--
        .byte #%01100011;--
        .byte #%01110010;--
        .byte #%01111111;--
        .byte #%00111111;--
        .byte #%10111111;--
        .byte #%10111111;--
        .byte #%11011011;--
        .byte #%11011011;--
        .byte #%11100111;--
GameOver1
        .byte #%11111110;--
        .byte #%11111100;--
        .byte #%11111110;--
        .byte #%11111110;--
        .byte #%11111110;--
        .byte #%11111110;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%00101010;--
        .byte #%10011010;--
        .byte #%11011010;--
        .byte #%11011010;--
        .byte #%01011010;--
        .byte #%10011010;--
        .byte #%11011010;--
        .byte #%11011010;--
        .byte #%01010101;--
        .byte #%10110101;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
GameOver2

        .byte #%11111111;--
        .byte #%00111111;--
        .byte #%00001111;--
        .byte #%00001111;--
        .byte #%00001111;--
        .byte #%10001111;--
        .byte #%00000111;--
        .byte #%00000111;--
        .byte #%00000111;--
        .byte #%00100111;--
        .byte #%11000111;--
        .byte #%11000011;--
        .byte #%11111111;--
        .byte #%11111010;--
        .byte #%11110100;--
        .byte #%11110001;--
        .byte #%11111010;--
        .byte #%11111101;--
        .byte #%11111100;--
        .byte #%11111110;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11011111;--
        .byte #%10110111;--
        .byte #%10100011;--
        .byte #%10101101;--
        .byte #%10101101;--
        .byte #%10100111;--
        .byte #%10101011;--
        .byte #%10101011;--
        .byte #%10101101;--
        .byte #%01110101;--
        .byte #%01111011;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
GameOver3

        .byte #%11111111;--
        .byte #%11111000;--
        .byte #%11111000;--
        .byte #%11100000;--
        .byte #%11100000;--
        .byte #%11100010;--
        .byte #%11000001;--
        .byte #%11000001;--
        .byte #%11000001;--
        .byte #%11001001;--
        .byte #%11000111;--
        .byte #%10000111;--
        .byte #%01111111;--
        .byte #%10111111;--
        .byte #%00111111;--
        .byte #%01111111;--
        .byte #%11111111;--
        .byte #%01111111;--
        .byte #%01111111;--
        .byte #%11111111;--

        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11110111;--
        .byte #%11101011;--
        .byte #%11101101;--
        .byte #%11011101;--
        .byte #%11011110;--
        .byte #%11011110;--
        .byte #%11011110;--
        .byte #%11011110;--
        .byte #%11011110;--
        .byte #%11011110;--
        .byte #%11011110;--
        .byte #%11011110;--
        .byte #%11101110;--
        .byte #%11101101;--
        .byte #%11110101;--
        .byte #%11111011;--
GameOver4
        .byte #%11111111;--
        .byte #%01111111;--
        .byte #%01111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11011101;--
        .byte #%11011000;--
        .byte #%11011011;--
        .byte #%10101011;--
        .byte #%10101001;--
        .byte #%10101010;--
        .byte #%10101010;--
        .byte #%10101011;--
        .byte #%10101101;--
        .byte #%01110110;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
GameOver5
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%10111101;--
        .byte #%11011101;--
        .byte #%01011101;--
        .byte #%01011111;--
        .byte #%11011111;--
        .byte #%11011101;--
        .byte #%11011101;--
        .byte #%01011101;--
        .byte #%01001101;--
        .byte #%10010101;--
        .byte #%11111101;--
        .byte #%11111101;--
        .byte #%11111101;--
        .byte #%11111101;--
        .byte #%11111101;--

    align 256

GameOverColor
        .byte BROWNGREEN+2;
        .byte BROWNGREEN+2;
        .byte BROWNGREEN+2;
        .byte BROWNGREEN+2;
        .byte BROWNGREEN+2;
        .byte BROWNGREEN+2;
        .byte BROWNGREEN+2;
        .byte BROWNGREEN+2;
        .byte BROWNGREEN+2;
        .byte BROWNGREEN+2;
        .byte BROWNGREEN+2;
        .byte BROWNGREEN+2;
        .byte RED+4
        .byte RED+4
        .byte RED+4
        .byte RED+4
        .byte RED+4
        .byte RED+4
        .byte RED+4
        .byte RED+4
    .byte 0
    .byte GRAY+14
    .byte GRAY+14
    .byte GRAY+14
    .byte GRAY+14
    .byte GRAY+14
    .byte GRAY+14
    .byte GRAY+14
    .byte GRAY+14
    .byte GRAY+14
    .byte GRAY+14
    .byte GRAY+14
    .byte GRAY+14
    .byte GRAY+14
    .byte GRAY+14
    .byte GRAY+14
    .byte GRAY+14
    .byte GRAY+14
    .byte GRAY+14
    .byte GRAY+14
    .byte GRAY+14

    align 256

Energy000
Energy010
Energy020
Energy030
Energy040
Energy050
Energy060
Energy070
Energy080
Energy090
Energy100
Energy110
Energy120
Energy130
        .byte #%11011111;$AE
        .byte #%11011111;$AE
        .byte #%11011111;$C2
        .byte #%11011111;$C2
        .byte #%10011110;$C2
        .byte #%01100101;$C2
        .byte #%11111011;$C2
        .byte #%11111011;$C2
        .byte #%11111011;$AE
        .byte #%11111011;$AE

Energy140
        .byte #%11011111;$AE
        .byte #%11011111;$AE
        .byte #%11011111;$C2
        .byte #%11011111;$C2
        .byte #%10011110;$C2
        .byte #%01100101;$C2
        .byte #%11111011;$C2
        .byte #%11111011;$C2
        .byte #%11111111;$AE
        .byte #%11111111;$AE

Energy150
        .byte #%11111111;$AE
        .byte #%11111111;$AE
        .byte #%11011111;$C2
        .byte #%11011111;$C2
        .byte #%10011110;$C2
        .byte #%01100101;$C2
        .byte #%11111011;$C2
        .byte #%11111011;$C2
        .byte #%11111111;$AE
        .byte #%11111111;$AE
Energy001
Energy011
Energy021
Energy031
Energy041
Energy051
Energy061
Energy071
Energy081
Energy091
        .byte #%01110111;$AE
        .byte #%01110111;$AE
        .byte #%01110111;$C2
        .byte #%01110111;$C2
        .byte #%00101011;$C2
        .byte #%11011101;$C2
        .byte #%11011110;$C2
        .byte #%11011110;$C2
        .byte #%11011110;$AE
        .byte #%11011110;$AE
Energy101
        .byte #%01110111;$AE
        .byte #%01110111;$AE
        .byte #%01110111;$C2
        .byte #%01110111;$C2
        .byte #%00101011;$C2
        .byte #%11011101;$C2
        .byte #%11011110;$C2
        .byte #%11011110;$C2
        .byte #%11011111;$AE
        .byte #%11011111;$AE

Energy111
        .byte #%01111111;$AE
        .byte #%01111111;$AE
        .byte #%01110111;$C2
        .byte #%01110111;$C2
        .byte #%00101011;$C2
        .byte #%11011101;$C2
        .byte #%11011110;$C2
        .byte #%11011110;$C2
        .byte #%11011111;$AE
        .byte #%11011111;$AE
Energy121
        .byte #%01111111;$AE
        .byte #%01111111;$AE
        .byte #%01110111;$C2
        .byte #%01110111;$C2
        .byte #%00101011;$C2
        .byte #%11011101;$C2
        .byte #%11011110;$C2
        .byte #%11011110;$C2
        .byte #%11111111;$AE
        .byte #%11111111;$AE
Energy131
Energy141
Energy151
        .byte #%11111111;$AE
        .byte #%11111111;$AE
        .byte #%01110111;$C2
        .byte #%01110111;$C2
        .byte #%00101011;$C2
        .byte #%11011101;$C2
        .byte #%11011110;$C2
        .byte #%11011110;$C2
        .byte #%11111111;$AE
        .byte #%11111111;$AE
Energy002
Energy012
Energy022
Energy032
Energy042
Energy052
Energy062
Energy072
Energy082
        .byte #%11110111;$AE
        .byte #%11110111;$AE
        .byte #%11000111;$C2
        .byte #%10110011;$C2
        .byte #%10100101;$C2
        .byte #%00001010;$C2
        .byte #%11000111;$C2
        .byte #%11111111;$C2
        .byte #%11111111;$AE
        .byte #%11111111;$AE
Energy092
Energy102
Energy112
Energy122
Energy132
Energy142
Energy152
        .byte #%11111111;$AE
        .byte #%11111111;$AE
        .byte #%11000111;$C2
        .byte #%10110011;$C2
        .byte #%10100101;$C2
        .byte #%00001010;$C2
        .byte #%11000111;$C2
        .byte #%11111111;$C2
        .byte #%11111111;$AE
        .byte #%11111111;$AE




Energy003
Energy013
Energy023
Energy033
Energy043
Energy053
        .byte #%11011111;$AE
        .byte #%11011111;$AE
        .byte #%11011111;$C2
        .byte #%11011111;$C2
        .byte #%11011111;$C2
        .byte #%10100100;$C2
        .byte #%01111011;$C2
        .byte #%01111011;$C2
        .byte #%01111011;$AE
        .byte #%01111011;$AE
Energy063
        .byte #%11011111;$AE
        .byte #%11011111;$AE
        .byte #%11011111;$C2
        .byte #%11011111;$C2
        .byte #%11011111;$C2
        .byte #%10100100;$C2
        .byte #%01111011;$C2
        .byte #%01111011;$C2
        .byte #%01111111;$AE
        .byte #%01111111;$AE

Energy073
        .byte #%11111111;$AE
        .byte #%11111111;$AE
        .byte #%11011111;$C2
        .byte #%11011111;$C2
        .byte #%11011111;$C2
        .byte #%10100100;$C2
        .byte #%01111011;$C2
        .byte #%01111011;$C2
        .byte #%01111111;$AE
        .byte #%01111111;$AE
Energy083
Energy093
Energy103
Energy113
Energy123
Energy133
Energy143
Energy153
        .byte #%11111111;$AE
        .byte #%11111111;$AE
        .byte #%11011111;$C2
        .byte #%11011111;$C2
        .byte #%11011111;$C2
        .byte #%10100100;$C2
        .byte #%01111011;$C2
        .byte #%01111011;$C2
        .byte #%11111111;$AE
        .byte #%11111111;$AE
Energy004
Energy014
Energy024
        .byte #%01111011;$AE
        .byte #%01111011;$AE
        .byte #%01111011;$C2
        .byte #%01111011;$C2
        .byte #%01110100;$C2
        .byte #%10001111;$C2
        .byte #%11101111;$C2
        .byte #%11101111;$C2
        .byte #%11101111;$AE
        .byte #%11101111;$AE

Energy034
        .byte #%01111111;$AE
        .byte #%01111111;$AE
        .byte #%01111011;$C2
        .byte #%01111011;$C2
        .byte #%01110100;$C2
        .byte #%10001111;$C2
        .byte #%11101111;$C2
        .byte #%11101111;$C2
        .byte #%11101111;$AE
        .byte #%11101111;$AE
Energy044
        .byte #%01111111;$AE
        .byte #%01111111;$AE
        .byte #%01111011;$C2
        .byte #%01111011;$C2
        .byte #%01110100;$C2
        .byte #%10001111;$C2
        .byte #%11101111;$C2
        .byte #%11101111;$C2
        .byte #%11111111;$AE
        .byte #%11111111;$AE
Energy054
Energy064
Energy074
Energy084
Energy094
Energy104
Energy114
Energy124
Energy134
Energy144
Energy154
        .byte #%11111111;$AE
        .byte #%11111111;$AE
        .byte #%01111011;$C2
        .byte #%01111011;$C2
        .byte #%01110100;$C2
        .byte #%10001111;$C2
        .byte #%11101111;$C2
        .byte #%11101111;$C2
        .byte #%11111111;$AE
        .byte #%11111111;$AE

Energy005
        .byte #%11110111;$AE
        .byte #%11110111;$AE
        .byte #%11110111;$C2
        .byte #%11110111;$C2
        .byte #%10001011;$C2
        .byte #%01111100;$C2
        .byte #%01111111;$C2
        .byte #%01111111;$C2
        .byte #%01111111;$AE
        .byte #%01111111;$AE
Energy015
        .byte #%11111111;$AE
        .byte #%11111111;$AE
        .byte #%11110111;$C2
        .byte #%11110111;$C2
        .byte #%10001011;$C2
        .byte #%01111100;$C2
        .byte #%01111111;$C2
        .byte #%01111111;$C2
        .byte #%01111111;$AE
        .byte #%01111111;$AE
Energy025
Energy035
Energy045
Energy055
Energy065
Energy075
Energy085
Energy095
Energy105
Energy115
Energy125
Energy135
Energy145
Energy155
        .byte #%11111111;$AE
        .byte #%11111111;$AE
        .byte #%11110111;$C2
        .byte #%11110111;$C2
        .byte #%10001011;$C2
        .byte #%01111100;$C2
        .byte #%01111111;$C2
        .byte #%01111111;$C2
        .byte #%11111111;$AE
        .byte #%11111111;$AE



;---End Graphics Data---


;---Color Data from PlayerPal 2600---

EnergyColor00
EnergyColor01
EnergyColor02
EnergyColor03
        .byte TURQUOISE+14
        .byte TURQUOISE+14
        .byte LIGHTSTRINGCOLOR
        .byte LIGHTSTRINGCOLOR
        .byte LIGHTSTRINGCOLOR
        .byte LIGHTSTRINGCOLOR
        .byte LIGHTSTRINGCOLOR
        .byte LIGHTSTRINGCOLOR
        .byte TURQUOISE+14
        .byte TURQUOISE+14
EnergyColor04
EnergyColor05
EnergyColor06
EnergyColor07
        .byte GOLD+12
        .byte GOLD+12
        .byte LIGHTSTRINGCOLOR
        .byte LIGHTSTRINGCOLOR
        .byte LIGHTSTRINGCOLOR
        .byte LIGHTSTRINGCOLOR
        .byte LIGHTSTRINGCOLOR
        .byte LIGHTSTRINGCOLOR
        .byte GOLD+12
        .byte GOLD+12
EnergyColor08
EnergyColor09
EnergyColor10
EnergyColor11
        .byte BURNTORANGE+10
        .byte BURNTORANGE+10
        .byte LIGHTSTRINGCOLOR
        .byte LIGHTSTRINGCOLOR
        .byte LIGHTSTRINGCOLOR
        .byte LIGHTSTRINGCOLOR
        .byte LIGHTSTRINGCOLOR
        .byte LIGHTSTRINGCOLOR
        .byte BURNTORANGE+10
        .byte BURNTORANGE+10
EnergyColor12
EnergyColor13
EnergyColor14
EnergyColor15
        .byte RED+4
        .byte RED+4
        .byte LIGHTSTRINGCOLOR
        .byte LIGHTSTRINGCOLOR
        .byte LIGHTSTRINGCOLOR
        .byte LIGHTSTRINGCOLOR
        .byte LIGHTSTRINGCOLOR
        .byte LIGHTSTRINGCOLOR
        .byte RED+4
        .byte RED+4

;   align 256



    align 256
Copyright1
        .byte #%10000011;--
        .byte #%01100101;--
        .byte #%01011101;--
        .byte #%01100101;--
        .byte #%10000011;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%00110111;--
        .byte #%01011111;--
        .byte #%00111111;--
        .byte #%01011111;--
        .byte #%00111111;--
        .byte #%11111111;--

Copyright2
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%01010111;--
        .byte #%01011111;--
        .byte #%01011111;--
        .byte #%01011111;--
        .byte #%00111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%01010001;--
        .byte #%01010101;--
        .byte #%01010101;--
        .byte #%00010101;--
        .byte #%01010001;--
        .byte #%11111111;--

Copyright3
        .byte #%10000001;--
        .byte #%11011111;--
        .byte #%11100011;--
        .byte #%10110001;--
        .byte #%11000011;--
        .byte #%11111111;--
        .byte #%00011011;--
        .byte #%11011011;--
        .byte #%00011011;--
        .byte #%01111011;--
        .byte #%00010001;--
        .byte #%11111111;--
        .byte #%11010101;--
        .byte #%11010101;--
        .byte #%11000101;--
        .byte #%11010101;--
        .byte #%11101100;--
        .byte #%11111111;--
        .byte #%01011011;--
        .byte #%01011011;--
        .byte #%01011011;--
        .byte #%01011011;--
        .byte #%00110001;--
        .byte #%11111111;--
Copyright4
        .byte #%11000011;--
        .byte #%10111001;--
        .byte #%10111001;--
        .byte #%10111001;--
        .byte #%11000011;--
        .byte #%11111111;--
        .byte #%01010001;--
        .byte #%01010101;--
        .byte #%00110101;--
        .byte #%01010101;--
        .byte #%00010101;--
        .byte #%11111111;--
        .byte #%01001111;--
        .byte #%01010111;--
        .byte #%01010111;--
        .byte #%01010111;--
        .byte #%11001111;--
        .byte #%11111111;--
        .byte #%10010001;--
        .byte #%01010101;--
        .byte #%01010101;--
        .byte #%01110101;--
        .byte #%10010001;--
        .byte #%11111111;--
Copyright5
        .byte #%11000011;--
        .byte #%10111001;--
        .byte #%10111001;--
        .byte #%10111001;--
        .byte #%11000011;--
        .byte #%11111111;--
        .byte #%01011111;--
        .byte #%01011111;--
        .byte #%01011111;--
        .byte #%00011111;--
        .byte #%01011111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%01010001;--
        .byte #%01010111;--
        .byte #%01010011;--
        .byte #%00010111;--
        .byte #%01010001;--
        .byte #%11111111;--
Copyright6
        .byte #%10000011;--
        .byte #%11110001;--
        .byte #%10000011;--
        .byte #%10111111;--
        .byte #%10000011;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%01011011;--
        .byte #%01011011;--
        .byte #%00111011;--
        .byte #%01010101;--
        .byte #%00110101;--
        .byte #%11111111;--

    align 256
SantaSleighBitmap1
        .byte #%11111011;--
        .byte #%11111101;--
        .byte #%11111110;--
        .byte #%11111110;--
        .byte #%11110010;--
        .byte #%11100000;--
        .byte #%11000000;--
        .byte #%10000000;--
        .byte #%00000000;--
        .byte #%11100000;--
        .byte #%10011000;--
        .byte #%10000100;--
        .byte #%10000010;--
        .byte #%11000001;--
        .byte #%11000000;--
        .byte #%11000001;--
        .byte #%11100011;--
        .byte #%11100111;--
        .byte #%10011110;--
        .byte #%11011010;--
        .byte #%11111100;--
        .byte #%11111100;--
        .byte #%11111110;--

        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--

SantaSleighBitmap2
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%01111111;--
        .byte #%10111111;--
        .byte #%11011111;--
        .byte #%11101111;--
        .byte #%01110111;--
        .byte #%00111011;--
        .byte #%00011101;--
        .byte #%00000000;--
        .byte #%00000111;--
        .byte #%00100111;--
        .byte #%01010011;--
        .byte #%10001011;--
        .byte #%00001010;--
        .byte #%00001011;--
        .byte #%00010111;--
        .byte #%00001111;--
        .byte #%00001111;--
        .byte #%01100000;--
        .byte #%01111111;--
        .byte #%11111111;--

        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--

SantaSleighBitmap3
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%01111111;--
        .byte #%01111111;--
        .byte #%01011111;--
        .byte #%01001111;--
        .byte #%11101111;--
        .byte #%11101111;--
        .byte #%11000111;--
        .byte #%11000011;--
        .byte #%11000000;--
        .byte #%00000010;--
        .byte #%11110011;--
        .byte #%11111001;--

        .byte #%11111010;--
        .byte #%11111011;--
        .byte #%11111001;--
        .byte #%11110001;--
        .byte #%11100111;--
        .byte #%11011011;--
        .byte #%11101111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--


SantaSleighBitmap4
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11011111;--
        .byte #%11001111;--
        .byte #%11101111;--
        .byte #%11101111;--


        .byte #%11000111;--
        .byte #%01000011;--
        .byte #%10000000;--
        .byte #%11100010;--
        .byte #%11110011;--
        .byte #%11111001;--
        .byte #%11111010;--
        .byte #%11111011;--
        .byte #%11111001;--
        .byte #%11110001;--
        .byte #%11100111;--
        .byte #%11011011;--
        .byte #%11101111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--

SantaSleighBitmap5
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--

        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11011111;--
        .byte #%11001111;--
        .byte #%11101111;--
        .byte #%11101111;--
        .byte #%11000111;--
        .byte #%01000011;--
        .byte #%10000000;--
        .byte #%11100010;--
        .byte #%11110011;--
        .byte #%11111001;--
        .byte #%11111010;--
        .byte #%11111011;--
        .byte #%11111001;--
        .byte #%11110001;--
        .byte #%11100111;--
        .byte #%11011011;--
        .byte #%11101111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--

    align 256

SantaSleighBitmap6

        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--

        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11111111;--
        .byte #%11011111;--
        .byte #%11001111;--
        .byte #%11101111;--
        .byte #%11101111;--
        .byte #%11000111;--
        .byte #%01000011;--
        .byte #%10000000;--
        .byte #%11100010;--
        .byte #%11110011;--
        .byte #%11111011;--
        .byte #%11111011;--
        .byte #%11111011;--
        .byte #%11111001;--
        .byte #%11110001;--
        .byte #%11100111;--
        .byte #%11011011;--
        .byte #%11101111;--


SantaSleighColor
    .byte GRAY+0,GRAY+0,GRAY+0,GRAY+0,GRAY+0,GRAY+0,GRAY+0,GRAY+0
    .byte GRAY+0,GRAY+0,GRAY+0,GRAY+0,GRAY+0,GRAY+0,GRAY+0,GRAY+0
    .byte GRAY+0,GRAY+0,GRAY+0,GRAY+0,GRAY+0,GRAY+0,GRAY+0,GRAY+0
    .byte GRAY+0,GRAY+0,GRAY+0,GRAY+0,GRAY+0,GRAY+0,GRAY+0,GRAY+0
    .byte GRAY+0,GRAY+0,GRAY+0,GRAY+0,GRAY+0,GRAY+0,GRAY+0,GRAY+0
    .byte GRAY+0,GRAY+0,GRAY+0,GRAY+0,GRAY+0,GRAY+0,GRAY+0,GRAY+0
Horizon3PF0Bank4
        .byte #%11110000
        .byte #%11110000
        .byte #%11110000
        .byte #%11110000
        .byte #%00110000
        .byte #%00110000
        .byte #%00110000
        .byte #%00110000
        .byte #%00110000
        .byte #%00110000
Horizon3PF1Bank4
        .byte #%11001111
        .byte #%11001111
        .byte #%11001111
        .byte #%11001111
        .byte #%11001111
        .byte #%11001111
        .byte #%11001110
        .byte #%00001110
        .byte #%00001110
        .byte #%00001110

Horizon3PF2Bank4
        .byte #%11111111
        .byte #%11111111
        .byte #%11111100
        .byte #%00111100
        .byte #%00111100
        .byte #%00000000
        .byte #%00000000
        .byte #%00000000
        .byte #%00000000
        .byte #%00000000



CopyrightColorTable
    .byte GRAY+14,GRAY+14,GRAY+14,GRAY+14,GRAY+14


ScoreColorTable
    .byte GRAY+14,GRAY+14,GRAY+14,GRAY+14
    .byte GRAY+14,GRAY+14,GRAY+14,GRAY+14


EnergyLookup0
    .word Energy150,Energy140,Energy130,Energy120,Energy110,Energy100
    .word Energy090,Energy080,Energy070,Energy060,Energy050,Energy040
    .word Energy030,Energy020,Energy010,Energy000
EnergyLookup1
    .word Energy151,Energy141,Energy131,Energy121,Energy111,Energy101
    .word Energy091,Energy081,Energy071,Energy061,Energy051,Energy041
    .word Energy031,Energy021,Energy011,Energy001
EnergyLookup2
    .word Energy152,Energy142,Energy132,Energy122,Energy112,Energy102
    .word Energy092,Energy082,Energy072,Energy062,Energy052,Energy042
    .word Energy032,Energy022,Energy012,Energy002
EnergyLookup3
    .word Energy153,Energy143,Energy133,Energy123,Energy113,Energy103
    .word Energy093,Energy083,Energy073,Energy063,Energy053,Energy043
    .word Energy033,Energy023,Energy013,Energy003
EnergyLookup4
    .word Energy154,Energy144,Energy134,Energy124,Energy114,Energy104
    .word Energy094,Energy084,Energy074,Energy064,Energy054,Energy044
    .word Energy034,Energy024,Energy014,Energy004
EnergyLookup5
    .word Energy155,Energy145,Energy135,Energy125,Energy115,Energy105
    .word Energy095,Energy085,Energy075,Energy065,Energy055,Energy045
    .word Energy035,Energy025,Energy015,Energy005
EnergyColorLookup
    .word EnergyColor12,EnergyColor13,EnergyColor14,EnergyColor15
    .word EnergyColor08,EnergyColor09,EnergyColor10,EnergyColor11
    .word EnergyColor04,EnergyColor05,EnergyColor06,EnergyColor07
    .word EnergyColor00,EnergyColor01,EnergyColor02,EnergyColor03


;---------------------------------------------------------
;---------------------------------------------------------
;---------------------------------------------------------



TitleDataTable
    .word TitleData0,TitleData1,TitleData2,TitleData3,TitleData4,TitleData5,TitleColorData
    .byte #LEVEL0BACKGROUNDCOLOR    ;--Player color



FloorColorTableBank4        ;has duplicate in bank 1
  IF TV_MODE = NTSC
    .byte GRAY+14,GRAY+12,GRAY+6,GRAY+0
  ELSE
        .byte GRAY+14,GRAY+12,GRAY+8,GRAY+0
  ENDIF

MoonFinalScreen
        .byte #%00000000;--
        .byte #%00011000;--
        .byte #%00111100;--
        .byte #%01110010;--
        .byte #%01100000;--
        .byte #%01100000;--
        .byte #%01100000;--
        .byte #%00110000;--
        .byte #%00011000;--

DigitDataIndex  ;index of low bytes (10 bytes)
    .byte <DigitZero,#<DigitOne,#<DigitTwo
    .byte #<DigitThree,#<DigitFour
    .byte #<DigitFive,#<DigitSix,#<DigitSeven
    .byte #<DigitEight,#<DigitNine

	.byte <HexA,<HexB,<HexC,<HexD,<HexE,<HexF

;---------------------------------------------------------
;---------------------------------------------------------
;---------------------------------------------------------
    org $4FBF
    rorg $FFBF
DisplaySantaAndReindeerInBank1
    sta $1FF6
    rts


       org $4FC8
        rorg $FFC8
    .byte 0,0,0     ;jmp HorizonKernelSubroutine
    .byte 0,0,0     ;$FFCB
    .byte 0,0,0     ;$FFCE
    .byte 0,0,0     ;$FFD1
    jmp FinalScreenKernel   ;$FFD4
    jmp GameOverScreenKernel
    jmp DisplayEnergyScoreSubroutine
    jmp TitleScreenKernel
    .byte 0,0,0 ;jmp MoveSkyItemSubroutine
    .byte 0,0,0 ;jmp ScrollHorizonObjectsSubroutine
    .byte 0,0,0 ;jmp Overscan
    .byte 0,0,0 ;jmp StartNewLevel
    .byte 0,0,0
SwitchToBank1FromBank4
        sta $1FF6                       ;$FFF2, $FFF3, $FFF4



    org $4FFC
    rorg $FFFC

    .word Start4
    .word Start4